/*
OuDiaSecond Copyright (C) 2017 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
// $Id: CdRessyasyubetsuYColSpecCont.cpp  $
// ****************************************************************
#include "stdafx.h"
#include "CdEkiTrack2YColSpecCont.h"

namespace ViewEkiTrack2 { namespace EkiTrack2ColSpec{

/// wb_̐
const int HEADER_COUNT = 1 ;	

	// ********************************
	//	RXgN^
	// ********************************
CdEkiTrack2YColSpecCont::CdEkiTrack2YColSpecCont(
		const CentDedEkiTrack2Cont* pCentDedEkiTrack2Cont )
	: m_iEkiTrack2Count( pCentDedEkiTrack2Cont->size() )
{
}
CdEkiTrack2YColSpecCont::CdEkiTrack2YColSpecCont()
	: m_iEkiTrack2Count( 0 )
{
}

	// ********************************
	//@name CdRessyasyubetsuYColSpec-
	// ********************************
int CdEkiTrack2YColSpecCont::getEkiTrack2Count()const
{	return m_iEkiTrack2Count ;};

	// ********************************
	//@name CWndJikokuhyou_CdXColSpecCont-
	// ********************************
void CdEkiTrack2YColSpecCont::scan(
		const CentDedEkiTrack2Cont* pCentDedEkiTrack2Cont )
{
	m_iEkiTrack2Count = pCentDedEkiTrack2Cont->size() ;
}

int CdEkiTrack2YColSpecCont::size()
{
	return m_iEkiTrack2Count + HEADER_COUNT + 1 ;	//	wb_ƐVKǉʒuZ
}

CdEkiTrack2YColSpec CdEkiTrack2YColSpecCont::ColumnNumberToSpec(
		int iColumnNumber ) 
{
	CdEkiTrack2YColSpec	aSpec ;
	
	//	wb_
	if ( iColumnNumber == 0 )
	{
		aSpec.set( CdEkiTrack2YColSpec::ColumnType_Head , -1 ) ;
	}
	//	Ԏʗ
	else if ( HEADER_COUNT <= iColumnNumber && 
		iColumnNumber < HEADER_COUNT + m_iEkiTrack2Count )
	{
		aSpec.set( CdEkiTrack2YColSpec::ColumnType_EkiTrack2, iColumnNumber - HEADER_COUNT ) ;
	}
	//	VKǉʒu
	else if ( iColumnNumber == HEADER_COUNT + m_iEkiTrack2Count )
	{
		aSpec.set( CdEkiTrack2YColSpec::ColumnType_NewEkiTrack2, m_iEkiTrack2Count ) ;
	}
	return aSpec ;
}

int CdEkiTrack2YColSpecCont::ColumnNumberFromSpec(
		const CdEkiTrack2YColSpec& aSpec )
{
	int iColumnNumber= -1 ;
	//	wb_ 
	if ( aSpec.getColumnType() == CdEkiTrack2YColSpec::ColumnType_Head )
	{
		iColumnNumber = 0 ;
	}
	//	Ԏʗ 
	else if ( aSpec.getColumnType() == 
		CdEkiTrack2YColSpec::ColumnType_EkiTrack2)
	{
		iColumnNumber = HEADER_COUNT + aSpec.getEkiTrack2Index() ;
	}
	//	VKǉʒu
	else if ( aSpec.getColumnType() == 
		CdEkiTrack2YColSpec::ColumnType_NewEkiTrack2)
	{
		iColumnNumber = HEADER_COUNT + m_iEkiTrack2Count ;
	}
	return iColumnNumber ;
}

void CdEkiTrack2YColSpecCont::clear()
{
	*this = CdEkiTrack2YColSpecCont() ;
};

} } //namespace EkiTrack2ColSpec namespace ViewEkiTrack2
