/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
// $Id: CdXColSpec.h 137 2012-10-07 06:42:01Z okm $
// ****************************************************************
/** @file */
#pragma once
#ifndef ViewJikokuhyou_CdXColSpec_h
#define ViewJikokuhyou_CdXColSpec_h

namespace ViewJikokuhyou{ namespace JikokuhyouColSpec{

/**
@brief
  \r[ CWndJikokuhyou ɂāAObhXɕ\
  ׂeLqAPf[^NXłB

  ̒l NULL Ԃ܂B
*/
class CdXColSpec
{
public:
	// ********************************
	//	Ci[^Cv
	// ********************************
	/** X̎ */
	enum EColumnType
	{
		/**	w */
		ColumnType_Ekimei = 0 ,
		/**	 */
		ColumnType_Chakuhatsu ,
		/**	 */
		ColumnType_Ressya ,
		/**	VKԒǉʒu */
		ColumnType_NewRessya ,

		/**	NULLԂ܂ */
		ColumnType_NULL = -1 
	};

private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/** X̎ */
	EColumnType	m_eColumnType ;
	
	/** 
		Index B
		m_eColumnType  ColumnType_Ressya ̏ꍇ́A
		0 ȏԖ{̗ Index \܂B

		̑̏ꍇ͈Ӗ܂B
		l -1 łB
		
		CdXColSpecCont::ColumnNumberToSpec() 
		߂lŁACdXColSpec::m_eColumnType == 
		ColumnType_NewRessya ̏ꍇA
		CdXColSpec::m_iRessyaIndex ͗Ԗ{
		Ȃ܂B
	*/
	int m_iRessyaIndex ;
	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************

	/**
	@param eColumnType 
		X̎ 
	@param iRessyaIndex 
		Index 
	*/
	CdXColSpec( 
		EColumnType eColumnType , 
		int iRessyaIndex ) 
		: m_eColumnType( eColumnType )
		, m_iRessyaIndex( iRessyaIndex ){}
	CdXColSpec( 
		EColumnType eColumnType ) 
		: m_eColumnType( eColumnType )
		, m_iRessyaIndex( -1 ){}

	CdXColSpec()
		: m_eColumnType( ColumnType_NULL ) 
		, m_iRessyaIndex( -1 ){}

public:
	// ********************************
	///@name CdXColSpec-
	// ********************************
	EColumnType	getColumnType()const{	return m_eColumnType ;};
	int getRessyaIndex()const{	return m_iRessyaIndex ;};

	/**
		lݒ肵܂B
	@param eColumnType 
		X̎ 
	@param iRessyaIndex 
		Index 
	*/
	void set( EColumnType eColumnType ,
		int iRessyaIndex ) 
	{
		m_eColumnType = eColumnType ;
		m_iRessyaIndex = iRessyaIndex ;
	}


	bool isNull()const{	return m_eColumnType == ColumnType_NULL ;};
	/* 
		this NULLԂɂ܂B
	*/
	void setNull(){	*this = CdXColSpec() ;};	

	/**
		̃IuWFNgƂ̊ԂŁAꂩۂ𔻒肵܂B
	@param value
		rΏۂw肵ĂB
	@return
		ł true 
	*/
	bool isEqualTo( const CdXColSpec& value )const
	{
		bool bRv = false ;
		if ( m_eColumnType == value.m_eColumnType )
		{
			//	ColumnType_Ressya ̏ꍇ́A
			//	m_iRessyaIndex ̈vKvƂ܂B
			if ( m_eColumnType == ColumnType_Ressya )
			{
				bRv = ( m_iRessyaIndex == value.m_iRessyaIndex ) ;
			}
			else
			{
				bRv = true ;
			}
		}
		return bRv ;
	}
	bool operator==(const CdXColSpec& value )const
	{	return isEqualTo( value ) ;}
	bool operator!=(const CdXColSpec& value )const
	{	return !isEqualTo( value ) ;}
};

} } //namespace JikokuhyouColSpec namespace ViewJikokuhyou

#endif /*ViewJikokuhyou_CdXColSpec_h*/
