/*
OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRessyaCont.cpp
//	$Id: CentDedRessyaCont.cpp 378 2016-11-16 21:10:54Z okm $
// ****************************************************************
*/
/** @file*/

#include "stdafx.h"
#include <algorithm>
#include "NsMu\CMup_deque.h"
#include "NsMu\CaMui.h"
#include "str\strtoint.h"
#include "logmsg\LogMsg.h"
#include "CentDedRosen.h"
#include "CentDedDiaCont.h"
#include "CentDedRessyaCont.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace entDed{
	using namespace std ;
	using namespace OuLib::Str ;
// ****************************************************************
//	CentDedRessyaCont
// ****************************************************************

// ********************************
//	RXgN^
// ********************************
CentDedRessyaCont::CentDedRessyaCont(
	ERessyahoukou eRessyahoukou )
	:
	 m_iEkiCount( 0 ) 
	, m_eRessyahoukou( eRessyahoukou )
{
}

CentDedRessyaCont::CentDedRessyaCont( 
		int iEkiCount ,
		ERessyahoukou eRessyahoukou )
	:
	 m_iEkiCount( iEkiCount ) 
	, m_eRessyahoukou( eRessyahoukou )
{
}


CentDedRessyaCont& CentDedRessyaCont::operator=( const CentDedRessyaCont& value )
{
	//	̃Rei CentDedDia ̎qIuWFNgłꍇA
	//	m_iEkiCount,m_iRessyasyubetsuCount,m_eRessyahoukou ͕ύXꂸAԂ
	//	Rs[܂B
	//	CentDedDia̎qłȂꍇ́ASRs[܂B
	if ( getDia() == NULL )
	{
		m_iEkiCount = value.m_iEkiCount ; 
		m_eRessyahoukou = value.m_eRessyahoukou ; 
	}

	//Ԃ̃Rs[
	super::operator =( value ) ;

	return *this ;
}

	// ********************************
	//@name Mui
	// ********************************

int CentDedRessyaCont::insert( const CentDedRessya& element , int iIndex ) 
{
	return super::insert( element , iIndex ) ;

}

int CentDedRessyaCont::set( const CentDedRessya& element , int iIndex ) 
{
	return super::set( element , iIndex ) ;
}

	// ********************************
	//@name CentDedRessyaCont-֘A
	// ********************************
CentDedRosen* CentDedRessyaCont::getRosen() 
{
	CentDedDia* pDia = getDia() ;
	if ( pDia == NULL ){	return NULL ;}
	CentDedDiaCont* pDiaCont = dynamic_cast<CentDedDiaCont*>( pDia->getParent() ) ;
	if ( pDiaCont == NULL ){	return NULL ;}
	return pDiaCont->getRosen() ;
}

const CentDedRosen* CentDedRessyaCont::getRosen()const 
{
	const CentDedDia* pDia = getDia() ;
	if ( pDia == NULL ){	return NULL ;}
	const CentDedDiaCont* pDiaCont = dynamic_cast<const CentDedDiaCont*>( pDia->getParent() ) ;
	if ( pDiaCont == NULL ){	return NULL ;}
	return pDiaCont->getRosen() ;
}


	// ********************************
	//@name CentDedRessyaCont-
	// ********************************
int CentDedRessyaCont::setable(  const CentDedRessya& element , int iIndex )const 
{
	return 0 ;
}

int  CentDedRessyaCont::getIndex( const CentDedRessya* element )const 
{
	const Mu<const CentDedRessya*>* pMu = getMuPtr() ;
	for ( int idx = 0 ; idx < pMu->size() ; idx ++ ){
		if ( pMu->get( idx ) == element ){	return idx ;}
	}
	return -1 ;

}

void CentDedRessyaCont::adjust() 
{
	CentDedRosen* pRosen = getRosen() ;
	if ( pRosen!= NULL )
	{
		m_iEkiCount = pRosen->getCentDedEkiCont()->size() ;
	}

	Mu<CentDedRessya*>* pMu = getMuPtr() ;
	for ( int idx = 0 ; idx < pMu->size() ; idx ++ ){
		pMu->get( idx )->adjust() ;
	}
}





int CentDedRessyaCont::EkiIndexOfEkiOrder( int iEkiOrder )const 
{
	int iRv = iEkiOrder ;
	if ( m_eRessyahoukou == Ressyahoukou_Nobori ){
		iRv = m_iEkiCount - 1 - iEkiOrder ;
	}
	return ( iRv ) ;
}

int CentDedRessyaCont::EkiOrderOfEkiIndex( int iEkiIndex )const 
{
	int iRv = iEkiIndex ;
	if ( m_eRessyahoukou == Ressyahoukou_Nobori ){
		iRv = m_iEkiCount - 1 - iEkiIndex ;
	}
	return ( iRv ) ;
}

int CentDedRessyaCont::findEkikanSaisyouSec( 
		int iEkiOrder , 
		int* pidxRessya )const 
{
	// --------------------------------
			int iSaisyouSyouSecTeisya = -1 ;
			//iSaisyouSyouSecTeisya = 
			//	iEkiiIndex E iEkiIndex + 1 ̗wɒԂԂ̂́A
			//	ŏwԏvb 
			int iSaisyouSyouSec = -1 ;
			//iSaisyouSyouSec = 
			//	iEkiiIndex E iEkiIndex + 1 ̍ŏwԏvb
			//	ЕE܂͗wʉ߉w̗Ԃ܂݂܂B

			int iSaisyouSyouSecTeisyaRessyaIdx = -1 ;
			//iSaisyouSyouSecTeisyaRessyaIdx = 
			//	iSaisyouSyouSecTeisya ɑΉIndex 
			int iSaisyouSyouSecRessyaIdx = -1 ;
			//iSaisyouSyouSecRessyaIdx = 
			//	iSaisyouSyouSec ɑΉIndex 
			
			const Mu<const CentDedRessya*>* pCentDedRessyaContGet =
				this->getMuPtr() ;
			if ( 0 <= iEkiOrder && iEkiOrder < this->getEkiCount() - 1 ){
				int iRessyaIndex = 0 ;
				for ( iRessyaIndex = 0 ; 
						iRessyaIndex < this->size() ; 
						iRessyaIndex ++ ){
					const CentDedRessya* pCentDedRessya = 
						pCentDedRessyaContGet->get( iRessyaIndex ) ;
					CentDedEkiJikoku aEkiJikokuCurr = 
						pCentDedRessya->getCentDedEkiJikoku( iEkiOrder ) ;
					CentDedEkiJikoku aEkiJikokuNext = 
						pCentDedRessya->getCentDedEkiJikoku( iEkiOrder + 1 ) ;

					CdDedJikoku	jikokuHatsu = 
						aEkiJikokuCurr.getHatsujikoku( true ) ;
					CdDedJikoku	jikokuChaku = 
						aEkiJikokuNext.getChakujikoku( true ) ;
					if ( !jikokuHatsu.isNull() && !jikokuChaku.isNull() ){
						int iSyoyouSec = jikokuChaku.subJikoku( jikokuHatsu ) ;
						if ( iSaisyouSyouSec == -1 || 
								iSaisyouSyouSec > iSyoyouSec ){
							iSaisyouSyouSec = iSyoyouSec ;
							iSaisyouSyouSecRessyaIdx = iRessyaIndex ;
						}
						
						if ( aEkiJikokuCurr.getEkiatsukai() == 
								CentDedEkiJikoku::Ekiatsukai_Teisya && 
							aEkiJikokuNext.getEkiatsukai() == 
								CentDedEkiJikoku::Ekiatsukai_Teisya ){
							if ( iSaisyouSyouSecTeisya == -1 || 
									iSaisyouSyouSecTeisya > iSyoyouSec ){
								iSaisyouSyouSecTeisya = iSyoyouSec ;
								iSaisyouSyouSecTeisyaRessyaIdx = iRessyaIndex ;
							}
						} 
					}
					
				}
			}
			LogMsg(_T("CentDedRessyaCont::findEkikanSaisyouSec( iEkiOrder=%d )")
				_T(" iSaisyouSyoyouSecTeisya=%d RessyaIdx=%d ")
					_T(" iSaisyouSyoyouSec=%d RessyaIdx=%d") ,
				iEkiOrder , 
				iSaisyouSyouSecTeisya ,
				iSaisyouSyouSecTeisyaRessyaIdx , 
				iSaisyouSyouSec ,
				iSaisyouSyouSecRessyaIdx ) ; 

			if ( iSaisyouSyouSecTeisya >= 0 ){
				iSaisyouSyouSec = iSaisyouSyouSecTeisya ;
				iSaisyouSyouSecRessyaIdx = iSaisyouSyouSecTeisyaRessyaIdx ;
			}
			if ( iSaisyouSyouSec < 0 ){
					iSaisyouSyouSec = 0 ;
			}
			// --------------------------------
			if ( pidxRessya != NULL ){
				*pidxRessya = iSaisyouSyouSecRessyaIdx ;
			}
			return ( iSaisyouSyouSec ) ;

}




int CentDedRessyaCont::findTrainToDirect(
		int idxRessya , 
		int iEkiOrder  )const 
{
	const CentDedRessya* pCentDedRessyaSyuuchaku = getMuPtr()->get( idxRessya ) ;
	CdDedJikoku jikokuSyuuchaku ;
	{
		int iEkiOrderSyuuchaku = pCentDedRessyaSyuuchaku->getRunLastEkiOrder() ;
		jikokuSyuuchaku = pCentDedRessyaSyuuchaku->getCentDedEkiJikoku( iEkiOrderSyuuchaku ).getChakujikoku( true ) ;
	}
	//jikokuSyuuchaku = thisԂ̏Iw̒iNULL̏ꍇ܂j

	int iRv = -1 ;
	for ( idxRessya ++ ; iRv == -1 && idxRessya  < getMuPtr()->size() ; idxRessya ++ )
	{
		const CentDedRessya* pCentDedRessyaSihatsu = getMuPtr()->get( idxRessya ) ;
		//	  - EtH[JX̂(rw~܂̗)ƓԎ
		if ( pCentDedRessyaSyuuchaku->getRessyasyubetsuIndex() == 
			pCentDedRessyaSihatsu->getRessyasyubetsuIndex() )
		{
			//	  - EtH[JX̂wnwƂ
			if ( iEkiOrder == pCentDedRessyaSihatsu->getRunFirstEkiOrder() )
			{
				//	  - EIԂ̒nw̔w肳Ăꍇ́A
				//	  - Enw̔AIԂ̒12Ԉȓ
				//	  - EIԂ̒Enw̔̂ǂ炩Ăꍇ́A
				//		ɒʉ̑ΏۂƂȂ܂B
				CdDedJikoku jikokuSihatsu = pCentDedRessyaSihatsu->getCentDedEkiJikoku( iEkiOrder ).getHatsujikoku( true ) ;
				if ( !jikokuSyuuchaku.isNull() && !jikokuSihatsu.isNull() )
				{
					CdDedJikan aJikan = jikokuSihatsu.subJikoku( jikokuSyuuchaku ) ;
					if ( CdDedJikan() <= aJikan )
					{
						iRv = idxRessya ;
					} 
				}
				else
				{
					//	  - Enw̔AIԂ̒12Ԉȓ
					iRv = idxRessya ;
				}
			}
		}
	}
	return iRv ;
}

void CentDedRessyaCont::adjustByEkijikokukeisiki(
		int iEkiOrder ,
		bool bChakujikokuHyouji , bool bHatsujikokuHyouji ) 
{
	for ( int idxRessya = 0 ; idxRessya < size() ; idxRessya ++ )
	{
		CentDedRessya* pRessya = getMuPtr()->get( idxRessya ) ;
		pRessya->adjustByEkijikokukeisiki( 
			iEkiOrder ,
			bChakujikokuHyouji , bHatsujikokuHyouji ) ;
	}
}

	// ********************************
	//@name CentDedRessyaCont-wEԎʐ̕ύX
	// ********************************


int CentDedRessyaCont::isExistRessyaOfRessyasyubetsu( 
		int iRessyasyubetsuIndex ,
		int* piRessyaIndex )
{
	int iRv = 0 ;
	Mu< CentDedRessya* >* pCentDedRessyaContGet = getMuPtr() ;
	int iRessyaIndexFound = -1 ;
	if ( iRv >= 0 ){
	
				Mu< CentDedRessya* >* pCentDedRessyaContGet = getMuPtr() ;
				int iRessyaCount = pCentDedRessyaContGet->size() ;

				int iRessyaIndex ;
				for ( iRessyaIndex = 0 ; 
						iRv == 0 && iRessyaIndex < iRessyaCount ; 
						iRessyaIndex ++ ){
					CentDedRessya*	pCentDedRessya = pCentDedRessyaContGet->get( iRessyaIndex ) ;
					
					int iRessyasyubetsuIndexCurr = pCentDedRessya->getRessyasyubetsuIndex() ;
					// --------------------------------
					if ( iRessyasyubetsuIndexCurr == iRessyasyubetsuIndex ){
						iRessyaIndexFound = iRessyaIndex ;
						iRv = 1 ;	//	w̗Ԏʂ̗Ԃ݂܂B
					}
				}
	}
	// --------------------------------
	if ( iRv == 1 ){
		if ( piRessyaIndex != NULL ){
			*piRessyaIndex = iRessyaIndexFound ;
		}
	}
	
	return ( iRv ) ;
}

int CentDedRessyaCont::isExistRessyaOfEkiTrack2(
	int iEkiOrder,
	int iEkiTrack2Index,
	int* piRessyaIndex)
{
	int iRv = 0;
	Mu< CentDedRessya* >* pCentDedRessyaContGet = getMuPtr();
	int iRessyaIndexFound = -1;
	if (iRv >= 0) {

		Mu< CentDedRessya* >* pCentDedRessyaContGet = getMuPtr();
		int iRessyaCount = pCentDedRessyaContGet->size();

		int iRessyaIndex;
		for (iRessyaIndex = 0;
			iRv == 0 && iRessyaIndex < iRessyaCount;
			iRessyaIndex++) {
			CentDedRessya*	pCentDedRessya = pCentDedRessyaContGet->get(iRessyaIndex);

			iRv = pCentDedRessya->isExistRessyaOfEkiTrack2(
				iEkiOrder, iEkiTrack2Index);
			//int iRessyasyubetsuIndexCurr = pCentDedRessya->getRessyasyubetsuIndex();
			// --------------------------------
			if (iRv == 1) {
			//if (iRessyasyubetsuIndexCurr == iRessyasyubetsuIndex) {
				iRessyaIndexFound = iRessyaIndex;
			//	iRv = 1;	//	w̗Ԏʂ̗Ԃ݂܂B
			}
		}
	}
	// --------------------------------
	if (iRv == 1) {
		if (piRessyaIndex != NULL) {
			*piRessyaIndex = iRessyaIndexFound;
		}
	}

	return (iRv);
}

int CentDedRessyaCont::isExistRessyaOfOuterTerminal(
	int iEkiOrder,
	int iOuterTerminalIndex,
	int* piRessyaIndex)
{
	int iRv = 0;
	Mu< CentDedRessya* >* pCentDedRessyaContGet = getMuPtr();
	int iRessyaIndexFound = -1;
	if (iRv >= 0) {

		Mu< CentDedRessya* >* pCentDedRessyaContGet = getMuPtr();
		int iRessyaCount = pCentDedRessyaContGet->size();

		int iRessyaIndex;
		for (iRessyaIndex = 0;
			iRv == 0 && iRessyaIndex < iRessyaCount;
			iRessyaIndex++) {
			CentDedRessya*	pCentDedRessya = pCentDedRessyaContGet->get(iRessyaIndex);

			iRv = pCentDedRessya->isExistRessyaOfOuterTerminal(
				iEkiOrder, iOuterTerminalIndex);
			//int iRessyasyubetsuIndexCurr = pCentDedRessya->getRessyasyubetsuIndex();
			// --------------------------------
			if (iRv == 1) {
				//if (iRessyasyubetsuIndexCurr == iRessyasyubetsuIndex) {
				iRessyaIndexFound = iRessyaIndex;
				//	iRv = 1;	//	w̗Ԏʂ̗Ԃ݂܂B
			}
		}
	}
	// --------------------------------
	if (iRv == 1) {
		if (piRessyaIndex != NULL) {
			*piRessyaIndex = iRessyaIndexFound;
		}
	}

	return (iRv);
}

	// ********************************
	//@name CentDedRosen-qIuWFNg̑̒ʒm
	// ********************************
void CentDedRessyaCont::onEkiInsert( int iEkiOrder )
{
	m_iEkiCount ++ ;
	Mu<CentDedRessya*>* muRessya = getMuPtr() ;
	for ( int i = 0 ; i < muRessya->size() ; i++ )
	{
		muRessya->get( i )->onEkiInsert( iEkiOrder ) ;
	}
}

void CentDedRessyaCont::onEkiErase( int iEkiOrder  )
{
	Mu<CentDedRessya*>* muRessya = getMuPtr() ;
	for ( int i = 0 ; i < muRessya->size() ; i++ )
	{
		muRessya->get( i )->onEkiErase( iEkiOrder ) ;
	}
	m_iEkiCount -- ;
}

void CentDedRessyaCont::onEkiTrack2Insert(int iEkiOrder, int iEkiTrack2Index)
{
	Mu<CentDedRessya*>* muRessya = getMuPtr();
	for (int i = 0; i < muRessya->size(); i++)
	{
		muRessya->get(i)->onEkiTrack2Insert(iEkiOrder, iEkiTrack2Index);
	}
}
void CentDedRessyaCont::onEkiTrack2Erase(int iEkiOrder, int iEkiTrack2Index)
{
	Mu<CentDedRessya*>* muRessya = getMuPtr();
	for (int i = 0; i < muRessya->size(); i++)
	{
		muRessya->get(i)->onEkiTrack2Erase(iEkiOrder, iEkiTrack2Index);
	}
}

void CentDedRessyaCont::onRessyasyubetsuInsert( int iRessyasyubetsuIndex )
{
	Mu<CentDedRessya*>* muRessya = getMuPtr() ;
	for ( int i = 0 ; i < muRessya->size() ; i++ )
	{
		muRessya->get( i )->onRessyasyubetsuInsert( iRessyasyubetsuIndex ) ;
	}
}
void CentDedRessyaCont::onRessyasyubetsuErase( int iRessyasyubetsuIndex )
{
	Mu<CentDedRessya*>* muRessya = getMuPtr() ;
	for ( int i = 0 ; i < muRessya->size() ; i++ )
	{
		muRessya->get( i )->onRessyasyubetsuErase( iRessyasyubetsuIndex ) ;
	}

}

void CentDedRessyaCont::adjustBrunchLoopByBrunchEdit(
	int iEkiOrder, bool bOriginSide, 
	deque<int>& iEkiOrderBrunchOriginSide,
	deque<int>& iEkiOrderLoop, deque<int>& iEkiOrderBrunchTerminalSide)
{
	Mu<CentDedRessya*>* muRessya = getMuPtr();
	for (int i = 0; i < muRessya->size(); i++)
	{
		muRessya->get(i)->adjustBrunchLoopByBrunchEdit(iEkiOrder, bOriginSide,
			iEkiOrderBrunchOriginSide, iEkiOrderLoop, iEkiOrderBrunchTerminalSide);
	}
}

void CentDedRessyaCont::adjustBrunchLoopByLoopEdit(
	int iEkiOrder, int iPosition,
	deque<int>& iEkiOrderBrunchOriginSide,
	deque<int>& iEkiOrderLoop, 
	deque<int>& iEkiOrderBrunchTerminalSide)
{
	Mu<CentDedRessya*>* muRessya = getMuPtr();
	for (int i = 0; i < muRessya->size(); i++)
	{
		muRessya->get(i)->adjustBrunchLoopByLoopEdit(
			iEkiOrder, iPosition,
			iEkiOrderBrunchOriginSide, iEkiOrderLoop,
			iEkiOrderBrunchTerminalSide);
	}
}

void CentDedRessyaCont::adjustBrunchLoopEkiTrack2(
	const deque<int>& iEkiOrderBrunchLoop, 
	const std::vector<int>& iEkiTrack2Map)
{
	Mu<CentDedRessya*>* muRessya = getMuPtr();
	for (int i = 0; i < muRessya->size(); i++)
	{
		muRessya->get(i)->adjustBrunchLoopEkiTrack2(
			iEkiOrderBrunchLoop,
			iEkiTrack2Map);
	}
}

void CentDedRessyaCont::adjustBrunchLoopOuterTerminal(
	const int iEkiOrder,
	const std::vector<int>& iOuterTerminalEkimeiMap)
{
	Mu<CentDedRessya*>* muRessya = getMuPtr();
	for (int i = 0; i < muRessya->size(); i++)
	{
		muRessya->get(i)->adjustBrunchLoopOuterTerminal(
			iEkiOrder,
			iOuterTerminalEkimeiMap);
	}
}


} //namespace entDed
