/*
OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedDgrDia.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include "CentDedDgrEki.h"
#include "CentDedDgrRessya.h"
#include "CentDedDgrDia.h"
#include "DcdCd\Pos\CLineFunc.h"
#include "logmsg/LogMsg.h"
#include <deque>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


namespace entDgr{
using namespace std ;

// ****************************************************************
//	CentDedDgrDia
// ****************************************************************
// --------------------------------
//@name readCentDedRosen() ̉֐
// --------------------------------
CentDedDgrEki::EDiagramRessyajouhouHyouji 
CentDedDgrDia::CentDedEki_to_CentDedDgrEki_EDiagramRessyajouhouHyouji( 
	CentDedEki::EDiagramRessyajouhouHyouji eValue )
{
	CentDedDgrEki::EDiagramRessyajouhouHyouji eRessyajouhouHyouji = 
		CentDedDgrEki::DiagramRessyajouhouHyouji_Origin ;
	switch( eValue )
	{
	case CentDedEki::DiagramRessyajouhouHyouji_Anytime:
		eRessyajouhouHyouji = CentDedDgrEki::DiagramRessyajouhouHyouji_Anytime ;
		break ;
	case CentDedEki::DiagramRessyajouhouHyouji_Not:
		eRessyajouhouHyouji = CentDedDgrEki::DiagramRessyajouhouHyouji_Not ;
		break ;
	}
	return eRessyajouhouHyouji ;
}

	/*
		readCentDedRosen() ̉֐łB
		(1)CentDedDgrDiȃݒ
	*/
void CentDedDgrDia::readCentDedRosen_01_updateCentDedDgrDiaProp(
		const CentDedRosen* pCentDedRosen ,
		const CentDedDia* pCentDedDia ) 
{
	m_strName = pCentDedDia->getName() ;
	m_iDgrXPosMin = pCentDedRosen->getKitenJikoku().getTotalSeconds() ;
	m_iDgrYSizeEkikanDefault = pCentDedRosen->getDiagramDgrYZahyouKyoriDefault() ;
	m_bEnableOperation = pCentDedRosen->getEnableOperation();
}

void CentDedDgrDia::readCentDedRosen_02_updateEkiCont(
		const CentDedEkiCont* pCentDedEkiCont,
		//const Mu< const CentDedEki* >* pCentDedEkiCont , 
		const CentDedDia* pCentDedDia ) 
{
	LogMsg(_T("CentDedDgrDia::readCentDedRosen_updateEkiCont()") );

	int iRv = 0 ;
	// --------------------------------
	//	܂ł
	//	w_COwx
	//	w_COԁx
	//	IuWFNg͔j܂B
	// --------------------------------
	if ( iRv >= 0 )
	{
		m_CentDedDgrEkiCont.erase( 0 , INT_MAX ) ;
		m_CentDedDgrRessyaCont[0].erase( 0 , INT_MAX ) ;
		m_CentDedDgrRessyaCont[1].erase( 0 , INT_MAX ) ;
	}

	// --------------------------------
	//	eẃw_COwx
	//	IuWFNg𐶐
	// --------------------------------
	int iEkiIndex = 0 ;
	for ( iEkiIndex = 0 ; 
			iRv >= 0 && iEkiIndex < pCentDedEkiCont->size() ;
			iEkiIndex ++ )
	{
		LogMsg(_T("\tEkiIndex[%d]%s") ,
			iEkiIndex , 
			pCentDedEkiCont->getMuPtr()->get( iEkiIndex )->getEkimei().c_str() ) ;
		// --------------------------------
		//	Ԃ̌(I_͏)
		// --------------------------------
		int iEkikanSaisyouSecKudari = 0 ;
		{
			const CentDedRessyaCont* pCentDedRessyaCont = 
					pCentDedDia->getCentDedRessyaCont( Ressyahoukou_Kudari ) ;
			int iEkiOrder = pCentDedRessyaCont->EkiOrderOfEkiIndex(	iEkiIndex ) ;
			if ( 0 <= iEkiOrder && iEkiOrder < pCentDedEkiCont->size() - 1 )
			{
				iEkikanSaisyouSecKudari = 
					pCentDedRessyaCont->findEkikanSaisyouSec( 
						iEkiOrder , NULL ) ;
			}
		}
		// --------------------------------
		//	Ԃ̌(I_͏)
		// --------------------------------
		int iEkikanSaisyouSecNobori = 0 ;

		{
			const CentDedRessyaCont* pCentDedRessyaCont = 
					pCentDedDia->getCentDedRessyaCont( Ressyahoukou_Nobori ) ;
			int iEkiOrder = pCentDedRessyaCont->EkiOrderOfEkiIndex(	iEkiIndex ) - 1 ;
			if ( 0 <= iEkiOrder && iEkiOrder < pCentDedEkiCont->size() - 1 )
			{
				iEkikanSaisyouSecNobori = 
					pCentDedRessyaCont->findEkikanSaisyouSec( 
						iEkiOrder , NULL ) ;
			}
		}

		// --------------------------------
		LogMsg(_T("\tiEkikanSaisyouSecKudari=%d iEkikanSaisyouSecNobori=%d") ,
			iEkikanSaisyouSecKudari , iEkikanSaisyouSecNobori ) ;

		const CentDedEki* pCentDedEki = pCentDedEkiCont->getMuPtr()->get( iEkiIndex ) ;

		//b菈uƂāArw̏E蒅̏ꍇAOɕhwĂAݐ\\
		int iDiagramTrackDisplay = 0;
		if (pCentDedEki->getDiagramTrackDisplay() &&
			pCentDedEki->getEkikibo() == CentDedEki::Ekikibo_Syuyou)
		{
			if (pCentDedEki->getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsuchaku)
			{
				iDiagramTrackDisplay = 1;
			}
			else if (pCentDedEki->getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_KudariChaku)
			{
				//if (iEkiIndex == pCentDedEkiCont->size() - 1)
				//{
					iDiagramTrackDisplay = 2;
				//}
				//else {
				//	const CentDedEki* pCentDedEkiNext = pCentDedEkiCont->get(iEkiIndex+1);
				//	if (pCentDedEkiNext->getBrunchCoreEkiIndex() >= 0)
				//	{
				//		iDiagramTrackDisplay = 2;
				//	}
				//}
			}
			else if (pCentDedEki->getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_NoboriChaku)
			{
				//if (iEkiIndex == 0)
				//{
					iDiagramTrackDisplay = 3;
				//}
				//else {
				//	const CentDedEki* pCentDedEkiPrev = pCentDedEkiCont->get(iEkiIndex - 1);
				//	if (pCentDedEkiPrev->getBrunchCoreEkiIndex() >= 0)
				//	{
				//		iDiagramTrackDisplay = 3;
				//	}
				//}
			}
		}
		//bLoopOpposite𓱏oB
		//(1)蒅w̏ꍇAI_ɂ̉wN_wƂw݂邩𒲂ׂA
		//	݂ꍇ́Aw̏ꍇ́Ảw(I_w)LoopOppositê܂܂̉wLoopOppositeɂȂA
		//	w蒅̏ꍇ́ẢwLoopOppositeɈ˂炸ẢwLoopOppositefalseɂȂB
		//(2)蒅w̏ꍇALoopOppositê܂܂̉wLoopOppositeɂȂB
		//	(ɂ́ẢwI_wł邱Ƃ`FbNKv͂邪AI_wł͂Ȃꍇ́ALoopOppositefalseȂ̂ŏȗ)
		//(3)ȊȌꍇALoopOpposite͏falseɂȂBwŏI_wLoopOppositetruȅꍇłAłfalseɂȂB
		bool bLoopOpposite = false;
		if (pCentDedEki->getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_NoboriChaku)
		{
			for (int idx = iEkiIndex+1; idx < pCentDedEkiCont->size(); idx++)
			{
				if (pCentDedEkiCont->getMuPtr()->get(idx)->getLoopOriginEkiIndex() == iEkiIndex)
				{
					if (pCentDedEkiCont->getMuPtr()->get(idx)->getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsuchaku)
					{
						bLoopOpposite = pCentDedEkiCont->getMuPtr()->get(idx)->getLoopOpposite();
					}
					break;
				}
			}
		}
		else if (pCentDedEki->getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_KudariChaku)
		{
			bLoopOpposite = pCentDedEki->getLoopOpposite();
		}
		//bIncludeOppositéAEݒŌqĂw̒ɁABrunchOpposite܂LoopOpposite
		//Truẻw܂܂Ă邩ǂlłB
		//oς݂iDiagramTrackDisplay1ȏ(ݐ\\w)̏ꍇ̂ݗLȒlłB
		bool bIncludeOpposite = false;
		if (iDiagramTrackDisplay > 0)
		{
			deque<int> iEkiIndexBrunchOriginSide;
			deque<int> iEkiIndexLoop;
			deque<int> iEkiIndexBrunchTerminalSide;
			int iResult = pCentDedEkiCont->getEkiIndexBrunchLoop(
				iEkiIndex,
				iEkiIndexBrunchOriginSide,
				iEkiIndexLoop,
				iEkiIndexBrunchTerminalSide);
			//ݐ\\wiResult́A-1(PƉw)0ȏ̂ꂩłB
			//INT_MINAINT_MAX(hw)ɂ͂Ȃ܂B
			if (iResult != -1)
			{
				//iEkiIndexBrunchOriginSideyiEkiIndexBrunchTerminalSidẻwBrunchOppositetrue
				//̉wAbIncludeOppositetrueɂ܂B
				//ł΁Aȏ̒T͕svłB
				for (int idxo = 0; idxo < (int)iEkiIndexBrunchOriginSide.size(); idxo++)
				{
					if (pCentDedEkiCont->getMuPtr()->get(iEkiIndexBrunchOriginSide[idxo])
						->getBrunchOpposite())
					{
						bIncludeOpposite = true;
						break;
					}
				}
				for (int idxt = 0;
					idxt < (int)iEkiIndexBrunchTerminalSide.size() && !bIncludeOpposite; idxt++)
				{
					if (pCentDedEkiCont->getMuPtr()->get(iEkiIndexBrunchTerminalSide[idxt])
						->getBrunchOpposite())
					{
						bIncludeOpposite = true;
						break;
					}
				}
				//iEkiIndexLoopɒlȏ゠Ƃ́A̂ŁA
				//ƂI_̉w(iEkiIndexLoop.back())LoopOppositemFA
				//truȅꍇbIncludeOppositetrueɂ܂B
				if (iEkiIndexLoop.size() >= 2 && !bIncludeOpposite)
				{
					if (pCentDedEkiCont->getMuPtr()->get(iEkiIndexLoop.back())
						->getLoopOpposite())
					{
						bIncludeOpposite = true;
					}
				}
				//iEkiIndexLoopɒlOȏ゠Ƃ́A2ȏ゠̂ŁA
				//iEkiIndexLoop2Ԗڂ̉w(ԋN_̊̏I_w)LoopOppositemFA
				//truȅꍇbIncludeOppositetrueɂ܂B
				if (iEkiIndexLoop.size() >= 3 && !bIncludeOpposite)
				{
					if (pCentDedEkiCont->getMuPtr()->get(iEkiIndexLoop[1])
						->getLoopOpposite())
					{
						bIncludeOpposite = true;
					}
				}
			}
		}
		CentDedDgrEki	aCentDedDgrEki( 
			pCentDedEki->getEkimei() , 
			pCentDedEki->getEkikibo() == 
				CentDedEki::Ekikibo_Syuyou , 
			iEkikanSaisyouSecKudari , iEkikanSaisyouSecNobori , 
			m_iDgrYSizeEkikanDefault ,
			CentDedEki_to_CentDedDgrEki_EDiagramRessyajouhouHyouji( 
				pCentDedEki->getDiagramRessyajouhouHyoujiKudari() ) , 
			CentDedEki_to_CentDedDgrEki_EDiagramRessyajouhouHyouji(
				pCentDedEki->getDiagramRessyajouhouHyoujiNobori() ) ,
			pCentDedEki->getDownMain(),
			pCentDedEki->getUpMain(),
			pCentDedEki->getBrunchCoreEkiIndex(),
			pCentDedEki->getBrunchOpposite(),
			pCentDedEki->getLoopOriginEkiIndex(),
			bLoopOpposite,
			iDiagramTrackDisplay,
			pCentDedEki->getOuterTerminalEkimeiCont(),
			pCentDedEki->getEkiTrack2Cont(),
			bIncludeOpposite
		) ;

		m_CentDedDgrEkiCont.insert( aCentDedDgrEki ) ;


	}

	
	LogMsg(_T("CentDedDgrDia::readCentDedRosen_updateEkiCont()=")  )  ;
	
}

void CentDedDgrDia::readCentDedRosen_06_updateEkiContForOperation(
	const Mu<const CentDedEki*>* pCentDedEkiCont, 
	const CentDedDia * pCentDedDia)
{
	Mu<CentDedDgrEki*>* pCentDedDgrEkiCont = getCentDedDgrEkiCont()->getMuPtr();

	//N_wݐ\\̏ꍇ́A
	//^p@\LA܂ԂȐAo}[NA^pԍ\LXy[XƂāAftHgwԂ2{̃Xy[X݂܂
	//^p@\Ao}[N\LXy[XƂāAftHgwԂ̃Xy[X݂܂
	CentDedDgrEki* pCentDedDgrEkiKiten = pCentDedDgrEkiCont->get(0);
	if (pCentDedDgrEkiKiten->getDiagramTrackDisplay() == 0)
	{
		if (getEnableOperation())
		{
			pCentDedDgrEkiKiten->setEkiTrackDisplaySpace(getDgrYSizeEkikanDefault() * 2);
		}
		else
		{
			pCentDedDgrEkiKiten->setEkiTrackDisplaySpace(getDgrYSizeEkikanDefault());
		}
	}

	//rwŉ蒅蒅̕т̉wꍇAǂ炩ݐ\\ȂA
	//wԋAftHgl2{ɂ܂
	for (int idx = 1; idx < pCentDedDgrEkiCont->size() - 1 && getEnableOperation(); idx++)
	{
		//CentDedDgrEki* pCentDedDgrEki = pCentDedDgrEkiCont->get(idx);
		//if (pCentDedDgrEki->getDiagramTrackDisplay() != 0)
		//{
		//	continue;
		//}
		const CentDedEki* pCentDedEki = pCentDedEkiCont->get(idx);
		if (pCentDedEki->getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_KudariChaku)
		{
			const CentDedEki* pCentDedEkiNext = pCentDedEkiCont->get(idx + 1);
			if (pCentDedEkiNext->getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_NoboriChaku)
			{
				if (!pCentDedEki->getDiagramTrackDisplay() ||
					!pCentDedEkiNext->getDiagramTrackDisplay())
				{
					pCentDedDgrEkiCont->get(idx)->setDgrYSizeEkikanDefault(getDgrYSizeEkikanDefault() * 2);
				}
			}
		}
	}

	//I_wݐ\\̏ꍇ́A
	//^p@\LA܂ԂȐAo}[NA^pԍ\LXy[XƂāAftHgwԂ2{̃Xy[X݂܂
	//^p@\Ao}[N\LXy[XƂāAftHgwԂ̃Xy[X݂܂
	CentDedDgrEki* pCentDedDgrEkiSyuuten = pCentDedDgrEkiCont->get(INT_MAX);
	if (pCentDedDgrEkiSyuuten->getDiagramTrackDisplay() == 0)
	{
		if (getEnableOperation())
		{
			pCentDedDgrEkiSyuuten->setEkiTrackDisplaySpace(getDgrYSizeEkikanDefault() * 2);
		}
		else
		{
			pCentDedDgrEkiSyuuten->setEkiTrackDisplaySpace(getDgrYSizeEkikanDefault());
		}
	}

}

void CentDedDgrDia::readCentDedRosen_03_updateMuRessyasyubetsu(
		const Mu< const CentDedRessyasyubetsu* >* pMuRessyasyubetsu ) 
{
	// --------------------------------
	//	wԎʁxIuWFNgj
	// --------------------------------
	m_MuCentDedDgrRessyasyubetsu.erase( 0 , INT_MAX ) ;

	// --------------------------------
	//	wԎʁxIuWFNg
	//	
	// --------------------------------
	for ( int idx = 0 ; idx < pMuRessyasyubetsu->size() ; idx ++ )
	{
		const CentDedRessyasyubetsu* pCentDedRessyasyubetsu = 
			pMuRessyasyubetsu->get( idx ) ;
		CentDedDgrRessyasyubetsu	aCentDedDgrRessyasyubetsu( 
			pCentDedRessyasyubetsu->getJikokuhyouMojiColor() ,
			pCentDedRessyasyubetsu->getCdDiagramLineStyle() ,
			pCentDedRessyasyubetsu->getStopMarkDrawType() ,
			pCentDedRessyasyubetsu->getParentSyubetsuIndex()) ;
		m_MuCentDedDgrRessyasyubetsu.insert( aCentDedDgrRessyasyubetsu ) ;
	}
}

void CentDedDgrDia::readCentDedRosen_04_updateRessyaCont( 
		const CentDedRosen* pCentDedRosen , 
		const CentDedDia* pCentDedDia,
		bool bSimplifyRead )
{
	LogMsg(_T("CentDedDgrDia::readCentDedRosen_updateRessyaCont()") )  ;


	// --------------------------------
	//	eԂ́w_COԁxIuWFNg
	//	
	// --------------------------------
	for ( int iRessyahoukou = Ressyahoukou_Kudari ;
			iRessyahoukou <= Ressyahoukou_Nobori ; 
			iRessyahoukou ++ )
	
	{
		ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
	
		const CentDedRessyaCont* pCentDedRessyaCont = 
			pCentDedDia->getCentDedRessyaCont( eRessyahoukou ) ;
		const Mu<const CentDedRessya*>* pCentDedRessyaContGet = 
			pCentDedDia->getCentDedRessyaCont( eRessyahoukou )->getMuPtr() ;

		Mui< CentDedDgrRessya >*	pCentDedDgrRessyaCont = 
			getCentDedDgrRessyaCont( eRessyahoukou ) ;
		
		// --------------------------------
		//	ԂUNA
		// --------------------------------
		pCentDedDgrRessyaCont->erase( 0 , INT_MAX );
		
		// --------------------------------
		//	ԃIuWFNg𐶐Eǉ
		// --------------------------------
		bool bWaitOperationUpdate = pCentDedDia->getWaitOperationUpdate();
		int iSize = pCentDedRessyaContGet->size();
#pragma omp parallel for ordered schedule(dynamic) 
		for ( int iRessyaIdx = 0 ; 
				iRessyaIdx < iSize ;
				iRessyaIdx ++ )
		{
			const CentDedRessya* pCentDedRessya = pCentDedRessyaContGet->get( iRessyaIdx ) ;
			CentDedDgrRessya	aCentDedDgrRessya(
				pCentDedRosen, pCentDedDia,
				this, pCentDedRessya, bSimplifyRead, bWaitOperationUpdate);

#pragma omp ordered 	
			pCentDedDgrRessyaCont->insert( aCentDedDgrRessya ) ;
		}
		
	}

	LogMsg(_T("CentDedDgrDia::readCentDedRosen_updateRessyaCont()=") )  ;
}


void CentDedDgrDia::readCentDedRosen_05_updateRessyaTrackLineCont(
	const CentDedRosen * pCentDedRosen,
	const CentDedDia * pCentDedDia)
{
	//vector<bool> bChecked;
	const CentDedEkiCont* pCentDedEkiCont = pCentDedRosen->getCentDedEkiCont();
	for (int idx = 0; idx < pCentDedEkiCont->size(); idx++)
	{
		//if (!pCentDedEkiCont->get(idx).getDiagramTrackDisplay())
		//{
		//	continue;
		//}
		for (int iRessyahoukou = Ressyahoukou_Kudari;
			iRessyahoukou <= Ressyahoukou_Nobori;
			iRessyahoukou++)

		{
			ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou;
			deque<int> iEkiOrderBrunchOriginSide;
			deque<int> iEkiOrderLoop;
			deque<int> iEkiOrderBrunchTerminalSide;
			int iResult = pCentDedEkiCont->getEkiOrderBrunchLoop(
				pCentDedEkiCont->EkiOrderOfEkiIndex(eRessyahoukou, idx),
				eRessyahoukou,
				iEkiOrderBrunchOriginSide,
				iEkiOrderLoop,
				iEkiOrderBrunchTerminalSide);
			int iEkijikokukeisiki = 1;
			if (pCentDedEkiCont->get(idx).getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsuchaku)
			{
				iEkijikokukeisiki = 1;
			}
			else if (pCentDedEkiCont->get(idx).getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_KudariChaku &&
				iRessyahoukou == Ressyahoukou_Kudari)
			{
				iEkijikokukeisiki = 2;
			}
			else if (pCentDedEkiCont->get(idx).getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_NoboriChaku &&
					iRessyahoukou == Ressyahoukou_Nobori)
			{
				iEkijikokukeisiki = 2;
			}
			else if (pCentDedEkiCont->get(idx).getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_NoboriChaku &&
				iRessyahoukou == Ressyahoukou_Kudari)
			{
				iEkijikokukeisiki = 3;
			}
			else if (pCentDedEkiCont->get(idx).getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_KudariChaku &&
					iRessyahoukou == Ressyahoukou_Nobori)
			{
				iEkijikokukeisiki = 3;
			}
			Mui< CentDedDgrRessya >*	pCentDedDgrRessyaCont =
				getCentDedDgrRessyaCont(eRessyahoukou);
			int iSize = pCentDedDgrRessyaCont->size();
#pragma omp parallel for schedule(guided) 
			for (int idxRessya = 0;
				idxRessya < iSize; idxRessya++)
			{
				CentDedDgrRessya aCentDedDgrRessya =
					pCentDedDgrRessyaCont->get(idxRessya);
				if (pCentDedEkiCont->get(idx).getDiagramTrackDisplay())
				{
					aCentDedDgrRessya.updateRessyaTrackLine(
						pCentDedEkiCont->EkiOrderOfEkiIndex(eRessyahoukou, idx),
						iEkijikokukeisiki,
						iEkiOrderBrunchOriginSide,
						iEkiOrderLoop,
						iEkiOrderBrunchTerminalSide,
						iResult);
				}
				else
				{
					aCentDedDgrRessya.updateRessyaTrackLineNoDisplay(
						pCentDedEkiCont->EkiOrderOfEkiIndex(eRessyahoukou, idx),
						iEkijikokukeisiki,
						iEkiOrderBrunchOriginSide,
						iEkiOrderLoop,
						iEkiOrderBrunchTerminalSide,
						iResult);
				}
				pCentDedDgrRessyaCont->set(aCentDedDgrRessya, idxRessya);
			}

		}
		//for (int iRessyahoukou = Ressyahoukou_Kudari;
		//	iRessyahoukou <= Ressyahoukou_Nobori;
		//	iRessyahoukou++)
		//{
		//	ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou;
		//	deque<int> iEkiOrderBrunchOriginSide;
		//	deque<int> iEkiOrderLoop;
		//	deque<int> iEkiOrderBrunchTerminalSide;
		//	int iResult = pCentDedEkiCont->getEkiOrderBrunchLoop(
		//		pCentDedEkiCont->EkiOrderOfEkiIndex(eRessyahoukou, idx),
		//		eRessyahoukou,
		//		iEkiOrderBrunchOriginSide,
		//		iEkiOrderLoop,
		//		iEkiOrderBrunchTerminalSide);
		//	int iEkijikokukeisiki = 1;
		//	if (pCentDedEkiCont->get(idx).getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsuchaku)
		//	{
		//		iEkijikokukeisiki = 1;
		//	}
		//	else if ((pCentDedEkiCont->get(idx).getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_KudariChaku &&
		//		iRessyahoukou == Ressyahoukou_Kudari) ||
		//		(pCentDedEkiCont->get(idx).getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_NoboriChaku &&
		//			iRessyahoukou == Ressyahoukou_Nobori))
		//	{
		//		iEkijikokukeisiki = 2;
		//	}
		//	else if ((pCentDedEkiCont->get(idx).getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_NoboriChaku &&
		//		iRessyahoukou == Ressyahoukou_Kudari) ||
		//		(pCentDedEkiCont->get(idx).getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_KudariChaku &&
		//			iRessyahoukou == Ressyahoukou_Nobori))
		//	{
		//		iEkijikokukeisiki = 3;
		//	}
		//	Mui< CentDedDgrRessya >*	pCentDedDgrRessyaCont =
		//		getCentDedDgrRessyaCont(eRessyahoukou);
		//	for (int idxRessya = 0;
		//		idxRessya < pCentDedDgrRessyaCont->size(); idxRessya++)
		//	{
		//		CentDedDgrRessya aCentDedDgrRessya =
		//			pCentDedDgrRessyaCont->get(idxRessya);
		//		aCentDedDgrRessya.updateRessyaTrackLineNoDisplay(
		//			pCentDedEkiCont->EkiOrderOfEkiIndex(eRessyahoukou, idx),
		//			iEkijikokukeisiki,
		//			iEkiOrderBrunchOriginSide,
		//			iEkiOrderLoop,
		//			iEkiOrderBrunchTerminalSide,
		//			iResult);
		//		pCentDedDgrRessyaCont->set(aCentDedDgrRessya, idxRessya);
		//	}

	}
}

// ********************************
//	RXgN^
// ********************************
CentDedDgrDia::CentDedDgrDia() :
	m_iDgrXPosMin( 0 ) ,
	m_iDgrYSizeEkikanDefault( 60 )
{
}
CentDedDgrDia::~CentDedDgrDia() 
{
}
	
// ********************************
//	CentDedDgrDia
// ********************************


	// ********************************
	//@name 
	// ********************************
tstring	CentDedDgrDia::getName()const
{
	return m_strName ;
};
int CentDedDgrDia::getDgrXPosMin()const 
{
	return m_iDgrXPosMin ;
}
CentDedDgrDia& CentDedDgrDia::setDgrXPosMin( int value ) 
{
	m_iDgrXPosMin = value ;
	return *this ; 
}

int CentDedDgrDia::getDgrYSizeEkikanDefault()const
{
	return m_iDgrYSizeEkikanDefault ;
}
bool CentDedDgrDia::getEnableOperation() const
{
	return m_bEnableOperation;
}
;

	// ********************************
	//@name 
	// ********************************
CentDedDgrEkiCont*	CentDedDgrDia::getCentDedDgrEkiCont()
{
	return &m_CentDedDgrEkiCont ;
}
const CentDedDgrEkiCont* CentDedDgrDia::getCentDedDgrEkiCont()const
{
	return &m_CentDedDgrEkiCont ;
}

Mui< CentDedDgrRessyasyubetsu >*	
CentDedDgrDia::getMuCentDedDgrRessyasyubetsu()
{
	return &m_MuCentDedDgrRessyasyubetsu ;
};

const Mu< const CentDedDgrRessyasyubetsu* >*
CentDedDgrDia::getMuCentDedDgrRessyasyubetsu()const
{
	return m_MuCentDedDgrRessyasyubetsu.getMuPtr() ;
};

Mui< CentDedDgrRessya >*	CentDedDgrDia::getCentDedDgrRessyaCont( 
		 ERessyahoukou eRessyahoukou ) 
{
	Mui< CentDedDgrRessya >*	pRv = NULL ;
	if ( eRessyahoukou == Ressyahoukou_Kudari ){
		pRv = &m_CentDedDgrRessyaCont[0] ;
	}	else	{
		pRv = &m_CentDedDgrRessyaCont[1] ;
	}
	return ( pRv ) ;
}


const Mu< const CentDedDgrRessya* >*	
	CentDedDgrDia::getCentDedDgrRessyaCont( 
		 ERessyahoukou eRessyahoukou )const 
{
	const Mu< const CentDedDgrRessya* >*	pRv = NULL ;
	if ( eRessyahoukou == Ressyahoukou_Kudari ){
		pRv = m_CentDedDgrRessyaCont[0].getMuPtr() ;
	}	else	{
		pRv = m_CentDedDgrRessyaCont[1].getMuPtr() ;
	}
	return ( pRv ) ;
}


	// ********************************
	//@name 
	// ********************************
void CentDedDgrDia::readCentDedRosen( 
		const CentDedRosen* pCentDedRosen , 
		const CentDedDia* pCentDedDia ,
		bool bSimplifyRead)
{
	int iRv = 0 ;
	
	//	(1)CentDedDgrDiȃݒ
	if ( iRv >= 0 )
	{
		readCentDedRosen_01_updateCentDedDgrDiaProp( 
			pCentDedRosen , 
			pCentDedDia ) ;
	}
	//(2)CentDedDgrEki𐶐
	//@CentDedDgrEkïȉ̑ACentDedEkȋ琶B
	if ( iRv >= 0 )
	{
		readCentDedRosen_02_updateEkiCont( 
			pCentDedRosen->getCentDedEkiCont()/*->getMuPtr()*/ ,
			pCentDedDia ) ;
	}
	//(6)CentDedDgrEki̒
	//@^p@\LACentDedDgrEkỉwԋȂACentDedEkȋ琶B
	//bSimplifyReadtruȅꍇ͏ȗ
	//Ver1.02.92 ^p@\OFF̏ꍇAH̎nIŵݑύXs߁AgetEnableOperation폜
	if (iRv >= 0 && !bSimplifyRead)
	{
		readCentDedRosen_06_updateEkiContForOperation(
			pCentDedRosen->getCentDedEkiCont()->getMuPtr(),
			pCentDedDia);
	}
	//	(3)CentDedDgrRessyasyubetsu𐶐
	if ( iRv >= 0 ) 
	{
		readCentDedRosen_03_updateMuRessyasyubetsu( 
			pCentDedRosen->getCentDedRessyasyubetsuCont()->getMuPtr() ) ;
	}
	//	(4)CentDedDgrRessya,CentDedDgrEkiJikoku𐶐
	if ( iRv >= 0 )
	{
		readCentDedRosen_04_updateRessyaCont( 
			pCentDedRosen , 
			pCentDedDia ,
			bSimplifyRead) ;
	}
	//(5)CentDedDgrRessyaTrackLine𐶐
	//bSimplifyReadtruȅꍇ͏ȗ
	if (iRv >= 0 && !bSimplifyRead)
	{
		readCentDedRosen_05_updateRessyaTrackLineCont(
			pCentDedRosen,
			pCentDedDia);
	}
	
}

int CentDedDgrDia::EkiIndexOfEkiOrder( 
		ERessyahoukou eRessyahoukou , int iEkiOrder )const 
{
	int iEkiIndex = iEkiOrder ;
	if ( eRessyahoukou == Ressyahoukou_Nobori ){
		iEkiIndex = m_CentDedDgrEkiCont.size() - 1 - iEkiOrder ;
	}
	return ( iEkiIndex ) ;
}

int CentDedDgrDia::EkiOrderOfEkiIndex(  ERessyahoukou eRessyahoukou , 
		int iEkiIndex )const 
{
	int iEkiOrder = iEkiIndex ;
	if ( eRessyahoukou == Ressyahoukou_Nobori ){
		iEkiOrder = m_CentDedDgrEkiCont.size() - 1 - iEkiIndex ;
	}
	return ( iEkiOrder ) ;
}

CdDcdZoneXy	CentDedDgrDia::getZone()const 
{
	int iYSize = getDgrYPosOfEkiTer(INT_MAX);
	if ( iYSize < 0 ){
		iYSize = 0 ;
	}
	return ( CdDcdZoneXy( 
		CdDcdZone( m_iDgrXPosMin , CdDedJikoku::TOTALSECONDS_A_DAY ) ,
		CdDcdZone( 0 , iYSize )  ) ) ;
}



//int CentDedDgrDia::getDgrYPosOfEki( int iEkiIndex, bool bIsOrigin)const
//{
//	//todo:w̎dlǉꂽAw̘aZKv܂B
//
//	if (bIsOrigin)
//	{
//		return getDgrYSizeEkikan(
//			Ressyahoukou_Kudari,
//			0,
//			iEkiIndex,
//			true);
//	}
//	else 
//	{
//		int iRv = getDgrYSizeEkikan(
//			Ressyahoukou_Kudari,
//			0,
//			iEkiIndex,
//			true);
//
//		iRv = iRv + getDgrEkiTrackDisplaySpace(iEkiIndex);
//		return iRv;
//	}
//}

//int CentDedDgrDia::getDgrYPosOfEki( ERessyahoukou eRessyahoukou , 
//		int iEkiOrder, bool bIsOrigin)const
//{
//	if (eRessyahoukou == ERessyahoukou::Ressyahoukou_Kudari)
//	{
//		return getDgrYPosOfEki(
//			EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrder),
//			bIsOrigin);
//	} 
//	else
//	{
//		return getDgrYPosOfEki(
//			EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrder),
//			!bIsOrigin);
//	}
//}





int CentDedDgrDia::getDgrYPosOfEkiOrg(int iEkiIndex)const
{
	return getDgrYSizeEkikanOrg(
		Ressyahoukou_Kudari,
		0,
		iEkiIndex);
}
int CentDedDgrDia::getDgrYPosOfEkiOrg(ERessyahoukou eRessyahoukou,
	int iEkiOrder)const
{
	if (eRessyahoukou == ERessyahoukou::Ressyahoukou_Kudari)
	{
		return getDgrYPosOfEkiOrg(
			EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrder));
	}
	else
	{
		return getDgrYPosOfEkiTer(
			EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrder));
	}
}
int CentDedDgrDia::getDgrYPosOfEkiTer(int iEkiIndex)const
{
	int iRv = getDgrYSizeEkikanOrg(
		Ressyahoukou_Kudari,
		0,
		iEkiIndex);

	iRv = iRv + getDgrEkiTrackDisplaySpace(iEkiIndex);
	return iRv;
}
int CentDedDgrDia::getDgrYPosOfEkiTer(ERessyahoukou eRessyahoukou,
	int iEkiOrder)const
{
	if (eRessyahoukou == ERessyahoukou::Ressyahoukou_Kudari)
	{
		return getDgrYPosOfEkiTer(
			EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrder));
	}
	else
	{
		return getDgrYPosOfEkiOrg(
			EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrder));
	}
}
int CentDedDgrDia::getDgrYSizeEkikanOrg(
	ERessyahoukou eRessyahoukou,
	int iEkiOrderOrg,
	int iEkiOrderDst)const
{
	int iRv = 0;
	// --------------------------------
	if (iEkiOrderOrg == INT_MAX) {
		iEkiOrderOrg = m_CentDedDgrEkiCont.size() - 1;
	}
	if (iEkiOrderDst == INT_MAX) {
		iEkiOrderDst = m_CentDedDgrEkiCont.size() - 1;
	}
	// --------------------------------
	if (!(0 <= iEkiOrderOrg && iEkiOrderOrg < m_CentDedDgrEkiCont.size())) {
		return (-1);	//		wwOrderxs
	}
	if (!(0 <= iEkiOrderDst && iEkiOrderDst < m_CentDedDgrEkiCont.size())) {
		return (-1);	//		wwOrderxs
	}
	int iEkiIndexOrg = EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrderOrg);
	int iEkiIndexDst = EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrderDst);
	if (iEkiIndexOrg > iEkiIndexDst) {
		int i = iEkiIndexOrg;	iEkiIndexOrg = iEkiIndexDst; iEkiIndexDst = i;
	}
	// --------------------------------	
	const Mu<CentDedDgrEki>* pCentDedDgrEkiCont = getCentDedDgrEkiCont();

	int idx;
	for (idx = iEkiIndexOrg; idx < iEkiIndexDst; idx++) {
		iRv += pCentDedDgrEkiCont->get(idx).getDgrYZahyouKyoriOrg();
	}

	return (iRv);
}
int CentDedDgrDia::getDgrYSizeEkikanTer(
	ERessyahoukou eRessyahoukou,
	int iEkiOrderOrg,
	int iEkiOrderDst)const
{
	int iRv = 0;
	// --------------------------------
	if (iEkiOrderOrg == INT_MAX) {
		iEkiOrderOrg = m_CentDedDgrEkiCont.size() - 1;
	}
	if (iEkiOrderDst == INT_MAX) {
		iEkiOrderDst = m_CentDedDgrEkiCont.size() - 1;
	}
	// --------------------------------
	if (!(0 <= iEkiOrderOrg && iEkiOrderOrg < m_CentDedDgrEkiCont.size())) {
		return (-1);	//		wwOrderxs
	}
	if (!(0 <= iEkiOrderDst && iEkiOrderDst < m_CentDedDgrEkiCont.size())) {
		return (-1);	//		wwOrderxs
	}
	int iEkiIndexOrg = EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrderOrg);
	int iEkiIndexDst = EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrderDst);
	if (iEkiIndexOrg > iEkiIndexDst) {
		int i = iEkiIndexOrg;	iEkiIndexOrg = iEkiIndexDst; iEkiIndexDst = i;
	}
	// --------------------------------	
	const Mu<CentDedDgrEki>* pCentDedDgrEkiCont = getCentDedDgrEkiCont();

	int idx;
	for (idx = iEkiIndexOrg; idx < iEkiIndexDst; idx++) {
		if (idx == iEkiIndexOrg)
		{
			iRv += pCentDedDgrEkiCont->get(idx).getDgrYZahyouKyoriTer();
		}
		else
		{
			iRv += pCentDedDgrEkiCont->get(idx).getDgrYZahyouKyoriOrg();
		}
	}

	return (iRv);
}




int CentDedDgrDia::getDgrYPosOfEkiTrack(ERessyahoukou eRessyahoukou, 
	int iEkiOrder, int iEkiTrackIndex) const
{
	int iEkiIndex = EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrder);
	CentDedDgrEki aCentDedDgrEki = getCentDedDgrEkiCont()->get(iEkiIndex);
	if (aCentDedDgrEki.getDiagramTrackDisplay() == 0)
	{
		return -1;
	}
	if (iEkiTrackIndex < 1 ||
		iEkiTrackIndex > aCentDedDgrEki.getCentDedDgrEkiTrack2Cont().size())
	{
		return -1;
	}
	int iRv= getDgrYPosOfEkiOrg(
		iEkiIndex);

	iRv += iEkiTrackIndex * m_iDgrYSizeEkikanDefault;

	return iRv;
}

//int CentDedDgrDia::getDgrYSizeEkikan( 
//			ERessyahoukou eRessyahoukou , 
//			int iEkiOrderOrg ,
//			int iEkiOrderDst,
//			bool bIsOrigin)const
//{
//	int iRv = 0 ;
//	// --------------------------------
//	if ( iEkiOrderOrg == INT_MAX ){
//		iEkiOrderOrg = m_CentDedDgrEkiCont.size() - 1 ;
//	}
//	if ( iEkiOrderDst == INT_MAX ){
//		iEkiOrderDst = m_CentDedDgrEkiCont.size() - 1 ;
//	}
//	// --------------------------------
//	if ( !( 0 <= iEkiOrderOrg && iEkiOrderOrg < m_CentDedDgrEkiCont.size() ) ){
//		return ( -1 ) ;	//		wwOrderxs
//	}
//	if ( !( 0 <= iEkiOrderDst && iEkiOrderDst < m_CentDedDgrEkiCont.size() ) ){
//		return ( -1 ) ;	//		wwOrderxs
//	}
//	int iEkiIndexOrg = EkiIndexOfEkiOrder( eRessyahoukou , iEkiOrderOrg ) ;
//	int iEkiIndexDst = EkiIndexOfEkiOrder( eRessyahoukou , iEkiOrderDst ) ;
//	if ( iEkiIndexOrg > iEkiIndexDst ){
//		int i = iEkiIndexOrg ;	iEkiIndexOrg = iEkiIndexDst ; iEkiIndexDst = i ;
//	}
//	// --------------------------------	
//	const Mu<CentDedDgrEki>* pCentDedDgrEkiCont = getCentDedDgrEkiCont() ;
//
//	int idx;
//	for ( idx = iEkiIndexOrg ; idx < iEkiIndexDst ; idx ++ ){
//		if (idx == iEkiIndexOrg)
//		{
//			iRv += pCentDedDgrEkiCont->get(idx).getDgrYZahyouKyori(bIsOrigin);
//		}
//		else
//		{
//			iRv += pCentDedDgrEkiCont->get(idx).getDgrYZahyouKyori(true);
//		}
//	}
//
//	return ( iRv ) ;
//}


int CentDedDgrDia::getEkikanSaisyouSec( 
			ERessyahoukou eRessyahoukou , 
			int iEkiOrderOrg ,
			int iEkiOrderDst )const 
{
	int iRv = 0 ;
	// --------------------------------
	if ( iEkiOrderOrg == INT_MAX ){
		iEkiOrderOrg = m_CentDedDgrEkiCont.size() - 1 ;
	}
	if ( iEkiOrderDst == INT_MAX ){
		iEkiOrderDst = m_CentDedDgrEkiCont.size() - 1 ;
	}
	// --------------------------------
	if ( !( 0 <= iEkiOrderOrg && iEkiOrderOrg < m_CentDedDgrEkiCont.size() ) ){
		return ( -1 ) ;	//		wwOrderxs
	}
	if ( !( 0 <= iEkiOrderDst && iEkiOrderDst < m_CentDedDgrEkiCont.size() ) ){
		return ( -1 ) ;	//		wwOrderxs
	}
	int iEkiIndexOrg = EkiIndexOfEkiOrder( eRessyahoukou , iEkiOrderOrg ) ;
	int iEkiIndexDst = EkiIndexOfEkiOrder( eRessyahoukou , iEkiOrderDst ) ;
	if ( iEkiIndexOrg > iEkiIndexDst ){
		int i = iEkiIndexOrg ;	iEkiIndexOrg = iEkiIndexDst ; iEkiIndexDst = i ;
	}
	// --------------------------------	
	const Mu<CentDedDgrEki>* pCentDedDgrEkiCont = getCentDedDgrEkiCont() ;

	int idx ;
	for ( idx = iEkiIndexOrg ; idx < iEkiIndexDst ; idx ++ ){
		if ( eRessyahoukou == Ressyahoukou_Kudari ){
			iRv += pCentDedDgrEkiCont->get( idx ).getEkikanSaisyouSecKudari() ;
		}	else if ( eRessyahoukou == Ressyahoukou_Nobori ){
			iRv += pCentDedDgrEkiCont->get( idx ).getEkikanSaisyouSecNobori() ;
		}
	}

	return ( iRv ) ;
}


CdDcdPosXy CentDedDgrDia::calcDgrPosRessyasenKiten( 
		const CentDedDgrRessya* pCentDedDgrRessya , 
		const CentDedDgrRessyasen* pCentDedDgrRessyasen )const 
{
	int iEkiOrderRessyasenKiten = pCentDedDgrRessyasen->getRessyasenKitenEkiOrder() ;
	CentDedDgrEkiJikoku	aEkiJikokuKiten = 
		*pCentDedDgrRessya->getMuCentDedDgrEkiJikoku()->get( iEkiOrderRessyasenKiten ) ;
	int iDgrXPosKiten = aEkiJikokuKiten.getDgrXPosHatsu( true ) ;
	int iDgrYPosKiten = this->getDgrYPosOfEkiTer( 
			pCentDedDgrRessya->getRessyahoukou() , 
			iEkiOrderRessyasenKiten) ;
	return CdDcdPosXy( iDgrXPosKiten , iDgrYPosKiten ) ;
}

CdDcdPosXy CentDedDgrDia::calcDgrPosRessyasenSyuuten( 
		const CentDedDgrRessya* pCentDedDgrRessya , 
		const CentDedDgrRessyasen* pCentDedDgrRessyasen )const 
{
	int iEkiOrderRessyasenSyuuten = pCentDedDgrRessyasen->getRessyasenSyuutenEkiOrder() ;
	CentDedDgrEkiJikoku	aEkiJikokuSyuuten = 
		*pCentDedDgrRessya->getMuCentDedDgrEkiJikoku()->get( iEkiOrderRessyasenSyuuten ) ;
	int iDgrXPosSyuuten = aEkiJikokuSyuuten.getDgrXPosChaku( true ) ;
	int iDgrYPosSyuuten =this->getDgrYPosOfEkiOrg( 
			pCentDedDgrRessya->getRessyahoukou() , 
			iEkiOrderRessyasenSyuuten ) ;
	return CdDcdPosXy( iDgrXPosSyuuten , iDgrYPosSyuuten ) ;
}

CdDcdPosXy CentDedDgrDia::calcDgrPosRessyaTrackChaku(
	const CentDedDgrRessya * pCentDedDgrRessya, 
	const CentDedDgrRessyaTrackLine * pCentDedDgrRessyaTrackLine, 
	const bool bIsRessyaTrack, 
	const int iShiftXSecond, const int iShiftYSecond) const
{
	int iDgrXPosChaku = pCentDedDgrRessya->getMuCentDedDgrEkiJikoku()->
		get(pCentDedDgrRessyaTrackLine->getChakuEkiOrder())->getDgrXPosChaku(true);
	int iDgrYPosChaku;
	if (bIsRessyaTrack)
	{
		iDgrYPosChaku = getDgrYPosOfEkiTrack(
			pCentDedDgrRessya->getRessyahoukou(),
			pCentDedDgrRessyaTrackLine->getEkiOrder(),
			pCentDedDgrRessya->getMuCentDedDgrRessyaTrack()
				->get(pCentDedDgrRessyaTrackLine->getChakuEkiOrder())
				->getRessyaTrackIndex());
	}
	else
	{
		iDgrYPosChaku = getDgrYPosOfEkiOrg(
			pCentDedDgrRessya->getRessyahoukou(),
			pCentDedDgrRessyaTrackLine->getEkiOrder());

	}
	if (pCentDedDgrRessya->getRessyahoukou() == Ressyahoukou_Kudari)
	{
		return CdDcdPosXy(iDgrXPosChaku + iShiftXSecond, iDgrYPosChaku + iShiftYSecond);
	}
	else
	{
		return CdDcdPosXy(iDgrXPosChaku + iShiftXSecond, iDgrYPosChaku - iShiftYSecond);
	}
}

CdDcdPosXy CentDedDgrDia::calcDgrPosRessyaTrackChakuOpposite(
	const CentDedDgrRessya * pCentDedDgrRessya,
	const CentDedDgrRessyaTrackLine * pCentDedDgrRessyaTrackLine,
	const int iShiftXSecond, const int iShiftYSecond) const
{
	int iDgrXPosChaku = pCentDedDgrRessya->getMuCentDedDgrEkiJikoku()->
		get(pCentDedDgrRessyaTrackLine->getChakuEkiOrder())->getDgrXPosChaku(true);
	int iDgrYPosChaku = getDgrYPosOfEkiTer(
		pCentDedDgrRessya->getRessyahoukou(),
		pCentDedDgrRessyaTrackLine->getEkiOrder());
	if (pCentDedDgrRessya->getRessyahoukou() == Ressyahoukou_Kudari)
	{
		return CdDcdPosXy(iDgrXPosChaku + iShiftXSecond, iDgrYPosChaku + iShiftYSecond);
	}
	else
	{
		return CdDcdPosXy(iDgrXPosChaku + iShiftXSecond, iDgrYPosChaku - iShiftYSecond);
	}
}

CdDcdPosXy CentDedDgrDia::calcDgrPosRessyaTrackHatsu(
	const CentDedDgrRessya * pCentDedDgrRessya, 
	const CentDedDgrRessyaTrackLine * pCentDedDgrRessyaTrackLine, 
	const bool bIsRessyaTrack, 
	const int iShiftXSecond, const int iShiftYSecond) const
{
	int iDgrXPosHatsu = pCentDedDgrRessya->getMuCentDedDgrEkiJikoku()->
		get(pCentDedDgrRessyaTrackLine->getHatsuEkiOrder())->getDgrXPosHatsu(true);
	int iDgrYPosHatsu;
	if (bIsRessyaTrack)
	{
		iDgrYPosHatsu = getDgrYPosOfEkiTrack(
			pCentDedDgrRessya->getRessyahoukou(),
			pCentDedDgrRessyaTrackLine->getEkiOrder(),
			pCentDedDgrRessya->getMuCentDedDgrRessyaTrack()
			->get(pCentDedDgrRessyaTrackLine->getHatsuEkiOrder())
			->getRessyaTrackIndex());
	}
	else
	{
		iDgrYPosHatsu = getDgrYPosOfEkiTer(
			pCentDedDgrRessya->getRessyahoukou(),
			pCentDedDgrRessyaTrackLine->getEkiOrder());

	}
	if (pCentDedDgrRessya->getRessyahoukou() == Ressyahoukou_Kudari)
	{
		return CdDcdPosXy(iDgrXPosHatsu + iShiftXSecond, iDgrYPosHatsu + iShiftYSecond);
	}
	else
	{
		return CdDcdPosXy(iDgrXPosHatsu + iShiftXSecond, iDgrYPosHatsu - iShiftYSecond);
	}
}

CdDcdPosXy CentDedDgrDia::calcDgrPosRessyaTrackHatsuOpposite(
	const CentDedDgrRessya * pCentDedDgrRessya,
	const CentDedDgrRessyaTrackLine * pCentDedDgrRessyaTrackLine,
	const int iShiftXSecond, const int iShiftYSecond) const
{
	int iDgrXPosHatsu = pCentDedDgrRessya->getMuCentDedDgrEkiJikoku()->
		get(pCentDedDgrRessyaTrackLine->getHatsuEkiOrder())->getDgrXPosHatsu(true);
	int iDgrYPosHatsu = getDgrYPosOfEkiOrg(
		pCentDedDgrRessya->getRessyahoukou(),
		pCentDedDgrRessyaTrackLine->getEkiOrder());
	if (pCentDedDgrRessya->getRessyahoukou() == Ressyahoukou_Kudari)
	{
		return CdDcdPosXy(iDgrXPosHatsu + iShiftXSecond, iDgrYPosHatsu + iShiftYSecond);
	}
	else
	{
		return CdDcdPosXy(iDgrXPosHatsu + iShiftXSecond, iDgrYPosHatsu - iShiftYSecond);
	}
}

CdDcdPosXy CentDedDgrDia::calcDgrPosRessyaTrackOperationChaku(
	const CentDedDgrRessya * pCentDedDgrRessya, 
	const CentDedDgrRessyaTrackLine * pCentDedDgrRessyaTrackLine, 
	const bool bIsRessyaTrack, const bool bIsShihatu,
	const int iShiftXSecond, const int iShiftYSecond) const
{
	int iEkiOrderOperation;
	if (bIsShihatu)
	{
		iEkiOrderOperation = pCentDedDgrRessyaTrackLine->getChakuEkiOrder();
	}
	else
	{
		iEkiOrderOperation = pCentDedDgrRessyaTrackLine->getHatsuEkiOrder();
	}
	int iDgrXPosOperationChaku = pCentDedDgrRessya->getMuCentDedDgrRessyaTrack()->
		get(iEkiOrderOperation)->getDgrXPosOperationChaku();
	int iDgrYPosOperationChaku;
	if (bIsRessyaTrack)
	{
		iDgrYPosOperationChaku = getDgrYPosOfEkiTrack(
			pCentDedDgrRessya->getRessyahoukou(),
			pCentDedDgrRessyaTrackLine->getEkiOrder(),
			pCentDedDgrRessya->getMuCentDedDgrRessyaTrack()
			->get(iEkiOrderOperation)
			->getRessyaTrackIndex());
	}
	else
	{
		iDgrYPosOperationChaku = getDgrYPosOfEkiTrack(
			pCentDedDgrRessya->getRessyahoukou(),
			pCentDedDgrRessyaTrackLine->getEkiOrder(),
			pCentDedDgrRessya->getMuCentDedDgrRessyaTrack()
			->get(iEkiOrderOperation)
			->getShuntTrackIndex());
	}
	if (pCentDedDgrRessya->getRessyahoukou() == Ressyahoukou_Kudari)
	{
		return CdDcdPosXy(iDgrXPosOperationChaku + iShiftXSecond, iDgrYPosOperationChaku + iShiftYSecond);
	}
	else
	{
		return CdDcdPosXy(iDgrXPosOperationChaku + iShiftXSecond, iDgrYPosOperationChaku - iShiftYSecond);
	}
}

CdDcdPosXy CentDedDgrDia::calcDgrPosRessyaTrackOperationHatsu(
	const CentDedDgrRessya * pCentDedDgrRessya, 
	const CentDedDgrRessyaTrackLine * pCentDedDgrRessyaTrackLine, 
	const bool bIsRessyaTrack, const bool bIsShihatu,
	const int iShiftXSecond, const int iShiftYSecond) const
{
	int iEkiOrderOperation;
	if (bIsShihatu)
	{
		iEkiOrderOperation = pCentDedDgrRessyaTrackLine->getChakuEkiOrder();
	}
	else
	{
		iEkiOrderOperation = pCentDedDgrRessyaTrackLine->getHatsuEkiOrder();
	}
	int iDgrXPosOperationHatsu = pCentDedDgrRessya->getMuCentDedDgrRessyaTrack()->
		get(iEkiOrderOperation)->getDgrXPosOperationHatsu();
	int iDgrYPosOperationHatsu;
	if (bIsRessyaTrack)
	{
		iDgrYPosOperationHatsu = getDgrYPosOfEkiTrack(
			pCentDedDgrRessya->getRessyahoukou(),
			pCentDedDgrRessyaTrackLine->getEkiOrder(),
			pCentDedDgrRessya->getMuCentDedDgrRessyaTrack()
			->get(iEkiOrderOperation)
			->getRessyaTrackIndex());
	}
	else
	{
		iDgrYPosOperationHatsu = getDgrYPosOfEkiTrack(
			pCentDedDgrRessya->getRessyahoukou(),
			pCentDedDgrRessyaTrackLine->getEkiOrder(),
			pCentDedDgrRessya->getMuCentDedDgrRessyaTrack()
			->get(iEkiOrderOperation)
			->getShuntTrackIndex());
	}
	if (pCentDedDgrRessya->getRessyahoukou() == Ressyahoukou_Kudari)
	{
		return CdDcdPosXy(iDgrXPosOperationHatsu + iShiftXSecond, iDgrYPosOperationHatsu + iShiftYSecond);
	}
	else
	{
		return CdDcdPosXy(iDgrXPosOperationHatsu + iShiftXSecond, iDgrYPosOperationHatsu - iShiftYSecond);
	}
}

CdDcdPosXy CentDedDgrDia::calcDgrPosRessyaTrackNext(
	const CentDedDgrRessya * pCentDedDgrRessya, 
	const CentDedDgrRessyaTrackLine * pCentDedDgrRessyaTrackLine, 
	const bool bIsRessyaTrack,
	//const bool bIsShihatu,
	const int iShiftXSecond, 
	const int iShiftYSecond) const
{
	int iEkiOrderOperation = pCentDedDgrRessyaTrackLine->getHatsuEkiOrder();
	int iDgrXPosNext = pCentDedDgrRessya->getDgrXPosNext();
	int iDgrYPosNext;
	if (bIsRessyaTrack)
	{
		iDgrYPosNext = getDgrYPosOfEkiTrack(
			pCentDedDgrRessya->getRessyahoukou(),
			pCentDedDgrRessyaTrackLine->getEkiOrder(),
			pCentDedDgrRessya->getMuCentDedDgrRessyaTrack()
			->get(iEkiOrderOperation)
			->getRessyaTrackIndex());
	}
	else
	{
		iDgrYPosNext = getDgrYPosOfEkiTrack(
			pCentDedDgrRessya->getRessyahoukou(),
			pCentDedDgrRessyaTrackLine->getEkiOrder(),
			pCentDedDgrRessya->getMuCentDedDgrRessyaTrack()
			->get(iEkiOrderOperation)
			->getShuntTrackIndex());
	}
	if (pCentDedDgrRessya->getRessyahoukou() == Ressyahoukou_Kudari)
	{
		return CdDcdPosXy(iDgrXPosNext + iShiftXSecond, iDgrYPosNext + iShiftYSecond);
	}
	else
	{
		return CdDcdPosXy(iDgrXPosNext + iShiftXSecond, iDgrYPosNext - iShiftYSecond);
	}
}

CdDcdPosXy CentDedDgrDia::calcDgrPosRessyaTrackNextNoDisplay(
	const CentDedDgrRessya * pCentDedDgrRessya,
	const CentDedDgrRessyaTrackLine * pCentDedDgrRessyaTrackLine,
	const int iShiftXSecond,
	const int iShiftYSecond) const
{
	int iEkiOrderOperation = pCentDedDgrRessyaTrackLine->getHatsuEkiOrder();
	int iDgrXPosNext = pCentDedDgrRessya->getDgrXPosNextNoDisplay();
	int iDgrYPosNext = getDgrYPosOfEkiTer(
			pCentDedDgrRessya->getRessyahoukou(),
			pCentDedDgrRessyaTrackLine->getEkiOrder());

	if (pCentDedDgrRessya->getRessyahoukou() == Ressyahoukou_Kudari)
	{
		return CdDcdPosXy(iDgrXPosNext + iShiftXSecond, iDgrYPosNext + iShiftYSecond);
	}
	else
	{
		return CdDcdPosXy(iDgrXPosNext + iShiftXSecond, iDgrYPosNext - iShiftYSecond);
	}
}

int CentDedDgrDia::getDgrEkiTrackDisplaySpace(const int iEkiIndex) const
{
	return getCentDedDgrEkiCont()->get(iEkiIndex).getDgrEkiTrackDisplaySpace();

	//CentDedDgrEki aCentDedDgrEki = getCentDedDgrEkiCont()->get(iEkiIndex);
	//if (aCentDedDgrEki.getDiagramTrackDisplay() > 0)
	//{
	//	//ōݐ\\̏ꍇAN_EԐ(Ԑ)EI_
	//	//Ԑ+1@̕ԂKvɂȂBāAw܂ł̋
	//	return (aCentDedDgrEki.getCentDedDgrEkiTrack2Cont().size() + 1) 
	//		* m_iDgrYSizeEkikanDefault;
	//}
	////else if (aCentDedDgrEki.getDiagramTrackDisplay() > 1)
	////{
	////	//蒅E蒅ōݐ\\̏ꍇAN_(蒅̂)EԐ(Ԑ)EI_(蒅̂)
	////	//Ԑ̕ԂKvɂȂB
	////	//āAOwEw܂ł̋ԁAAnEIw͏
	////	return aCentDedDgrEki.getCentDedDgrEkiTrack2Cont().size() 
	////		* m_iDgrYSizeEkikanDefault;
	////}
	//else
	//{
	//	return 0;
	//}
}

void CentDedDgrDia::createEstimateRessya(
		const CentDedDgrRessya* pCentDedDgrRessya ,
		CentDedRessya* pCentDedRessya )const 
{


	CentDedRessya	aCentDedRessya( 
		m_CentDedDgrEkiCont.size() ,
		pCentDedDgrRessya->getRessyahoukou() ) ;

	// --------------------------------
	//	̐ݒ
	// --------------------------------
	{
		aCentDedRessya.setRessyabangou( 
			pCentDedDgrRessya->getRessyabangou() ) ;
		aCentDedRessya.setRessyamei( 
			pCentDedDgrRessya->getRessyamei() ) ;
		aCentDedRessya.setGousuu( 
			pCentDedDgrRessya->getGousuu() ) ;

	}
	// --------------------------------
	//	w̐ݒ
	// --------------------------------
	{
		const Mu<const CentDedDgrEkiJikoku*>*	pMuCentDedDgrEkiJikoku = pCentDedDgrRessya->getMuCentDedDgrEkiJikoku() ;
		const Mu<const CentDedDgrRessyaTrack*>*	pMuCentDedDgrRessyaTrack = pCentDedDgrRessya->getMuCentDedDgrRessyaTrack();
		for ( int iEkiOrder = 0 ; 
			iEkiOrder < pMuCentDedDgrEkiJikoku->size() ; 
			iEkiOrder ++ )
		{
			CentDedDgrEkiJikoku	aCentDedDgrEkiJikoku = *pMuCentDedDgrEkiJikoku->get( iEkiOrder ) ;

			CentDedEkiJikoku	aEkiJikoku = aCentDedRessya.getCentDedEkiJikoku( iEkiOrder ) ;

			// --------------------------------
			//	wݒ
			// --------------------------------
			aEkiJikoku.setEkiatsukai( aCentDedDgrEkiJikoku.getEkiatsukai() ) ;
			
			// --------------------------------
			//	̉w[_ƂԐ
			// --------------------------------
			int idxRessyasenChaku = INT_MIN ;
			int idxRessyasenHatsu = INT_MIN ;
			const Mu<const CentDedDgrRessyasen*>* pMuRessyasen = pCentDedDgrRessya->getCentDedDgrRessyasenCont() ;
			for ( int idxRessyasen = 0 ; 
				idxRessyasen < pMuRessyasen->size() ; 
				idxRessyasen ++ )
			{
				const CentDedDgrRessyasen*	pCentDedDgrRessyasen = pMuRessyasen->get( idxRessyasen ) ;
				if ( pCentDedDgrRessyasen->getRessyasenSyuutenEkiOrder() == iEkiOrder )
				{
					idxRessyasenChaku = idxRessyasen ;
				}
				if ( pCentDedDgrRessyasen->getRessyasenKitenEkiOrder() == iEkiOrder )
				{
					idxRessyasenHatsu = idxRessyasen ;
				}
			}
			//idxRessyasenChaku = 
			//	̉wOrderԐI_ȂA̗ԐOrderAłȂȂINT_MIN 
			//idxRessyasenHatsu = 
			//	̉wOrderԐN_ȂA̗ԐOrderAłȂȂINT_MIN 

			// --------------------------------
			//	wݒ
			// --------------------------------
			if ( idxRessyasenChaku != INT_MIN && aCentDedDgrEkiJikoku.getDgrXPosChaku( true ) != INT_MIN )
			{
				//	Ԑ̏I_ȂADgrXPosƂɒݒ
				aEkiJikoku.setChakujikoku( CdDedJikoku( aCentDedDgrEkiJikoku.getDgrXPosChaku( true ) ) ) ;
			}
			if ( idxRessyasenHatsu != INT_MIN && aCentDedDgrEkiJikoku.getDgrXPosHatsu( true ) != INT_MIN )
			{
				//	Ԑ̋N_ȂADgrXPosƂɔݒ
				aEkiJikoku.setHatsujikoku( CdDedJikoku( aCentDedDgrEkiJikoku.getDgrXPosHatsu( true ) ) ) ;
			}
			if ( idxRessyasenChaku == INT_MIN && 
				idxRessyasenHatsu == INT_MIN && 
				aCentDedDgrEkiJikoku.getDgrXPosRessyasen() != INT_MIN )
			{
				//	ԐN_EI_łȂ && w DgrXPosRessyasen ꍇ́A
				//	DgrXPosRessyasen 𒅁Eɐݒ
				aEkiJikoku.setChakujikoku( CdDedJikoku( aCentDedDgrEkiJikoku.getDgrXPosRessyasen() ) ) ;
				aEkiJikoku.setHatsujikoku( CdDedJikoku( aCentDedDgrEkiJikoku.getDgrXPosRessyasen() ) ) ;
			}

			aCentDedRessya.setCentDedEkiJikoku( iEkiOrder , aEkiJikoku ) ;

			// --------------------------------
			// ԔԐݒ
			// --------------------------------

			CentDedDgrRessyaTrack	aCentDedDgrRessyaTrack = *pMuCentDedDgrRessyaTrack->get(iEkiOrder);

			CentDedRessyaTrack	aRessyaTrack = aCentDedRessya.getCentDedRessyaTrack(iEkiOrder);
			if (iEkiOrder == pCentDedDgrRessya->getSihatsuEki() || 
				iEkiOrder == pCentDedDgrRessya->getSyuuchakuEki())
			{
				aRessyaTrack.setRessyaTrackIndex(aCentDedDgrRessyaTrack.getRessyaTrackIndex());
				aRessyaTrack.setOperation(aCentDedDgrRessyaTrack.getOperation());
				aRessyaTrack.setShuntTrackIndex(aCentDedDgrRessyaTrack.getShuntTrackIndex());
				aRessyaTrack.setOperationHatsuJikoku(aCentDedDgrRessyaTrack.getDgrXPosOperationHatsu());
				aRessyaTrack.setOperationChakuJikoku(aCentDedDgrRessyaTrack.getDgrXPosOperationChaku());
				aRessyaTrack.setOperationNumber(aCentDedDgrRessyaTrack.getOperationNumber());
			}
			else if (iEkiOrder > pCentDedDgrRessya->getSihatsuEki() &&
				iEkiOrder < pCentDedDgrRessya->getSyuuchakuEki())
			{
				aRessyaTrack.setRessyaTrackIndex(aCentDedDgrRessyaTrack.getRessyaTrackIndex());
			}
			aCentDedRessya.setCentDedRessyaTrack(iEkiOrder, aRessyaTrack);
		}
	}
	// --------------------------------
		
	if ( pCentDedRessya != NULL )
	{
		*pCentDedRessya = aCentDedRessya ;
	}
}

void CentDedDgrDia::createEstimateRessya2( 
		const CentDedDgrRessya* pCentDedDgrRessya ,
		CentDedRessya* pCentDedRessya ,
		const CentDedEkiCont* pCentDedEkiCont)const
{
	// --------------------------------
	CentDedRessya	aCentDedRessya( 
		m_CentDedDgrEkiCont.size() ,
		pCentDedDgrRessya->getRessyahoukou() ) ;
	if ( pCentDedRessya == NULL )
	{
		pCentDedRessya = &aCentDedRessya ;
	}
	// --------------------------------
	{
		//	莞ԃIuWFNg𐶐
		createEstimateRessya(
			pCentDedDgrRessya ,
			pCentDedRessya ) ;
	}
	{
		//	wɃANZX Mu 𐶐
		//const Mu< CentDedDgrEkiCont::CdDedDgrEki >* muEki =	getCentDedDgrEkiCont()->getMuPtr( pCentDedRessya->getRessyahoukou())  ;


		// --------------------------------
		//	xw̏ꍇ́Aw
		//	wRs[
		//	(xԂ̃\[g̐xグ邽)
		// --------------------------------

		//	SwɁAwRs[܂B
		//
		//	̎dĺAA-B-C|B-D`̎xH
		//	TransferSort(p\[g)̐xグ邽߂̂̂łB
		//	B-DԗԂBw̉w
		//	A-B-C̊Ԃ B ɂݒ肷邱ƂɂAp\[g
		//	x܂܂B

		//{
		//	for ( int iEkiOrderSrc = 0 ; iEkiOrderSrc < muEki->size() ; iEkiOrderSrc ++ )
		//	{
		//		CentDedDgrEkiCont::CdDedDgrEki	aEkiSrc = muEki->get(iEkiOrderSrc) ;

		//		CentDedEkiJikoku	aEkiJikokuSrc = 
		//			pCentDedRessya->getCentDedEkiJikoku( iEkiOrderSrc ) ;
		//		if ( aEkiJikokuSrc.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya ||
		//			aEkiJikokuSrc.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka )
		//		{
		//			for ( int iEkiOrder = 0 ; 
		//				iEkiOrder <  muEki->size() ;
		//				iEkiOrder ++ )
		//			{
		//				if ( iEkiOrderSrc != iEkiOrder )
		//				{
		//					CentDedDgrEkiCont::CdDedDgrEki aEki = muEki->get(iEkiOrder) ;

		//					if ( aEkiSrc.getEkimei() == aEki.getEkimei() )
		//					{
		//						CentDedEkiJikoku	aEkiJikoku = 
		//							pCentDedRessya->getCentDedEkiJikoku( iEkiOrder ) ;
		//						if ( aEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None ||
		//							aEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi )
		//						{
		//							pCentDedRessya->setCentDedEkiJikoku( iEkiOrder , aEkiJikokuSrc ) ;
		//						}
		//					}
		//				}
		//			}
		//		}
		//	}
		//}

		{
			int iEkiCount = pCentDedEkiCont->size();
			deque<bool> bEkiChecked(iEkiCount, false);
			for (int ord = 0; ord < iEkiCount; ord++)
			{
				deque<int> iEkiOrderBrunchOriginSide;
				deque<int> iEkiOrderLoop;
				deque<int> iEkiOrderBrunchTerminalSide;

				if (bEkiChecked[ord])
				{
					continue;
				}
				int iResult = pCentDedEkiCont->getEkiOrderBrunchLoop(
					ord,
					pCentDedRessya->getRessyahoukou(),
					iEkiOrderBrunchOriginSide,
					iEkiOrderLoop,
					iEkiOrderBrunchTerminalSide);

				if (iResult != -1)
				{
					pCentDedRessya->adjustBrunchLoopForTransferSort(
						iEkiOrderBrunchOriginSide,
						iEkiOrderLoop,
						iEkiOrderBrunchTerminalSide);
					for (int idxo = 0; idxo < (int)iEkiOrderBrunchOriginSide.size(); idxo++)
					{
						bEkiChecked[iEkiOrderBrunchOriginSide[idxo]] = true;
					}
					for (int idxl = 0; idxl < (int)iEkiOrderLoop.size(); idxl++)
					{
						bEkiChecked[iEkiOrderLoop[idxl]] = true;
					}
					for (int idxt = 0; idxt < (int)iEkiOrderBrunchTerminalSide.size(); idxt++)
					{
						bEkiChecked[iEkiOrderBrunchTerminalSide[idxt]] = true;
					}
				}
			}
		}

	}


}
} //namespace entDgr
