/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdGridCell.h
// ****************************************************************
*/
/** @file */
#ifndef  CDcdGridCell_h
#define  CDcdGridCell_h
#include <deque>


#include "DcDraw/IfDcDraw.h"
#include "NsOu/Ou.h"

namespace DcDrawLib{
namespace DcdGrid{
	using namespace OuLib::NsOu;
	using namespace DcDraw;

// ****************************************************************
//	CDcdGridCell
// ****************************************************************
/**
 @brief
 yTvz
	DcdGrid ̃ZIuWFNgłB

	IfDcDraw IuWFNgƊ֘A  IfDcDraw IuWFNgg
	Z̒g`悵܂B

	CDcdGrid ́Aʏ CDcdTextbox IuWFNg𐶐āA
	this Ɗ֘A IfDcDraw IuWFNgƂēo^܂

 */
class CDcdGridCell
{
	friend class CDcdGrid ;

	typedef	std::deque< CDcdGridCell* > CDcdGridYColumnCellCont ;
private:
	// ********************************
	/// @name 	CDcdGrid Ɋ֌W鑮/֘A
	// ********************************
	///@{
	/**
		̃IuWFNgێObhIuWFNgւ̃|C^łB
		RXgN^Ō܂܂B
		j̐Ӗ́ANX[U[ɂ܂B
		̃IuWFNǵAthisȂĂ͂Ȃ܂B

		̊֘ÁA	m_iYAttachCellCount , m_iXAttachCellCount ύXꂽ
		ׂ̂ẴZ̑XV̂Ɏg܂B
	*/
	CDcdGrid*	m_pCDcdGrid ;
	/**
		̃IuWFNgW񂵂ĂReiłB
		̃Reiɂ́AYɂ CDcdGridCell IuWFNgi[Ă܂B

		̊֘ÁACDcdGrid AgetColumnNumberOfCell() sɎQƂ܂B
		RXgN^Ō܂܂B
	*/
	CDcdGridYColumnCellCont* m_pCont ;

	/**
		ʏNULLłB
		̃ZZ̈ԍȊOɈʒuĂꍇ́A
		̃ZĂłɂ̂w܂B
		̊֘ÁA CDcdGrid ݒ肵܂B
	 */
	CDcdGridCell*	m_pcellAttachTo ;

	///@}
 private:
	// ********************************
	/// @name CDcdGridCell ŗL̊֘A
	// ********************************
	///@{
	
	/**
		this ɑ΂錻݂̕`IuWFNgw|C^łB
		̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		̃IuWFNǵÅ֘ALȊԂ͐ȂĂ͂Ȃ܂B
	
		ʏ́A CDcdGrid::OnCreateCell() CX^X𐶐Eo^A
		 CDcdGrid::OnDeleteCell() CX^Xo^Ej܂B
		
		ftHg  CDcdGrid::OnCreateCell() ̎́A
		CDcdTextbox CX^X𐶐Eo^܂B
		̂Ƃ̑́A
	
			- tHg̓XgbNIuWFNg DEFAULT_GUI_FONT 
			- eLXgzu 
				CdDrawTextFormat::H_LEFT | 
				CdDrawTextFormat::V_SINGLELINT_CENTER
			- wiF 
			- eLXg̏㉺EE̘g̈̑͘_PʂłP
	
		ƂȂ܂B
	 */
	Ou<IfDcDraw>			m_pIfDcDraw ;
	
	///@}
private:
	// ********************************
	/// @name CDcdGridCell ŗL̑
	// ********************************
	///@{
	/**
		̃ZYɌĂZ̐B
	
		- ̃ZZ̍̃Z̏ꍇ́A
		ĂZY̐łB
		- ̃ZPƂ̃Z̏ꍇ1B
		- ̃ZZ̍ȊOł΁A̒l͈Ӗ܂B
	
		l1B\bhŕύXł܂B
	 */
	int	m_iYAttachCellCount ;

	/**
		̃ZXɌĂZ̐B
	
		- ̃ZZ̍̃Z̏ꍇ́A
		ĂZX̐łB
		- ̃ZPƂ̃Z̏ꍇ1B
		- ̃ZZ̍ȊOł΁A̒l͈Ӗ܂B
	
		l1B\bhŕύXł܂B
	 */
	int	m_iXAttachCellCount ;


	///@}

// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 @param [in] pCDcdGrid 
		̃IuWFNgێObhIuWFNgւ̃|C^łB
	 @param [in] pCDcdGridYColumnCellCont 
		CDcdGrid ɂāÃIuWFNgW񂷂Reiւ̃|C^łB
	 */
	CDcdGridCell( CDcdGrid*	pCDcdGrid , 
		CDcdGridYColumnCellCont* pCDcdGridYColumnCellCont  ) ;
	
 private:
	CDcdGridCell( const CDcdGridCell& ev ){} ;
	void operator=( CDcdGridCell& ev ) {};

// ********************************
//	CDcdGridCell
// ********************************
public:
	// ********************************
	/// @name 	CDcdGrid Ɋ֌W鑮/֘A
	// ********************************
	///@{
	CDcdGrid*	getCDcdGrid() ;


	/**
		ʏNULLłB
		̃ZZ̈ԍȊOɈʒuĂꍇ́A
		̃ZĂłɂ̂w܂B
		̊֘ÁA CDcdGrid ݒ肵܂B
	 */
	virtual CDcdGridCell*	getAttachTo() ;

	///@}
	// ********************************
	/// @name 	/
	// ********************************
	///@{
	///@}

	// ********************************
	/// @name	CDcdGridCell ŗL̊֘A
	// ********************************
	///@{
	virtual Ou<IfDcDraw> getIfDcDraw() ;
	virtual void setIfDcDraw( Ou<IfDcDraw> value ) ;


	///@}
	// ********************************
	/// @name CDcdGridCell ŗL̑
	// ********************************
	///@{

	///@see m_iYAttachCellCount
	virtual int	getYAttachCellCount() ;
	
	///@see m_iXAttachCellCount
	virtual int	getXAttachCellCount() ;

	/**
		Z̐ݒ肵܂B
		̍ɈʒuZɁA̒lݒ肵ĂB
	
		AZ̐Obh͈̔͂zĂꍇ́AK
		s܂B
	 @param iXAttachCellCount [in]
		XɌZ̐w肵ĂB
	 @param iYAttachCellCount [in]
		YɌZ̐w肵ĂB
	 @return
		΂OȏAG[Ȃ畉̐łB
		-	0 ;	//	Z̐ɕύX͂܂B
		-	1 ;	//	Z̐ύX܂B
		-	-1 ;	//	l͈̔͂sł
	 */
	int	setAttachCellCount( 
		int iXAttachCellCount , 
		int iYAttachCellCount ) ;


	///@}
};

} //namespace DcdGrid
} //namespace DcDrawLib

#endif /*CDcdGridCell_h*/
