/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/** @file CDcdGridXBorder.h */
//$Id: CDcdGridXBorder.h 296 2016-06-11 05:40:21Z okm $
//////////////////////////////////////////////////////////////////////

#ifndef CDcdGridXBorder_h
#define CDcdGridXBorder_h

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DcDraw/IfDcDraw.h"
#include "NsOu/Ou.h"


namespace DcDrawLib{
namespace DcdGrid{
	using namespace OuLib::NsOu;
	using namespace DcDraw;

// ****************************************************************
//	CDcdGridXBorder
// ****************************************************************
/**
@brief
yTvz
	DcdGrid X̊Ԃ̌r(cr)̃IuWFNgłB
	IfDcDraw IuWFNgƊ֘A  IfDcDraw IuWFNgg
	DcdGridX̋E`悵܂B

	CDcdGrid ́Aʏ CDcdLine IuWFNg𐶐āA
	this Ɗ֘A IfDcDraw IuWFNgƂēo^܂

*/
class CDcdGridXBorder  
{
private:
	// ********************************
	/// @name 	CDcdGrid Ɋ֌W鑮/֘A
	// ********************************
	///@{

	/**
		this ɑ΂錻݂̕`IuWFNgw|C^łB
	
		̃IuWFNg̔j̐Ӗ̓NX[U[ɂ܂B
		̃IuWFNǵÅ֘ALȊԂ́A
		ĂȂĂ͂Ȃ܂B
	
		ʏ́A CDcdGrid::OnCreateXColumn() CX^X𐶐Eo^A
		 CDcdGrid::OnDeleteXColumn() CX^Xo^Ej܂B
		
		ftHg  CDcdGrid::OnCreateXColumn() ̎́A
		CDcdLine CX^X𐶐Eo^܂B
		̂Ƃ̑́AP̍̎
		ƂȂ܂B
	 */
	Ou<IfDcDraw>			m_pIfDcDraw ;
	/**
		_TCYŁÅOiE/j̋ẼTCYێ܂B
		A m_bAutoColumnBorderSize ^ȂA̒l͖łB
		ftHgł͂PłB
	 */
	DcdSize	m_iColumnBorderSize ;
	
	/**
		- true ;	m_pIfDcDraw  getItemSize() Ԃ @n
			TCYƂɁÅOiE/j̋ẼTCY肵܂B
	*/
	bool	m_bAutoColumnBorderSize ;

	///@}	

	// ********************************
	//	RXgN^
	// ********************************
public:
	/**
	 @param [in] pCDcdGrid 
		̃IuWFNgێObhIuWFNgւ̃|C^łB
	 */
	CDcdGridXBorder();
	virtual ~CDcdGridXBorder(){};
private:
	CDcdGridXBorder( const CDcdGridXBorder& ev ){} ;
	void operator=( CDcdGridXBorder& ev ) {};

public:
	// ********************************
	/// @name	CDcdGridXBorder ֘A
	// ********************************
	///@{
	virtual Ou<IfDcDraw> getIfDcDraw() ;
	virtual void setIfDcDraw( Ou<IfDcDraw> value ) ;
	///@}

	// ********************************
	/// @name	CDcdGridXBorder 
	// ********************************
	///@{

	CDcdGridXBorder& setColumnBorderSize( DcdSize ev ){
		m_bAutoColumnBorderSize = false ;
		m_iColumnBorderSize = ev ;	return *this ; } ;
	bool	getAutoColumnBorderSize(){
		return m_bAutoColumnBorderSize ;	} ;

	CDcdGridXBorder& setAutoColumnBorderSize( bool ev ){
		m_bAutoColumnBorderSize = ev ;	return *this ; } ;
	///@}
	// ********************************
	/// @name	
	// ********************************
	///@{
	/**
		_TCYŁAẼTCYԂ܂B
	 @param pIfDcdTarget [in]
		`ΏۂƂȂ^[Qbgw肵ĂB
	 @return
		ẼTCYԂ܂B
	 */
	virtual DcdSize	getColumnBorderSize( IfDcdTarget* pIfDcdTarget ) ;
	///@}
};

} //namespace DcdGrid
} //namespace DcDrawLib
#endif // CDcdGridXBorder_h
