/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/** @file */
//$Id: CMuiOuParent.h 348 2016-08-16 17:47:55Z okm $
#ifndef  OuLib_NsMu_CMuiOuParent
#define  OuLib_NsMu_CMuiOuParent

#include "CMuiOu.h"
#include "CParentBase.h"

namespace OuLib{
namespace NsMu{


/**
@brief
@ElementType ^̃IuWFNgw Ou(QƃJE^gpX}[g|C^)ێReiłBweqReixp^[̐eIuWFNgƂċ@\܂B

@ref parent_child_container

@qIuWFNg(ReĩACe)AeIuWFNg(gێĂRei)ɃANZX邱Ƃł܂B

@̃NXev[ǵACMuiOu {NXƂĂ܂B

@qIuWFNgeIuWFNg(this)ɒǉꂽƂAeIuWFNǵAqIuWFNg CChildBase::setParent() \bhĂяoāAeIuWFNg(this)̃AhXqIuWFNgɓo^܂B̂ƂneIuWFNǧ^́ACParentBase* łB
@qIuWFNǵACChildBase::getParent() ŁAeIuWFNg̃AhX擾ł܂BCChildBase::getParent() Ԃ CParentBase* łBqIuWFNǵÃAhXAۂ̐eIuWFNg(Rei)̌^Ƀ_ELXg邱ƂɂAeIuWFNg̃\bhĂяoƂł܂B


@param ElementType
  i[IuWFNǧ^w肵ĂB
@ElementTypéACChildBase p^łȂĂ͂Ȃ܂B
@̃p[^[ɂ́AOu͊܂߂ȂłB
@param ContType
  Ou< ElementType > ێSTLReiw肵ĂB
  ł́Astd::deque łA std::vector gƂł܂B
*/
template <
	class ElementType,
	class ContType =std::deque< Ou< ElementType > > >
class CMuiOuParent 
	: public CMuiOu< ElementType , ContType >
 	, public CParentBase

{
public:
	// ********************************
	// RXgN^
	// ********************************
	/** ftHgRXgN^ */
	CMuiOuParent(){} ; 

	/** 
		Rs[RXgN^B
		value  Ou wĂIuWFNgAg̎qACe
		܂B
		SĂ̎qACeɑ΂āAsetParent( this ) s܂B
	*/
	CMuiOuParent( const CMuiOuParent<ElementType,ContType>& value ) 
		: CMuiOu( value ) 
	{
		//	SĂ̗vfɑ΂āAsetParent()s
		for ( int idx = 0 ; idx < size() ; idx ++ )
		{
			get( idx )->setParent( this ) ;
		}

		
	}


	/** 
		ZqB
		value  Ou wĂIuWFNgAg̎qACe
		܂B
		SĂ̎qACeɑ΂āAsetParent( this ) s܂B
	*/
	CMuiOuParent& operator=( const CMuiOuParent<ElementType,ContType>& value ) 
	{
		CMuiOu::operator=( value ) ; 
		
		//	SĂ̗vfɑ΂āAsetParent()s
		for ( int idx = 0 ; idx < size() ; idx ++ )
		{
			get( idx )->setParent( this ) ;
		}

		return *this ;
	};


	/** 
		fXgN^
		value  Ou wĂIuWFNgƂ̐eq֌W
		܂B
		SĂ̎qACeɑ΂āAsetParent( NULL ) s܂B
	*/
	virtual ~CMuiOuParent()
	{
		//	SĂ̗vfɑ΂āAsetParent()s
		for ( int idx = 0 ; idx < size() ; idx ++ )
		{
			get( idx )->setParent( NULL ) ;
		}

	} ; 
public:
	// ********************************
	///@name Mui 
	// ********************************
	///@{
	/**
		ReíACfNXŎw肳ꂽꏊɁA vf̃Rs[ǉ܂B
		Ou̎wIuWFNgqACeƂ܂B
		qACeɑ΂āAsetParent( this ) s܂B
	@param element
		vfw肵ĂB 
	@param iIndex
		0 n܂CfNXw肵ĂB 
		͈͂͂Oȏ size() ȉłB ÓA擪Esize()Ȃ疖ւ
		ǉɂȂ܂B AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B 
	@return
		0ȏ͐A̐̓G[ł 
	*/
	virtual int insert( const Ou<ElementType>& element ,  int iIndex=INT_MAX) 
	{
		if ( iIndex == INT_MAX )
		{
			iIndex = size() ;
		}
		int iRv = CMuiOu< ElementType , ContType >::insert( element , iIndex ) ;
		get( iIndex )->setParent( this ) ;  
		return iRv ;
	}
	/**
		ReíACfNXŎw肳ꂽꏊ vf폜܂B 
		폜 Ou wĂIuWFNgƂ̐eq֌W
		܂B
		폜qACeɑ΂āAsetParent( NULL ) s܂B
	@param iIndex
		On܂CfNXw肵ĂB ͈͂͂Oȏ size() 
		łB AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B 
	@param iSize
		폜vf̐w肵ĂB AAINT_MAX ́A 
		iIndex 疖܂ł\܂B 
	@attention
		iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B 
	@return
		0ȏ͐A̐̓G[ł 
	*/
	virtual int erase( int iIndex , int  iSize = 1  ) 
	{
		if ( iIndex == INT_MAX )
		{
			iIndex = size() - 1 ;
		}
		if ( iSize == INT_MAX )
		{
			iSize = size() - iIndex ; 
		}
		for ( int i = 0 ; i < iSize ; i ++ )
		{
			get( iIndex + i )->setParent( NULL ) ; 
		}
		return CMuiOu< ElementType , ContType >::erase( iIndex , iSize ) ;
	}
	/**
		ReíACfNXŎw肳ꂽꏊɁA vf㏑܂B 
		㏑ Ou wĂIuWFNgƂ̐eq֌W
		܂B
		VOu̎wIuWFNgqACeƂ܂B
		qACeɑ΂āAsetParent( this ) s܂B
	@param element
		vfw肵ĂB 
	@param iIndex
		 On܂CfNXw肵ĂB 
		 ͈͂͂Oȏ size() łB 
		 AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B 
	@return
		0ȏ͐A̐̓G[ł 
	*/
	virtual int set( const Ou<ElementType>& element , int iIndex ) 
	{
		if ( iIndex == INT_MAX )
		{
			iIndex = size() - 1 ;
		}
		get( iIndex )->setParent( NULL ) ;  
		int iRv = CMuiOu< ElementType , ContType >::set( element , iIndex ) ;
		get( iIndex )->setParent( this ) ; 
		return iRv ;
	}

};

} //namespace NsMu
} //namespace OuLib



#endif //OuLib_NsMu_CMuiOuParent

