/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CHidemdiRootDoc.cpp
// ****************************************************************
*/

#include "CHidemdiRootDoc.h"
#include "CHidemdiApp.h"

namespace OuMfc{
namespace Hidemdi{


// ****************************************************************
//	CHidemdiRootDoc
// ****************************************************************
// ********************************
//	CHidemdiRootDoc
// ********************************
void CHidemdiRootDoc::UpdateAllSubDocviews( CView* pSender	
								, LPARAM lHint , CObject* pHint )
		//	ׂẴTuDocviewɑ΂āAUpdateAllViews()s܂
		//pSender
		//	hLgύXr[ւ̃|C^B
		//ׂẴr[XVƂɂ NULL w肵܂B
		//lHint
		//	ύXɊւw肵܂B
		//	A LHINT_SUBVIEW_TO_ROOTDOC w肳ꂽꍇ́A
		//	ׂĂDocviewɑ΂āA
		//	e[ghLgɔfAKvȂ΃[gDocɑ΂
		//	SetModifiedFlag()s܂B
		//pHint
		//	ύXɊւ񂪊i[ĂIuWFNgւ̃|C^B
{
	POSITION	LPosition = AfxGetApp()->GetFirstDocTemplatePosition() ;

	//	ׂẴTuDocViewւ́AUpdateAllViews() Ăяo
	while( LPosition != NULL ){
		CDocTemplate*	pLDocTemplate = AfxGetApp()
						->GetNextDocTemplate( LPosition ) ;
		if ( pLDocTemplate != GetDocTemplate() ){
			POSITION	LPosition = pLDocTemplate->GetFirstDocPosition() ;
			while( LPosition != NULL ){
				CDocument*	pLDocument = 
					pLDocTemplate->GetNextDoc( LPosition ) ;
				pLDocument->UpdateAllViews( pSender	, lHint , pHint ) ;
			}
		}
	}
}

//----------------------------------------------------------------
//	MFC
//----------------------------------------------------------------
IMPLEMENT_DYNCREATE(CHidemdiRootDoc, CDocument)

BEGIN_MESSAGE_MAP(CHidemdiRootDoc, CHidemdiRootDoc::super)
	//{{AFX_MSG_MAP(CHidemdiRootDoc)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CHidemdiRootDoc::CHidemdiRootDoc()
{

}

CHidemdiRootDoc::~CHidemdiRootDoc()
{
}

#ifdef _DEBUG
void CHidemdiRootDoc::AssertValid() const
{
	super::AssertValid();
}

void CHidemdiRootDoc::Dump(CDumpContext& dc) const
{
	super::Dump(dc);
}
#endif //_DEBUG

BOOL CHidemdiRootDoc::SaveModified() 
	//	SaveAllModifiedSubDocviewsij
	//	iׂẴTuDocviewɑ΂SaveModofiedsj
	//	sĂAgSaveModifieds܂)
{
	BOOL	bRv = TRUE ;
	bRv = ((CHidemdiApp*)AfxGetApp())->pRootDoctmpl()
									->SaveAllModifiedSubDocviews() ;
	if ( bRv ){
		bRv = super::SaveModified();
	}
	return ( bRv ) ;
}




void CHidemdiRootDoc::SetTitle(LPCTSTR lpszTitle) 
{
	//[Attention]
	//	hLg𖼑OĕۑꍇȂǂ́A
	//	 OnUpdateFrameTitle() ĂяoȂƁA
	//	Ct[EChẼ^Cgo[ς܂B
	super::SetTitle(lpszTitle);
	( (CFrameWnd*)AfxGetMainWnd() )->OnUpdateFrameTitle( TRUE ) ;
}

void CHidemdiRootDoc::OnFileSave() 
{
	BOOL	bRv = TRUE ;

	//[Attention]
	//	̃R}hbZ[W̏ꍇ́AIɂ
	//	SaveModified()Ă΂܂̂ŁAI
	//	SaveAllModifiedSubDocviewsij
	//	iׂẴTuDocviewɑ΂SaveModofiedsj
	//	sĂAg̏s܂
	bRv = ((CHidemdiApp*)AfxGetApp())->pRootDoctmpl()
								->SaveAllModifiedSubDocviews() ;

	if ( bRv ){
		super::OnFileSave() ;
	}

}

void CHidemdiRootDoc::OnFileSaveAs() 
{
	BOOL	bRv = TRUE ;

	//[Attention]
	//	̃R}hbZ[W̏ꍇ́AIɂ
	//	SaveModified()Ă΂܂̂ŁAI
	//	SaveAllModifiedSubDocviewsij
	//	iׂẴTuDocviewɑ΂SaveModofiedsj
	//	sĂAg̏s܂
	bRv = ((CHidemdiApp*)AfxGetApp())->pRootDoctmpl()
								->SaveAllModifiedSubDocviews() ;

	if ( bRv ){
		super::OnFileSaveAs() ;
	}
}


void CHidemdiRootDoc::OnFileClose() 
{
	//attention
	// RootDoc ɑ΂ ID_FILE_CLOSE ́A
	//	Ă͂܂
	//	i[ghLgOɂȂĂ܂܂B
	//	Hidemdi AvP[V́AɂP
	//	[ghLgIuWFNgȂĂ͂Ȃ܂)
	//	
	//	RootDoc ̃j[
	//	 FILE_CLOSE 폜ȂĂ͂Ȃ܂B
	ASSERT( 0 ) ;
	//CHidemdiRootDoc::super::OnFileClose();
}


void CHidemdiRootDoc::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( ((CHidemdiApp*)AfxGetApp())->pRootDoc()->IsModified() ) ;
}

void CHidemdiRootDoc::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( ((CHidemdiApp*)AfxGetApp())->pRootDoc()->IsModified() ) ;
}

} //namespace Hidemdi
} //namespace OuMfc

