/*
OuDiaSecond Copyright (C) 2017 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CRfEditCmd_EkiTrack2.cpp
// $Id: CRfEditCmd_EkiTrack2.cpp  $
// ****************************************************************
*/
#include "stdafx.h"
#include "NsMu/CaMui.h"
#include "NsOu/OuNew.h"
#include "CRfEditCmd_EkiTrack2.h"

#ifndef _CONSOLE
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif



namespace DedRosenFileData{ namespace EditCmd{

// ****************************************************************
//	CRfEditCmd_EkiTrack2
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CRfEditCmd_EkiTrack2::
	CRfEditCmd_EkiTrack2(
		int iEkiIndex ,
		int iIndexDst ,
		int iSizeDst ,
		const CentDedEkiTrack2Cont& aCentDedEkiTrack2ContSrc ) :
	m_iEkiIndex( iEkiIndex ),
	m_iIndexDst( iIndexDst ) ,
	m_iSizeDst( iSizeDst ) ,
	m_CentDedEkiTrack2ContSrc( aCentDedEkiTrack2ContSrc ) ,
	m_CaMuiSelect( &m_CentDedEkiTrack2ContSrc , m_CentDedEkiTrack2ContSrc.getMuPtr() ) ,
	//m_pMuAll(&m_CentDedEkiTrack2ContSrc, m_CentDedEkiTrack2ContSrc.getMuPtr()),
	m_pCentDedEkiTrack2ContOld( NULL ) ,
	m_pCentDedRosen( NULL ) 
{
	m_CaMuiSelect.setSelectAll( true ) ;
}

CRfEditCmd_EkiTrack2::
	CRfEditCmd_EkiTrack2(
		const CDedRosenFileData& aCDedRosenFileData ,
		int iEkiIndex,
		int iIndexDst , 
		int iSizeDst ) :
	m_iEkiIndex(iEkiIndex),
	m_iIndexDst( iIndexDst ) ,
	m_iSizeDst( iSizeDst ) ,
	m_CentDedEkiTrack2ContSrc() ,
	m_CaMuiSelect( &m_CentDedEkiTrack2ContSrc , m_CentDedEkiTrack2ContSrc.getMuPtr() ) ,
	//m_pMuAll(&m_CentDedEkiTrack2ContSrc, m_CentDedEkiTrack2ContSrc.getMuPtr()),
	m_pCentDedEkiTrack2ContOld( NULL ) ,
	m_pCentDedRosen( NULL ) 
{
	const CentDedEkiTrack2Cont* pCentDedEkiTrack2Cont
		= aCDedRosenFileData.getCentDedRosen()->getCentDedEkiCont()->getMuPtr()->get(m_iEkiIndex)->getEkiTrack2Cont();

	CaMui<CentDedEkiTrack2> aMui( &m_CaMuiSelect ) ;
	aMui.insert( pCentDedEkiTrack2Cont , iIndexDst , iSizeDst ) ;

	m_CaMuiSelect.setSelectAll( true ) ;

}		



CRfEditCmd_EkiTrack2::
	~CRfEditCmd_EkiTrack2()
{
	if ( m_pCentDedEkiTrack2ContOld != NULL )
	{
		delete m_pCentDedEkiTrack2ContOld ;
		m_pCentDedEkiTrack2ContOld = NULL ;
	}
	if ( m_pCentDedRosen !=  NULL ) 
	{
		delete m_pCentDedRosen ;
		m_pCentDedRosen = NULL ;
	}
}
// ********************************
//@name	CRfEditCmd-
// ********************************
int 
CRfEditCmd_EkiTrack2::
	execute( CDedRosenFileData* pCDedRosenFileData ) 
{
	int iRv = 0 ;
	// --------------------------------
	CentDedRosen*	pCentDedRosen = pCDedRosenFileData->getCentDedRosen() ;
	Mu<CentDedEki*>*	pCentDedEkiCont =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr();
	CentDedEkiTrack2Cont*	pCentDedEkiTrack2Cont =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr()->get(m_iEkiIndex)->getEkiTrack2Cont(); 
	if ( iRv >= 0 ){
		if ( m_iIndexDst == INT_MAX && m_iSizeDst == INT_MAX ){
			iRv = -1 ;	//	m_iDiaIndex ̒lsłB
		}	else	{
			if ( m_iIndexDst == INT_MAX ){
				m_iIndexDst = pCentDedEkiTrack2Cont->size()  - m_iSizeDst ;
			}	else if ( m_iSizeDst == INT_MAX ){
				m_iSizeDst = pCentDedEkiTrack2Cont->size() - m_iIndexDst ;
			}
			if ( !( 0 <= m_iIndexDst && 
				m_iIndexDst + m_iSizeDst <= 
					pCentDedEkiTrack2Cont->size() ) ){
				iRv = -1 ;	//	m_iDiaIndex ̒lsłB
			}
		}
	}
	// --------------------------------
	//	폜f[^ۑ
	// --------------------------------
	if ( iRv >= 0 ){
		if ( m_pCentDedEkiTrack2ContOld != NULL ){
			delete m_pCentDedEkiTrack2ContOld ;
			m_pCentDedEkiTrack2ContOld = NULL ;
		}
		if ( m_pCentDedRosen != NULL ){
			delete m_pCentDedRosen ;
			m_pCentDedRosen = NULL ;
		}
		//	vfuE܂͒ǉsꍇ
		if ( m_iSizeDst <= m_CentDedEkiTrack2ContSrc.size() ){
			m_pCentDedEkiTrack2ContOld = new CentDedEkiTrack2Cont() ;
			CaMui<CentDedEkiTrack2>	aCaCont( m_pCentDedEkiTrack2ContOld ) ;
			aCaCont.insert( 
				pCentDedEkiTrack2Cont ,
				m_iIndexDst , 
				m_iSizeDst , 0 ) ;
		}
		//	vf̍폜̏ꍇ́AHŜۑKv܂
		//	(폜ꂽԐgpԂłȂȂ邽)
		else
		{
			m_pCentDedRosen = new CentDedRosen( *pCentDedRosen ) ; 
		}
	}
	//wEΉ
	//ꈵwiEkiIndexBrunchLoopɒoASĂɓҏW{
	std::deque<int> iEkiIndexBrunchLoop;
	int iSize = pCentDedRosen->getCentDedEkiCont()
		->getEkiIndexBrunchLoop(m_iEkiIndex, iEkiIndexBrunchLoop);
	// --------------------------------
	//	̗vf̍폜
	// --------------------------------
	if ( iRv >= 0 ){
		int iGensyouSize = m_iSizeDst - m_CentDedEkiTrack2ContSrc.size() ;
		if ( iGensyouSize > 0 ){
			for (int idx = 0; idx < iSize; idx++)
			{
				CentDedEkiTrack2Cont* pCentDedEkiTrack2ContTarget =
					pCentDedEkiCont->get(iEkiIndexBrunchLoop[idx])->getEkiTrack2Cont();
				int iResult = pCentDedEkiTrack2ContTarget->erase(
					m_iIndexDst + m_iSizeDst - iGensyouSize,
					iGensyouSize
				);
				if (iResult < 0) {
					iRv = -11;	//	vf̍폜Ɏs܂B
				}
			}
		}
	}
	// --------------------------------
	//	vf̒u
	// --------------------------------
	int iOkikaeSize = 0 ;
	if ( iRv >= 0 ){
		iOkikaeSize = 
			min( m_iSizeDst , m_CentDedEkiTrack2ContSrc.size() ) ;
		for (int idx = 0; idx < iSize; idx++)
		{
			CentDedEkiTrack2Cont* pCentDedEkiTrack2ContTarget =
				pCentDedEkiCont->get(iEkiIndexBrunchLoop[idx])->getEkiTrack2Cont();
			for (int cnt = 0; iRv >= 0 && cnt < iOkikaeSize; cnt++) {
				int iResult = pCentDedEkiTrack2ContTarget->set(
					m_CentDedEkiTrack2ContSrc.get(cnt),
					m_iIndexDst + cnt);
				if (iResult < 0) {
					iRv = -13;	//	vf̒uɎs܂B
				}
			}
		}
	}
	// --------------------------------
	//	̗vf̒ǉ
	// --------------------------------
	if ( iRv >= 0 ){
		int iZoukaSize = m_CentDedEkiTrack2ContSrc.size() - m_iSizeDst ;
		if ( iZoukaSize > 0 ){
			for (int idx = 0; idx < iSize; idx++)
			{
				CentDedEkiTrack2Cont* pCentDedEkiTrack2ContTarget =
					pCentDedEkiCont->get(iEkiIndexBrunchLoop[idx])->getEkiTrack2Cont();
				for (int cnt = 0; iRv >= 0 && cnt < iZoukaSize; cnt++) {
					int iResult = pCentDedEkiTrack2ContTarget->insert(
						m_CentDedEkiTrack2ContSrc.get(iOkikaeSize + cnt),
						m_iIndexDst + iOkikaeSize + cnt);
					if (iResult < 0) {
						iRv = -12;	//	vf̒ǉɎs܂B
					}
				}
			}
		}

	}

	return ( iRv ) ;
}
	
Ou<CRfEditCmd> CRfEditCmd_EkiTrack2::
	createUndoCmd() 
{
	if ( m_pCentDedEkiTrack2ContOld != NULL ){
		OuNew<CRfEditCmd>	pCmd( 
			new CRfEditCmd_EkiTrack2(
				m_iEkiIndex ,
				m_iIndexDst ,
				m_CentDedEkiTrack2ContSrc.size() ,
				*m_pCentDedEkiTrack2ContOld  ) ) ;
		delete m_pCentDedEkiTrack2ContOld ;
		m_pCentDedEkiTrack2ContOld = NULL ;
		return pCmd ;
	}
	if ( m_pCentDedRosen != NULL ){
		OuNew<CRfEditCmd>	pCmd( 
			new CRfEditCmd_Rosen( 
				*m_pCentDedRosen  ) ) ;
		delete m_pCentDedRosen ;
		m_pCentDedRosen = NULL ;
		return pCmd ;
	}
	return ( Ou<CRfEditCmd>() ) ;
}
	
} } // namespace EditCmd namespace DedRosenFileData
