/*
OuDiaSecond Copyright (C) 2017 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdPrintPageProp.h
// ****************************************************************
*/
/** @file */
#ifndef  CdPrintPageProp_h
#define  CdPrintPageProp_h

#include <string>
#include <tchar.h>
#include "Str\tstring.h"

namespace Print{

// ****************************************************************
//	CdPrintPageProp
// ****************************************************************
/**
 *	@brief
 *	yTvz  Pf[^NXłB
 *	  y[WɊւvpeBێ܂B
 *	
 *	  ƂāA
 *	- ]i㉺Ej
 *	ێ܂B
 */
class CdPrintPageProp
{
// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	 *	y[W̗]ij
	 *	Pʂ mm B
	 */
	double m_dMarginLeftMm ;
	/**
	 *	y[W̗]ij
	 *	Pʂ mm B
	 */
	double m_dMarginTopMm ;
	/**
	 *	y[W̗]iEj
	 *	Pʂ mm B
	 */
	double m_dMarginRightMm ;
	/**
	 *	y[W̗]ij
	 *	Pʂ mm B
	 */
	double m_dMarginBottomMm ;
	/**
	*	wb_[邩ۂ
	*/
	int m_iPrintHeader;
	/**
	*	tb^[邩ۂ
	*/
	int m_iPrintFooter;
///@}

// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 * @param dMarginLeftMm [in]
	 *	y[W̗]ij
	 *	Pʂ mm B
	 * @param dMarginTopMm [in]
	 *	y[W̗]ij
	 *	Pʂ mm B
	 * @param dMarginRightMm [in]
	 *	y[W̗]iEj
	 *	Pʂ mm B
	 * @param dMarginBottomMm [in]
	 *	y[W̗]ij
	 *	Pʂ mm B
	 * @param iPrintHeader [in]
	 *	wb_[邩ۂ
	 * @param iPrintFooter [in]
	 *	tb^[邩ۂ
	 */
	CdPrintPageProp( 
		double dMarginLeftMm ,
		double dMarginTopMm ,
		double dMarginRightMm ,
		double dMarginBottomMm,
		int iPrintHeader,
		int iPrintFooter) :
		m_dMarginLeftMm( dMarginLeftMm ),
		m_dMarginTopMm( dMarginTopMm ),
		m_dMarginRightMm( dMarginRightMm ),
		m_dMarginBottomMm( dMarginBottomMm ),
		m_iPrintHeader(iPrintHeader),
		m_iPrintFooter(iPrintFooter) {};

	CdPrintPageProp( ) :
		m_dMarginLeftMm( 0 ),
		m_dMarginTopMm( 0 ),
		m_dMarginRightMm( 0 ),
		m_dMarginBottomMm( 0 ),
		m_iPrintHeader(1),
		m_iPrintFooter(1) {};

// ********************************
//	CdPrintPageProp
// ********************************
 public:
	// ********************************
	///@name CdPrintPageProp-
	// ********************************
	///@{
	double getMarginLeftMm()const{ return m_dMarginLeftMm ;};
	CdPrintPageProp& setMarginLeftMm( double value ){
		m_dMarginLeftMm = value ; return *this ; } ;

	double getMarginTopMm()const{ return m_dMarginTopMm ;};
	CdPrintPageProp& setMarginTopMm( double value ){
		m_dMarginTopMm = value ; return *this ; } ;

	double getMarginRightMm()const{ 
		return m_dMarginRightMm ;};
	CdPrintPageProp& setMarginRightMm( double value ){
		m_dMarginRightMm = value ; return *this ; } ;

	double getMarginBottomMm()const{
		return m_dMarginBottomMm ;};
	CdPrintPageProp& setMarginBottomMm(double value) {
		m_dMarginBottomMm = value; return *this;};

	int getPrintHeader()const {
		return m_iPrintHeader;};
	CdPrintPageProp& setPrintHeader(int value ){
		m_iPrintHeader = value ; return *this ; } ;

	int getPrintFooter()const {
		return m_iPrintFooter;};
	CdPrintPageProp& setPrintFooter(int value) {
		m_iPrintFooter = value; return *this;};
	///@}
	// ********************************
	///@name CdPrintPageProp-
	// ********************************
	///@{
	/**
	 * @return
	 *	̃IuWFNgێĂ鑮𕶎񉻂܂B
	 */
	tstring encode() ;
	/**
	 *	encode() Ő߂āAthis̑ɔf܂B
	 * @param value [in]
	 *	encode() Őw肵ĂB
	 * @return 
	 *	 0 ȏAG[Ȃ畉̐łB
	 */
	int decode( const tstring& value ) ;
		
	/**
	 *	̃IuWFNg̑AftHgRXgN^
	 *	Ԃɖ߂܂B
	 */
	void clear(){	*this = CdPrintPageProp() ;};
		
};

} //namespace Print

#endif /*CdPrintPageProp_h*/
