/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CaDcdDiagram_PageSelector.cpp
// ****************************************************************
*/
#include "stdafx.h"
#include "CaDcdDiagram_PageSelector.h"

namespace ViewDiagram{

/**
  (␳Ώےl)APʂ̔{}(덷el) ȂA
  Ŋ̑Pʂ̔{x̒lɕ␳܂B

()iUnit=5,iAllowedDifference=1 ̏ꍇAvalueɑ΂錋ʂ͈ȉ̂ƂłB

@- value=3 Ȃ return=3
@- value=4 Ȃ return=5
@- value=5 Ȃ return=5
@- value=6 Ȃ return=5
@- value=7 Ȃ return=7


@param value [in]
	␳Ώےlw肵ĂB͈͂0ȏłB
@param iUnit [in]
	Pʂw肵ĂB͈͂1ȏłB
@param iAllowedDifference [in]
	덷el
@return
	␳ꂽlԂ܂B
*/
static int adjustForNearestUnit( int value , int iUnit , int iAllowedDifference ) 
{
	int iMod = value % iUnit ;

	if ( iMod == 0 )
	{
	}
	//␳PF(ݒl%P)(덷el) ȂA
	//@ݒl=ݒl-(ݒl%P)
	//
	//()
	//@P=1800
	//@ݒl=1801
	//@(덷el)=1
	//̏ꍇ
	//@(1801%1800)=1 (ݒl%P)
	//@1801-(1801%1800)=1800
	//
	else if ( iMod <= iAllowedDifference )
	{
		value = value - iMod ; 
	}

	//␳QF(ݒl%P)(P-덷el) ȂA
	//@ݒl=ݒl+(P-(ݒl%P))
	//
	//()
	//@P=1800
	//@ݒl=3599
	//@(덷el)=1
	//̏ꍇ
	//@(3599%1800)=1799 (ݒl%P)
	//@3599+(1800-(3599%1800))=3600
	else if ( iMod >= ( iUnit - iAllowedDifference ) )
	{
		value = value + ( iUnit - iMod ) ; 
	}
	return value ;
}

// ****************************************************************
//	CaDcdDiagram_PageSelector
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CaDcdDiagram_PageSelector::CaDcdDiagram_PageSelector( 
		CDcdDiagram2*	pCDcdDiagram2 ,
		const CdDcdSizeXy&	sizePage_Dgr ) 
{
	m_pCDcdDiagram2 = pCDcdDiagram2 ;
	m_sizePage_Dgr = sizePage_Dgr ;
	m_iXPage = 0 ;
	m_iYPage = 0 ;

	m_CconvContentPosToDcdTargetPrev = 
		*m_pCDcdDiagram2->getCconvContentPosToDcdTarget() ;
}


	
CaDcdDiagram_PageSelector::~CaDcdDiagram_PageSelector() 
{
	*m_pCDcdDiagram2->getCconvContentPosToDcdTarget() =
		m_CconvContentPosToDcdTargetPrev ;
}

// ********************************
//@name 	IfDcDraw
// ********************************
bool CaDcdDiagram_PageSelector::DcDraw( IfDcdTarget* pIfDcdTarget ) 
{
	CdDcdZoneXy	zonexyZone_Dgr = m_pCDcdDiagram2->getZone_Dgr( pIfDcdTarget ) ;
	//zonexyZone_Dgr=`s _COW͈̔
	
	// --------------------------------
	//	_COŜ̗̈(_COW)擾
	// --------------------------------
	CdDcdZoneXy	zonexyCentDcdDgrDia = 
		m_pCDcdDiagram2->getCentDedDgrDia()->getZone() ;
	if ( m_sizePage_Dgr.getX() > 0 )
	{
		zonexyCentDcdDgrDia.setX( 
			CdDcdZone( zonexyCentDcdDgrDia.getX().getPos() , 
				adjustForNearestUnit( zonexyCentDcdDgrDia.getX().getSize() , m_sizePage_Dgr.getX() , 1 ) ) ) ;
	}
	if ( m_sizePage_Dgr.getY() > 0 )
	{
		zonexyCentDcdDgrDia.setY( 
			CdDcdZone( zonexyCentDcdDgrDia.getY().getPos() , 
				adjustForNearestUnit( zonexyCentDcdDgrDia.getY().getSize() , m_sizePage_Dgr.getY() , 1 ) ) ) ;
	}
	//zonexyCentDcdDgrDia = _COŜ̗̈(_COW)
	//	APy[W̃TCY(_COW)ɋ߂ꍇ́A
	//	1y[W̃TCYƓɂ܂B
	//	݂ł́AӖȂȂĂ悤łB

	// --------------------------------


	zonexyZone_Dgr.setX( CdDcdZone( 
		zonexyCentDcdDgrDia.getX().getPos() + m_sizePage_Dgr.getX() * m_iXPage , 
		m_sizePage_Dgr.getX() ) )  ;
	zonexyZone_Dgr.setY( CdDcdZone( 
		zonexyCentDcdDgrDia.getY().getPos() + m_sizePage_Dgr.getY() * m_iYPage , 
		m_sizePage_Dgr.getY() ) )  ;
	m_pCDcdDiagram2->setZone_Dgr( pIfDcdTarget , zonexyZone_Dgr ) ;

	return m_pCDcdDiagram2->DcDraw( pIfDcdTarget ) ;
}
bool CaDcdDiagram_PageSelector::getItemSize( IfDcdTarget* pIfDcdTarget , 
							CdDcdSizeXy* pCdDcdSizeXy ) 
{
	CdDcdZoneXy	zonexyZone_Dgr = m_pCDcdDiagram2->getZone_Dgr( pIfDcdTarget ) ;
	//zonexyZone_Dgr=`s _COW͈̔
	//	(1y[Wɕ`悷_CO͈̔)

	// --------------------------------
	//	_COŜ̗̈(_COW)擾
	// --------------------------------
	CdDcdZoneXy	zonexyCentDcdDgrDia = 
		m_pCDcdDiagram2->getCentDedDgrDia()->getZone() ;
	if ( m_sizePage_Dgr.getX() > 0 )
	{
		zonexyCentDcdDgrDia.setX( 
			CdDcdZone( zonexyCentDcdDgrDia.getX().getPos() , 
				adjustForNearestUnit( zonexyCentDcdDgrDia.getX().getSize() , m_sizePage_Dgr.getX() , 1 ) ) ) ;
	}
	if ( m_sizePage_Dgr.getY() > 0 )
	{
		zonexyCentDcdDgrDia.setY( 
			CdDcdZone( zonexyCentDcdDgrDia.getY().getPos() , 
				adjustForNearestUnit( zonexyCentDcdDgrDia.getY().getSize() , m_sizePage_Dgr.getY() , 1 ) ) ) ;
	}
	//zonexyCentDcdDgrDia = _COŜ̗̈(_COW)
	//	APy[W̃TCY(_COW)ɋ߂ꍇ́A
	//	1y[W̃TCYƓɂ܂B
	//	݂ł́AӖȂȂĂ悤łB

	
	// --------------------------------

	zonexyZone_Dgr.setX( CdDcdZone( 
		zonexyCentDcdDgrDia.getX().getPos() + m_sizePage_Dgr.getX() * m_iXPage , 
		m_sizePage_Dgr.getX() ) )  ;
	zonexyZone_Dgr.setY( CdDcdZone( 
		zonexyCentDcdDgrDia.getY().getPos() + m_sizePage_Dgr.getY() * m_iYPage , 
		m_sizePage_Dgr.getY() ) )  ;

	m_pCDcdDiagram2->setZone_Dgr( pIfDcdTarget , zonexyZone_Dgr ) ;

	return m_pCDcdDiagram2->getItemSize( pIfDcdTarget , pCdDcdSizeXy ) ;
}

// ********************************
//	CaDcdDiagram_PageSelector
// ********************************


int CaDcdDiagram_PageSelector::getXPageCount() 
{
	int iRv = 0 ;

	// --------------------------------
	//	_COŜ̗̈(_COW)擾
	// --------------------------------
	CdDcdZoneXy	zonexyCentDcdDgrDia = 
		m_pCDcdDiagram2->getCentDedDgrDia()->getZone() ;
	if ( m_sizePage_Dgr.getX() > 0 )
	{
		zonexyCentDcdDgrDia.setX( 
			CdDcdZone( zonexyCentDcdDgrDia.getX().getPos() , 
				adjustForNearestUnit( zonexyCentDcdDgrDia.getX().getSize() , m_sizePage_Dgr.getX() , 1 ) ) ) ;
	}
	if ( m_sizePage_Dgr.getY() > 0 )
	{
		zonexyCentDcdDgrDia.setY( 
			CdDcdZone( zonexyCentDcdDgrDia.getY().getPos() , 
				adjustForNearestUnit( zonexyCentDcdDgrDia.getY().getSize() , m_sizePage_Dgr.getY() , 1 ) ) ) ;
	}
	//zonexyCentDcdDgrDia = _COŜ̗̈(_COW)
	//	APy[W̃TCY(_COW)ɋ߂ꍇ́A
	//	1y[W̃TCYƓɂ܂B
	//
	//yRz\Ȃy[WȂ悤ɂ邽߂łB
	//
	//yz
	//@EChETCY_COŜ̃TCY
	//	킸(PsNZ)ȂꍇB
	//		zonexyCentDcdDgrDia.m_Y.m_Size =10800
	//		m_sizePage_Dgr.m_Y.m_Size      =10799
	//	YɕKvȃy[WQƌvZĂ܂A
	//	2y[Wڂ͌ڏ󔒂ɂȂĂ܂܂B
	//
	//	ł́A
	//		zonexyCentDcdDgrDia.m_Y.m_Size  10799 
	//	ɕ␳邱ƂɂAYɕKvȃy[W
	//	PƌvZ邱Ƃł܂B
	
	// --------------------------------

	if ( m_sizePage_Dgr.getX() > 0 )
	{
		iRv = zonexyCentDcdDgrDia.getX().getSize() ;

		iRv += ( m_sizePage_Dgr.getX() - 1 ) ;
		iRv /= m_sizePage_Dgr.getX() ;
	}

	return ( iRv ) ;
	
}

int CaDcdDiagram_PageSelector::getYPageCount() 
{
	int iRv = 0 ;

	// --------------------------------
	//	_COŜ̗̈(_COW)擾
	// --------------------------------
	CdDcdZoneXy	zonexyCentDcdDgrDia = 
		m_pCDcdDiagram2->getCentDedDgrDia()->getZone() ;
	if ( m_sizePage_Dgr.getX() > 0 )
	{
		zonexyCentDcdDgrDia.setX( 
			CdDcdZone( zonexyCentDcdDgrDia.getX().getPos() , 
				adjustForNearestUnit( zonexyCentDcdDgrDia.getX().getSize() , m_sizePage_Dgr.getX() , 1 ) ) ) ;
	}
	if ( m_sizePage_Dgr.getY() > 0 )
	{
		zonexyCentDcdDgrDia.setY( 
			CdDcdZone( zonexyCentDcdDgrDia.getY().getPos() , 
				adjustForNearestUnit( zonexyCentDcdDgrDia.getY().getSize() , m_sizePage_Dgr.getY() , 1 ) ) ) ;
	}
	//zonexyCentDcdDgrDia = _COŜ̗̈(_COW)
	//	APy[W̃TCY(_COW)ɋ߂ꍇ́A
	//	1y[W̃TCYƓɂ܂B
	//yRz\Ȃy[WȂ悤ɂ邽߂łB
	//	getXPageCount()QƂĂB

	// --------------------------------


	if ( m_sizePage_Dgr.getY() > 0 )
	{
		iRv = zonexyCentDcdDgrDia.getY().getSize() ;

		iRv += ( m_sizePage_Dgr.getY() - 1 ) ;
		iRv /= m_sizePage_Dgr.getY() ;
	}
	return ( iRv ) ;
}

int CaDcdDiagram_PageSelector::getPageCount() 
{
	return getXPageCount() * getYPageCount() ;
}
	
	
int CaDcdDiagram_PageSelector::getXPage() 
{
	return m_iXPage ;
}

CaDcdDiagram_PageSelector& 
	CaDcdDiagram_PageSelector::setXPage( int value ) 
{
	if ( value == INT_MAX ){
		value = getXPageCount() - 1 ;
	}
	if ( value >= getXPageCount() - 1 ){
		value = getXPageCount() - 1 ;
	}
	if ( value < 0 ){
		value = 0 ;
	}
	m_iXPage = value ;
	return *this ;
}

int CaDcdDiagram_PageSelector::getYPage() 
{
	return m_iYPage ;
}

CaDcdDiagram_PageSelector& 
	CaDcdDiagram_PageSelector::setYPage( int value ) 
{
	if ( value == INT_MAX ){
		value = getYPageCount() - 1 ;
	}
	if ( value >= getYPageCount() - 1 ){
		value = getYPageCount() - 1 ;
	}
	if ( value < 0 ){
		value = 0 ;
	}
	m_iYPage = value ;
	return *this ;

}
int CaDcdDiagram_PageSelector::getPage() 
{
	return m_iXPage + m_iYPage * getXPageCount() ;
}


CaDcdDiagram_PageSelector& 
	CaDcdDiagram_PageSelector::setPage( int value ) 
{
	if ( value == INT_MAX ){
		value = getPageCount() - 1 ;
	}
	if ( value >= getPageCount() - 1 ){
		value = getPageCount() - 1 ;
	}
	if ( value < 0 ){
		value = 0 ;
	}
	int iXPage = value % getXPageCount() ;
	int iYPage = value / getXPageCount() ;
	setXPage( iXPage );
	setYPage( iYPage ) ;
	return *this ;
}
} //namespace ViewDiagram
