/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
// $Id: CdXColSpecCont.h 295 2016-06-11 05:14:13Z okm $
// ****************************************************************
/** @file */
#pragma once

#ifndef ViewJikokuhyou_CdXColSpecCont_h
#define ViewJikokuhyou_CdXColSpecCont_h

#include "NsMu\CMup_vector.h"

#include "ViewJikokuhyou\JikokuhyouColSpec\CdXColSpec.h"
#include "entDed\CentDedRessyaCont.h"


namespace ViewJikokuhyou{ namespace JikokuhyouColSpec{
	using namespace entDed;

/**
@brief
  \r[ CWndJikokuhyou ̊eԍƕ\ȇݕϊ
  @\񋟂܂B
  
  ̃NX́AɑSĂXɂĂ wԍ-\ex̑Ή\
ێ܂B ̑Ή\́A CentDedRessyaContECentDedRessya ɕύX
疳ɂȂ܂B̂߁ACentDedRessyaContECentDedRessya  ɕύX
\󋵂ł́AΉ\XVKv܂B

ygz

(1)  ftHgRXgN^ŃCX^X𐶐Ƃ́A scan() 
wԍ-\ex̑Ή\XVĂB

(2)  Ή\XV́AColumnNumberToSpec(),ColumnNumberFromSpec() ŁA
ԍƕ\ȇݕϊł܂B

*/
class CdXColSpecCont
{
private:
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	///@}

	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		ԕBscan() Ō܂܂B
	*/
	ERessyahoukou	m_eRessyahoukou ;

	/**
		Ԃ̐Bscan() Ō܂܂B
	*/
	int m_iRessyaCount ;

	/**
		Ԃ̐擪̗ԍB
		Ԃ̐0̏ꍇ́AԂǉԍɂȂ܂B
	*/
	int m_iColumnNumber_Ressya_begin ;

	/**
		Ԃ̏I[̎ʂ XԍBscan() Ō܂܂B

		m_iColumnNumber_Ressya_end = getColumnNumber_Ressya_begin() + Ԃ̐
	*/
	int m_iColumnNumber_Ressya_end ;

	///@}

	// ********************************
	///@name W
	// ********************************
	///@{
	/**
		iKł́AwԁxȊO̗vfi[܂B

		wԍ-\ex̑Ή\B
		CfNXԍɑ܂B
		vf\r[X񐔂ɑ܂B
	*/
	CMup_vector<CdXColSpec>	m_contColumnSpec ;
	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************
	/**
		scan() ƓłB
	@param pCentDedRessyaCont
		ԃReiB
		̃IuWFNǵA֐I͔jł܂B
	*/
	CdXColSpecCont( 
		const CentDedRessyaCont* pCentDedRessyaCont ) ;
	CdXColSpecCont() ;
 
public:
	// ********************************
	///@name CdXColSpec-֘A
	// ********************************
	///@{
	///@}
	// ********************************
	///@name CdXColSpec-
	// ********************************
	///@{
	ERessyahoukou	getRessyahoukou()const ;
	int getRessyaCount()const{	return m_iRessyaCount ;};
	int getColumnNumber_Ressya_begin()const ;
	int getColumnNumber_Ressya_end()const ;

	///@}
	// ********************************
	///@name CdXColSpecCont-
	// ********************************
	///@{
	/**
		ԃRei𑖍āA wԍ-\ex̑Ή\XV܂B
		this ܂ŕێĂeׂ͂Ď܂B 
	@param pCentDedRessyaCont
		ԃReiB
		̃IuWFNǵA֐I͔jł܂B
	*/
	void scan( 
		const CentDedRessyaCont* pCentDedRessyaCont ) ;


	/**
	@return 
		񐔂Ԃ܂B
	*/
	int size() ;

	/**
		ԍA\ׂe𓱏o܂B
	@param iXColumnNumber 
		ԍw肵ĂB
	@return
		\ׂeԂ܂B
		ԍȂꍇ́ANULLԂ̃IuWFNgԂ܂B

		߂l 
		CdXColSpec::m_eColumnType == 
		ColumnType_NewRessya ̏ꍇA
		CdXColSpec::m_iRessyaIndex ͗Ԗ{
		Ȃ܂B

		߂l 
		CdXColSpec::m_eColumnType  
		ColumnType_RessyałColumnType_NewRessya łȂꍇA
		CdXColSpec::m_iRessyaIndex = -1 ƂȂ܂B
	*/
	CdXColSpec ColumnNumberToSpec( 
		int iXColumnNumber ) ;

	/**
		\eɑ΂ԍ𓱏o܂B
	@param aCdXColSpec 
		\ew肵ĂB
	@return
		\ׂeԂ܂B
		ΉԍȂꍇ(\܂)́A-1Ԃ܂B
	*/
	int ColumnNumberFromSpec( 
		const CdXColSpec& aCdXColSpec ) ;


	/**
		wԍ-\ex̑Ή\폜܂B
	*/
	void clear() ;
	///@}
};

} } //namespace JikokuhyouColSpec namespace ViewJikokuhyou

#endif/* ViewJikokuhyou_CdXColSpecCont_h*/
