/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDedRessyaSoater_Transfer.h
// $Id: CDedRessyaSoater_Transfer.h 241 2016-01-05 06:14:33Z okm $
// ****************************************************************
*/
/** @file */
#ifndef  CDedRessyaSoater_Transfer_h
#define  CDedRessyaSoater_Transfer_h

#include "entDed\CentDedRosen.h"
#include "entDgr\CentDedDgrDia.h"
#include "IfProgress.h"

#include "entDed\CDedRessyaSoater.h"

namespace entDgr{

// ****************************************************************
//	CDedRessyaSoater_Transfer
// ****************************************************************
/**
@brief
	yTvz
	CentDedDia ̗Ԃ́wp\[gxsNXB
	
	ygz
	
	1.  RXgN^ŃIuWFNg𐶐A validate() Ăяo
	sĂB
@@
@@@this ́A CentDedRessyaDia ɑΉ CentDedDgrDia IuWFNgƁA
@@\[gΏۂ̗Ԃ̐莞ێ CentDedRessyaCont 𐶐܂B
	
	2.@sort() \bhĂяoƁAthiśAw肳ꂽԃReîׂĂ̗Ԃ\[g܂B

	3.  CentDedDia̗ԃRei̗Ԃ̓eωAthis ̓e͖ɂȂ܂
	@(1{̗Ԃ1w̉wωŁAthis̓e͖ɂȂ܂)B
	@̏ꍇ́Ainvalidate() ĂяoĈU this A
	 ēx validate() ĂяoāAthis̓eXVȂĂ͂Ȃ܂B

*/
class CDedRessyaSoater_Transfer : public CDedRessyaSoater
{
private:
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	/**
		\[g̑ΏۂƂȂԂW񂷂HIuWFNgB
	*/
	const CentDedRosen* m_pDedRosen ;

	/**
		\[g̑ΏۂƂȂԂW񂷂_CB
	*/
	const CentDedDia* m_pDedDia ;

	///@}
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		\[gΏۂ wOrderB
	*/
	CdDedJikokuOrder  m_JikokuOrder ;  



	///@}
	// ********************************
	///@name W
	// ********************************
	///@{
	/**
		\[g̑ΏۂƂȂ_C̃IuWFNgB
		validate() ŁAm_pDedRosen m_pDedDia 
		e𔽉f܂B
	*/
	CentDedDgrDia m_CentDedDgrDia ;

	///@}

	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		validate() ŏĂ invalidate() Ŕj܂ł true B
	*/
	bool	m_bIsValid ;
	///@}
protected:
	// --------------------------------
	///@name ֐
	// --------------------------------
	///@{
	/**
		w肳ꂽׂẴ\[gOԂɑ΂āA
		uw̉wOrderŁA\[gԂ\[gOԂɏ抷łv
		\[gԂT܂B

		̂悤ȑgݍ킹A
		\[gOԂ̗Index폜A
		\[gԂ̌Ɉړ܂B
	@param pEstimateRessyaCont[in]
		\[gΏۂ̗ԂێReiB
		̗Ԃ́ACentDedDgrDia::createEstimateRessya2()ɂ
		莞ǉꂽԂłȂĂ͂Ȃ܂B
	@param pcontRessyaIndexBeforeSort [in,out] 
		\[gOԂ̃CfNX̔z
	@param pcontRessyaIndexAfterSort[in,out] 
		\[gԂ̃CfNX̔z
	@param iEkiOrder[in]
		抷w̉wOrder w肵ĂB
	@param pIfProgress [in]
		iԂ̒ʒm󂯂ꍇ́AiԒʒm󂯎
		CX^Xւ̃|C^w肵ĂB
		NULLȂÅ֐͐iԂ̒ʒms܂B
	@param iMaxTransferSec[in]
		ő抷(b)w肵ĂB
		INT_MAXw肷ƁAłB
	@return
		true: fv܂B
	*/
	bool sortRessyaIndex_TransferFromSortedRessyaAtEki( 
		const CentDedRessyaCont* pEstimateRessyaCont ,
		std::vector<int>* pcontRessyaIndexBeforeSort , 
		std::vector<int>* pcontRessyaIndexAfterSort , 
		int iEkiOrder , 
		int iMaxTransferSec , 
		IfProgress* pIfProgress ) ;



	/**
		w肳ꂽׂẴ\[gOԂɑ΂āA
		uw̉wOrderŁA\[gOԂ\[gԂɏ抷łv
		\[gԂT܂B

		̂悤ȑgݍ킹A
		\[gOԂ̗Index폜A
		\[gԂ̑OɈړ܂B
	@param pEstimateRessyaCont[in]
		\[gΏۂ̗ԂێReiB
		̗Ԃ́ACentDedDgrDia::createEstimateRessya2()ɂ
		莞ǉꂽԂłȂĂ͂Ȃ܂B
	@param pcontRessyaIndexBeforeSort [in,out] 
		\[gOԂ̃CfNX̔z
	@param pcontRessyaIndexAfterSort[in,out] 
		\[gԂ̃CfNX̔z
	@param iEkiOrder[in]
		抷w̉wOrder w肵ĂB
	@param pIfProgress [in]
		iԂ̒ʒm󂯂ꍇ́AiԒʒm󂯎
		CX^Xւ̃|C^w肵ĂB
		NULLȂÅ֐͐iԂ̒ʒms܂B
	@param iMaxTransferSec[in]
		ő抷(b)w肵ĂB
		INT_MAXw肷ƁAłB
	@return
		true: fv܂B
	*/
	bool sortRessyaIndex_TransferToSortedRessyaAtEki( 
		const CentDedRessyaCont* pEstimateRessyaCont ,
		std::vector<int>* pcontRessyaIndexBeforeSort , 
		std::vector<int>* pcontRessyaIndexAfterSort , 
		int iEkiOrder , 
		int iMaxTransferSec , 
		IfProgress* pIfProgress ) ;



	/**
		w肳ꂽׂẴ\[gOԂɑ΂āA
		uw̉wOrderȌŁA\[gԂ\[gOԂɏ抷łv
		\[gԂׂĒT܂B

		̂悤ȑgݍ킹A
		\[gOԂ̗Index폜A
		\[gԂ̌Ɉړ܂B
	@param pEstimateRessyaCont[in]
		\[gΏۂ̗ԂێReiB
		̗Ԃ́ACentDedDgrDia::createEstimateRessya2()ɂ
		莞ǉꂽԂłȂĂ͂Ȃ܂B
	@param pcontRessyaIndexBeforeSort [in,out] 
		\[gOԂ̃CfNX̔z
	@param pcontRessyaIndexAfterSort[in,out] 
		\[gԂ̃CfNX̔z
	@param iEkijikokuOrder[in]
		\[g̃L[ƂȂAwOrder w肵ĂB
	@param pIfProgress [in]
		iԂ̒ʒm󂯂ꍇ́AiԒʒm󂯎
		CX^Xւ̃|C^w肵ĂB
		NULLȂÅ֐͐iԂ̒ʒms܂B
	@return
		true: fv܂B
	*/
	bool sortRessyaIndex_TransferFromSortedRessya( 
		const CentDedRessyaCont* pEstimateRessyaCont ,
		std::vector<int>* pcontRessyaIndexBeforeSort , 
		std::vector<int>* pcontRessyaIndexAfterSort , 
		CdDedJikokuOrder aEkijikokuOrder  , 
		IfProgress* pIfProgress ) ;

	/**
		w肳ꂽׂẴ\[gOԂɑ΂āA
		uw̉wOrderȑOŁA\[gOԂ\[gԂɏ抷łv
		\[gԂׂĒT܂B

		̂悤ȑgݍ킹A
		\[gOԂ̗Index폜A
		\[gԂ̑OɈړ܂B
	@param pEstimateRessyaCont[in]
		\[gΏۂ̗ԂێReiB
		̗Ԃ́ACentDedDgrDia::createEstimateRessya2()ɂ
		莞ǉꂽԂłȂĂ͂Ȃ܂B
	@param pcontRessyaIndexBeforeSort [in,out] 
		\[gOԂ̃CfNX̔z
	@param pcontRessyaIndexAfterSort[in,out] 
		\[gԂ̃CfNX̔z
	@param iEkijikokuOrder[in]
		\[g̃L[ƂȂAwOrder w肵ĂB
	@param pIfProgress [in]
		iԂ̒ʒm󂯂ꍇ́AiԒʒm󂯎
		CX^Xւ̃|C^w肵ĂB
		NULLȂÅ֐͐iԂ̒ʒms܂B
	@return
		true: fv܂B
	*/
	bool sortRessyaIndex_TransferToSortedRessya( 
		const CentDedRessyaCont* pEstimateRessyaCont ,
		std::vector<int>* pcontRessyaIndexBeforeSort , 
		std::vector<int>* pcontRessyaIndexAfterSort , 
		CdDedJikokuOrder aEkijikokuOrder , 
		IfProgress* pIfProgress ) ;
	///@}

	/**
		w2̉wƂ̊Ԃł̏芷ԂvZ܂B
	@param aEkijikokuFrom [in]
		芷̗Ԃ̉ww肵ĂB
	@param aEkijikokuTo [in]
		芷̗Ԃ̉ww肵ĂB
	@param jikokuKitenJikoku [in]
		_CON_w肵ĂB
		̊֐́A̎z芷͕s\Ƃ݂Ȃ܂B
		(F̎5:00w肳ꂽꍇ́A5:00<23:59<0:00<4:59 ƂĔrs܂)
	@return
		w2̉wƂ̊Ԃł̏芷(b)Ԃ܂B
		芷s\ȏꍇ -1 Ԃ܂B

		ȉ̏ꍇ͏芷s\ƂāA-1Ԃ܂B	
			- ǂ炩̉wuԁvłȂꍇB
	*/
	static int calcNorikaeSec( 
		const CentDedEkiJikoku& aEkiJikokuFrom , 
		const CentDedEkiJikoku& aEkiJikokuTo ,
		const CdDedJikoku& jikokuKitenJikoku ) ;
protected:
	// ================================
	///@name CDedRessyaSoater::sort ̉֐
	// ================================
	///@{
	/**
		w肳ꂽIndex\[g܂B
	@param pRessyaCont [in]
		\[gΏۂ̗ԃReiw肵ĂB
	@param muRessyaIndexOrder [in,out]
		\[gsIndexێReiw肵ĂB
		(FIndex0`4\[gꍇ́A
		{0,1,2,3,4} 5̗vfReiw肵ĂB
		̊֐͂̔zAwOrdeȓIndexɃ\[g܂B
	@param pIfProgress [in]
		iԂ̒ʒm󂯂ꍇ́AiԒʒm󂯎
		CX^Xւ̃|C^w肵ĂB
		NULLȂÅ֐͐iԂ̒ʒms܂B
	@note 
		̊֐œ\[gʂ
		sortWithSortedRessyaIndex() ɓnƂɂA
		ԃRei\[g邱Ƃł܂B

	*/
	virtual void sortRessyaIndex( 
		const CentDedRessyaCont* pRessyaCont , 
		Mui<int>* muRessyaIndexOrder , 
		IfProgress* pIfProgress )  ;
	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************
	/**
@	@param pDedRosen [in]
		\[g̑ΏۂƂȂԂW񂷂HIuWFNgB
	@param iDiaIndex [in]
		\[g̑ΏۂƂȂԂW񂷂_CB
	@param aCdDedJikokuOrder[in]
		\[gΏۂ wOrderB
	*/
	CDedRessyaSoater_Transfer(
		const CentDedRosen* pDedRosen , 
		const CentDedDia* pDedDia ,
		CdDedJikokuOrder  aCdDedJikokuOrder ) ;  

	virtual ~CDedRessyaSoater_Transfer() ;
	
public:
	// ********************************
	///@name CDedRessyaSoater_Transfer-
	// ********************************
	///@{
	///@}
	// ********************************
	///@name CDedRessyaSoater_Transfer-W
	// ********************************
	///@{
	///@}
	// ********************************
	///@name CDedRessyaSoater_Transfer--IfValidate
	// ********************************
	///@{
	/**
	 	@IuWFNg̏sAL܂B
	 	@ɂĕKvȃp[^́ARXgN^Ȃǂ
	 	w肵Ă
	 	Kv܂B
	 @return
	 	@LɐPȏA
	 	@łɗLIĂꍇ͂OA
	 	@G[̏ꍇ͕̐Ԃ܂B\n
	 	@Ƃ̂Pȏ̒l̈Ӗ́ANXRɒ`
	 	ł܂B\n
	 	@sƂ̐̈̕ӖANX`ł܂BɂA
	 	s̗RƂɈقȂG[lԂƂł܂B
	 	
	 */
	virtual int validate()  ;
	
	/**
	 	@IuWFNg𖳌܂B
	 	@LɊmۂ\[XJ܂B
	 	  LԂłȂIuWFNgɑ΂ẮAȂɂ܂B
	 */
	virtual void invalidate() ;
	
	/**
	 @return
	 	@݃IuWFNgLԂłΐ^Ԃ܂B
	 */
	virtual bool isValid() ;
	///@}



};

} //namespace entDgr


#endif /*CDedRessyaSoater_Transfer_h*/
