/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CEnumRessyasen.cpp
// $Id: CEnumRessyasen.cpp 94 2012-09-29 12:11:37Z okm $
// ****************************************************************
*/
#include "stdafx.h"
#include "CEnumRessyasen.h"
#include <chrono>

namespace entDgr{
	
// ****************************************************************
//	CEnumRessyasen
// ****************************************************************
	//*******************************
	//	RXgN^
	//*******************************
CEnumRessyasen::CEnumRessyasen( 
		const CentDedDgrDia* pCentDedDgrDia ,
		const CdDcdZoneXy& zonexyDgrZone ,
		bool bDisplayRessyasenKudari ,
		bool bDisplayRessyasenNobori ) :
	m_pCentDedDgrDia( pCentDedDgrDia ) ,
	m_zonexyDgrZone( zonexyDgrZone ) ,
	m_bDisplayRessyasenKudari( bDisplayRessyasenKudari ) ,
	m_bDisplayRessyasenNobori( bDisplayRessyasenNobori )
{
}
CEnumRessyasen::~CEnumRessyasen() 
{
}

	// --------------------------------
	//@name CEnumRessyasen
	// --------------------------------
void CEnumRessyasen::onCentDedDgrRessya( 
		ERessyahoukou eRessyahoukou ,
		int iRessyaIdx ,
		const CentDedDgrRessya* pCentDedDgrRessya ) 
{
	//	ΏۂƂȂ`̈A
	//	w_COGeBeBWnxŕێ܂B
	//	́A`s͈͂\Ă܂B
	CdDcdZoneXy	zonexyDgrZone = m_zonexyDgrZone ;

	const Mu<const CentDedDgrRessyasen*>* pMuCentDedDgrRessyasen = 
		pCentDedDgrRessya->getCentDedDgrRessyasenCont() ;
	for ( int iRessyasenIdx = 0 ; 
			iRessyasenIdx < pMuCentDedDgrRessyasen->size() ;
			iRessyasenIdx ++ )
	{
		// --------------------------------
		//	Ԑ̏
		// --------------------------------
		const CentDedDgrRessyasen*	pCentDedDgrRessyasen = 	
			pMuCentDedDgrRessyasen->get( iRessyasenIdx ) ;
		// --------------------------------
		//	Ԑ͂ދ`̈߂
		// --------------------------------
		CdDcdZoneXy	zonexyDgrRessyasen ;
		CdDcdPosXy	posRessyasenKiten ;
		CdDcdPosXy	posRessyasenSyuuten ; 
		{
			posRessyasenKiten = 
				m_pCentDedDgrDia->calcDgrPosRessyasenKiten( 
				pCentDedDgrRessya , pCentDedDgrRessyasen ) ;
			posRessyasenSyuuten = 
				m_pCentDedDgrDia->calcDgrPosRessyasenSyuuten( 
				pCentDedDgrRessya , pCentDedDgrRessyasen ) ;

			CdDcdZone	zoneDgrX ;
			zoneDgrX.setBeginEndPos( 
				posRessyasenKiten.getX() , 
				posRessyasenSyuuten.getX() ) ;
			CdDcdZone	zoneDgrY ;
			zoneDgrY.setBeginEndPos( 
				posRessyasenKiten.getY() ,
				posRessyasenSyuuten.getY() ) ;

			if ( !( zoneDgrX.getSize() == 0 && zoneDgrY.getSize() == 0 ) )
			{
				if ( zoneDgrX.getSize() == 0 )
				{
					//	n_ƏI_XW̏ꍇ()́AOIɕ1Ƃ܂
					//	(0ƂĂ܂ƁA`悳܂)
					zoneDgrX.setSize( 1 ) ;
				}
				if ( zoneDgrY.getSize() == 0 )
				{
					//	n_ƏI_YW̏ꍇ()́AOIɕ1Ƃ܂
					//	(0ƂĂ܂ƁA`悳܂)
					zoneDgrY.setSize( 1 ) ;
				}
			}

			zonexyDgrRessyasen.setX( zoneDgrX ).setY( zoneDgrY ) ;

		}


		CdDcdZoneXy	zonexyDgrRessyasenOnDgrZone = zonexyDgrZone.CrossZone( zonexyDgrRessyasen ) ;
		//zonexyDgrRessyasenOnDgrZone
		//	Ԑƕ`̈́Ä
		//	̒l̃TCY0ȂA̗Ԑ͕`\ȗ̈ɂ͂܂B


		if ( zonexyDgrRessyasenOnDgrZone.getX().getSize() > 0 && 
			zonexyDgrRessyasenOnDgrZone.getY().getSize() > 0 )
		{
			//	̗Ԑ́A`\ȉwԂɂ܂B
			onCentDedDgrRessyasen( 
				eRessyahoukou ,
				iRessyaIdx ,
				pCentDedDgrRessya ,
				iRessyasenIdx ,
				pCentDedDgrRessyasen ) ;
		}
	}
}

void CEnumRessyasen::onCentDedDgrRessyasen( 
		ERessyahoukou eRessyahoukou ,
		int iRessyaIdx ,
		const CentDedDgrRessya* pCentDedDgrRessya ,
		int iRessyasenIdx ,
		const CentDedDgrRessyasen* pCentDedDgrRessyasen ) 
{
	int iEkiOrderRessyasenKiten = pCentDedDgrRessyasen->getRessyasenKitenEkiOrder() ;
	int iEkiOrderRessyasenSyuuten = pCentDedDgrRessyasen->getRessyasenSyuutenEkiOrder() ;

	const Mu<const CentDedDgrEkiJikoku*>* pMuCentDedDgrEkiJikoku = 
		pCentDedDgrRessya->getMuCentDedDgrEkiJikoku() ;
	


	for ( int iEkiOrder = iEkiOrderRessyasenKiten ;
		iEkiOrder <= iEkiOrderRessyasenSyuuten ;
		iEkiOrder ++ )
	{
		auto p1 = std::chrono::system_clock::now();
		const CentDedDgrEkiJikoku* pCentDedDgrEkiJikoku = 
			pCentDedDgrRessya->getMuCentDedDgrEkiJikoku()->get( iEkiOrder ) ;
		onCentDedDgrEkiJikoku( 
			eRessyahoukou , 
			iRessyaIdx , 
			pCentDedDgrRessya ,
			iRessyasenIdx ,
			pCentDedDgrRessyasen ,
			iEkiOrder ,
			pCentDedDgrEkiJikoku ) ;
		auto p2 = std::chrono::system_clock::now();
		m_ds1 += std::chrono::duration_cast<std::chrono::milliseconds>(p2 - p1).count();
	}


}
void CEnumRessyasen::onCentDedDgrEkiJikoku( 
		ERessyahoukou eRessyahoukou ,
		int iRessyaIdx ,
		const CentDedDgrRessya* pCentDedDgrRessya ,
		int iRessyasenIdx ,
		const CentDedDgrRessyasen* pCentDedDgrRessyasen ,
		int iEkiOrder , 
		const CentDedDgrEkiJikoku* pCentDedDgrEkiJikoku ) 
{
}

	// ********************************
	//@name CEnumRessyasen-֘A
	// ********************************
const CentDedDgrDia*	CEnumRessyasen::getCentDedDgrDia()
{	
		return m_pCentDedDgrDia ; 
} ;
	// ********************************
	//@name CEnumRessyasen-
	// ********************************
CdDcdZoneXy	CEnumRessyasen::getDgrZone()
{
	return m_zonexyDgrZone ;
};

bool CEnumRessyasen::getDisplayRessyasen(  ERessyahoukou eRessyahoukou )const 
{
	bool bRv = false ;
	if ( eRessyahoukou == Ressyahoukou_Kudari ){
		bRv = m_bDisplayRessyasenKudari ;
	}	else if ( eRessyahoukou == Ressyahoukou_Nobori ) {
		bRv = m_bDisplayRessyasenNobori ;
	}
	return ( bRv ) ;
}
	// ********************************
	//@name CEnumRessyasen-
	// ********************************
void CEnumRessyasen::execute() 
{
	//	ΏۂƂȂ`̈A
	//	w_COGeBeBWnxŕێ܂B
	//	́A`s͈͂\Ă܂B
	CdDcdZoneXy	zonexyDgrZone = m_zonexyDgrZone ;


	//double s1 = 0.0;
	//double s2 = 0.0;
	//double s3 = 0.0;
	//m_ds1 = 0.0;
	//auto start = std::chrono::system_clock::now();
	for ( int iRessyahoukou = Ressyahoukou_Kudari ;
		iRessyahoukou <= Ressyahoukou_Nobori ;
		iRessyahoukou ++ )
	{
		// --------------------------------
		//	ԕ̏s邩ۂ̔
		// --------------------------------
		ERessyahoukou	eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
		if ( !getDisplayRessyasen( eRessyahoukou ) ) 
		{
			//	͍̏̕s܂B
			continue ;
		}
		// --------------------------------
		//	ԕ̏
		// --------------------------------
		const Mu<const CentDedDgrRessya*>*	pMuCentDedDgrRessya = 
			m_pCentDedDgrDia->getCentDedDgrRessyaCont( eRessyahoukou );
		int iSize = pMuCentDedDgrRessya->size();
#ifdef _OPENMP
#pragma omp parallel for schedule(guided)
#endif
		for (int iRessyaIdx = 0;
			iRessyaIdx < iSize;
			iRessyaIdx++)
			//for (int iRessyaIdx = 0;
			//	iRessyaIdx < pMuCentDedDgrRessya->size();
			//	iRessyaIdx++)
			{
				// --------------------------------
				//	Ԗ̏
				// --------------------------------
				const CentDedDgrRessya* pCentDedDgrRessya =
					pMuCentDedDgrRessya->get(iRessyaIdx);
				if (pCentDedDgrRessya->getIsNull() ||
					pCentDedDgrRessya->getCentDedDgrRessyasenCont()->size() <= 0)
				{
					//	NULLԁEԐ̑SȂԂ͑ΏۊO
					continue;
				}
				// --------------------------------

				CentDedDgrRessya	aCentDedDgrRessya(*pCentDedDgrRessya);
				//	Ԃ̍őDgrXW_CO
				//	[DgrXWɂȂ܂ŁA
				//	ԑŜDgrXW24ԂZB
				//
				//	̏́AԂ_CO[
				//	ׂłꍇɁAKvłB
				//	Ƃ΁A_CO̍[ 00:00:00
				//	ɂȂĂ_C̏ꍇA
				//	23:00  01:00 ɌđĂԂ
				//	-01:0001:00 
				//	 23:0025:00
				//	̂QӏɗԐ`悵ȂĂ͂Ȃ܂B
				//	̃[vł́AUԂ̎
				//	-25:00-23:00 
				//	ɂ܂B
				while (!(aCentDedDgrRessya.getDgrXZone().getEndPos() <
					zonexyDgrZone.getX().getPos()))
				{
					aCentDedDgrRessya.modifyDgrXPos(-CdDedJikoku::TOTALSECONDS_A_DAY);
				}

				//	ŁA24ԉZ܂BɂAԎ
				//	-01:0001:00 
				//	ƂȂ܂B
				aCentDedDgrRessya.modifyDgrXPos(+CdDedJikoku::TOTALSECONDS_A_DAY);

				auto p2 = std::chrono::system_clock::now();

				for (; aCentDedDgrRessya.getDgrXZone().getPos() <
					zonexyDgrZone.getX().getEndPos();
					aCentDedDgrRessya.modifyDgrXPos(+CdDedJikoku::TOTALSECONDS_A_DAY))
				{
					// --------------------------------
					//	Ԃ̕\ʒuiQSԊԊuj̏
					// --------------------------------
					CdDcdZone	zoneDgrXCross = zonexyDgrZone.getX().CrossZone(
						aCentDedDgrRessya.getDgrXZone());
					if (zoneDgrXCross.getSize() > 0)
					{
						auto p4 = std::chrono::system_clock::now();
						//	̗Ԃ́AΏۂƂȂ`̈ɂ܂B
						onCentDedDgrRessya(
							eRessyahoukou,
							iRessyaIdx,
							&aCentDedDgrRessya);
						//auto p5 = std::chrono::system_clock::now();
						//s3 += std::chrono::duration_cast<std::chrono::milliseconds>(p5 - p4).count();
					}
				}
				//auto p3 = std::chrono::system_clock::now();
				//s1 += std::chrono::duration_cast<std::chrono::milliseconds>(p2 - p1).count();
				//s2 += std::chrono::duration_cast<std::chrono::milliseconds>(p3 - p2).count();
			}
		
	}
	//auto end = std::chrono::system_clock::now();
	//double elapsed = std::chrono::duration_cast<std::chrono::milliseconds>(end-start).count();
	////double elapsed2 = std::chrono::duration_cast<std::chrono::milliseconds>(s2).count();
	//int a = 0;
};

} //namespace entDgr
