/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdTextboxV3.cpp
// ****************************************************************
*/
#include <deque>
#include "str\CStrCharSizeMb.h"
#include "NsMu\CMup_deque.h"
#include "logmsg\logmsg.h"
#include "DcDraw\CaDcdTargetItemPosition.h"
#include "DcDraw\CConverter_WinGdi.h"
#include "DcDraw\CVerticalTextElement.h"
#include "DcDraw\CVerticalTextElementBuilder.h"
#include "CDcdTextboxV3.h"
#include "str\strToWstr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace DcDrawLib{
namespace DcDraw{
	using namespace OuLib::Str ;
// ****************************************************************
//	CDcdTextboxV3
// ****************************************************************
// --------------------------------
//@name ֐
// --------------------------------

Ou<CGdiHFontHolder> CDcdTextboxV3::CreateVFont( 
		IfDcdTarget* pIfDcdTarget ,
		const CdFontProp& fontHorizontal ) 
{
	Ou<CGdiHFontHolder> pfontVertical ;
	{
		CdFontProp	aCdFontPropV = fontHorizontal ;
		aCdFontPropV.setIsEscapementVertical() ;
		pfontVertical = pIfDcdTarget->createGdiHFontHolder( aCdFontPropV ) ;
	}
	return ( pfontVertical ) ;
}

Ou<CGdiHFontHolder> CDcdTextboxV3::CreateHFont( 
		IfDcdTarget* pIfDcdTarget ,
		const CdFontProp& fontHorizontal ) 
{
	Ou<CGdiHFontHolder> pfontVertical ;
	{
		CdFontProp	aCdFontPropV = fontHorizontal ;
		aCdFontPropV.setIsEscapementHolyzontal() ;
		pfontVertical = pIfDcdTarget->createGdiHFontHolder( aCdFontPropV ) ;
	}
	return ( pfontVertical ) ;
}


CdDcdSizeXy CDcdTextboxV3::calcZenkakuCharExtent(
		IfDcdTarget* pIfDcdTarget , const CdFontProp& aCdFontProp ) 
{
	CdDcdSizeXy	sizeExtent ;
	{
		Ou<CGdiHFontHolder> pFontHolder = pIfDcdTarget->createGdiHFontHolder( aCdFontProp ) ;
		// --------------------------------
		HFONT hFontOld = (HFONT)SelectObject( 
			pIfDcdTarget->getHdc() , 
			pFontHolder->getHFont() ) ;
		TEXTMETRIC	aTEXTMETRIC ;
		GetTextMetrics( pIfDcdTarget->getHdc() , &aTEXTMETRIC ) ;

		//	TEXTMETRIC::tmMaxCharWidth ́AWindows7傫({ɂ)
		//	Windows7Windows10Ƃł́AGetTextMetrics() ֐ɂē 
		//	TEXTMETRIC::tmMaxCharWidth
		//	(https://msdn.microsoft.com/en-us/library/windows/desktop/dd145132(v=vs.85).aspx) 
		//	̒lقȂ܂B
		//	"lr SVbN" 9|Cg̃tHg̏ꍇATEXTMETRIC::tmMaxCharWidth ̒ĺA
		//	Windows7ł 13AWindows10 ł 24 ƂȂ܂B
		//	Windows10 24͗]ɂ傫܂B̂߁ÃTCY
		//	TEXTMETRIC.tmHeight ƂɌ߂邱Ƃɂ܂B
		
		//// ȑÕR[h
		//	sizeExtent.setX( aTEXTMETRIC.tmHeight ) ;
		//	sizeExtent.setY( aTEXTMETRIC.tmMaxCharWidth ) ;
		//	sizeExtent.setX( max( sizeExtent.getX() , sizeExtent.getY() ) ) ;
		//	sizeExtent.setY( sizeExtent.getX() ) ;

		sizeExtent.setX( aTEXTMETRIC.tmHeight ).setY( aTEXTMETRIC.tmHeight ) ;

		// --------------------------------
		if ( hFontOld != NULL ){
			SelectObject( pIfDcdTarget->getHdc() , hFontOld ) ;
		}
	}
	return sizeExtent ;
}


CDcdText CDcdTextboxV3::createCDcdTextH( 
		const CdFontProp&	aCdFontPropArg , 
		const CdColorProp& colorrefText ) 
{
	CdFontProp	aCdFontProp = aCdFontPropArg ;
	aCdFontProp.setIsEscapementHolyzontal() ;

	CDcdText	aCDcdText( 
		_T("") ,
		CdDrawTextProp( aCdFontProp , colorrefText ) , 
			_T("00") ) ;
	//	aCDcdText ́A㉺E񂹂ɂ܂B
	//	́ApP\ۂɁAɕ\邽߂łB
	{
		CdDrawTextProp	aCdDrawTextProp = aCDcdText.getCdDrawTextProp() ;
		aCdDrawTextProp.setCdDrawTextFormat( 
			CdDrawTextFormat(
				 CdDrawTextFormat::H_CENTER , 
				CdDrawTextFormat::V_SINGLELINT_CENTER 
			) 
		) ;
		aCDcdText.setCdDrawTextProp( aCdDrawTextProp ) ;
	}
	return aCDcdText ;
}


int CDcdTextboxV3::VerticalTextElementToElementPlace( 
		IfDcdTarget* pIfDcdTarget ,
		const CdFontProp& aCdFontProp ,
		const Mu<CVerticalTextElement>* pCStrElementCont ,
		Mui<CStrElementPlace>* pCStrElementPlaceCont ) 
{
	int iRv = 0 ;
	
	// --------------------------------
	CdDcdZoneXy	zonexyTarget = pIfDcdTarget->getZone() ;
	pCStrElementPlaceCont->erase( 0 , INT_MAX ) ;
	// --------------------------------
	//	tHg쐬
	// --------------------------------
	Ou<CGdiHFontHolder> fontVertical ; 
	Ou<CGdiHFontHolder> fontHolyzontal ; 
	{
		fontVertical = CreateVFont( 
			pIfDcdTarget , aCdFontProp ) ;
		fontHolyzontal = CreateHFont( 
			pIfDcdTarget , aCdFontProp ) ;
	}
	CDcdText aCDcdText( createCDcdTextH( 
				aCdFontProp , CdColorProp( 0 , 0 , 0 ) ) ) ;
	//aCDcdText = eLXgṕADcDrawIuWFNg
	// --------------------------------
	int logicalunitYOffset = 0 ;	//݂́ADcDraẅ㕔YW
	int iXLineNumber = 0 ;			//݂́AX̍sԍ
	
	int idxMojiretsuyousoCont ;
	for ( idxMojiretsuyousoCont = 0 ; 
			idxMojiretsuyousoCont < pCStrElementCont->size() ;){
		CVerticalTextElement	aCStrElement = 
			pCStrElementCont->get( idxMojiretsuyousoCont ) ;

		//	c(pESp)
		if ( aCStrElement.getType() == CVerticalTextElement::V_ZENKAKU || 
				aCStrElement.getType() == CVerticalTextElement::V_HANKAKU )
		{
			HFONT hFontOld = (HFONT)SelectObject( pIfDcdTarget->getHdc() , 
				fontVertical->getHFont() ) ;
			// --------------------------------
			//	̌s߂ɁA
			//	ނ̘Awx
			//	I[T܂B
			//	AAsɕ\łȂꍇ́A
			//	ł؂܂B
			// --------------------------------
			tstring strMojiretsu ;
			int idxMojiretsuyousoEnd = idxMojiretsuyousoCont ;
			int logicalunitYSize = 0 ;
			int iXLineWidth = 0 ;
			for ( idxMojiretsuyousoEnd = idxMojiretsuyousoCont ;
				idxMojiretsuyousoEnd < pCStrElementCont->size() ;
				idxMojiretsuyousoEnd ++ ){
				CVerticalTextElement	aCStrElementEnd = 
					pCStrElementCont->get( idxMojiretsuyousoEnd ) ;

				
				if ( aCStrElementEnd.getType() != 
						aCStrElement.getType() )
				{
					//	́wx́A idxMojiretsuyousoCont ̈ʒu
					//	wxƂ͎ނقȂ܂B
					break ;
				}


				tstring aString = strMojiretsu + 
					tstringOf(aCStrElementEnd.getString()) ;
				//stringŎ󂯎̂tstringɖ߂
				SIZE	aSize ;
				GetTextExtentPoint32( 
					pIfDcdTarget->getHdc() , 
					aString.c_str() , 
					(int)aString.size() , 
					&aSize ) ;
				//
				if ( logicalunitYOffset + aSize.cx <= 
						zonexyTarget.getY().getSize() || 
					( logicalunitYOffset == 0 && strMojiretsu.size() == 0 ) ){
					//	́̕A̍siiXLineNumber ̍sj
					//	\ł܂B
					//
					//	@s̐擪ɂ͕KPwx
					//	݂Kv܂B
					strMojiretsu = aString ;
					logicalunitYSize = aSize.cx ;
					iXLineWidth = aSize.cy ;
				}	else	{
					break ;
				}
			}
			//idxMojiretsuyousoEnd = wx̎̃CfNX
			//	wx݂̍siiXLineNumberjɈ`łȂ
			//	ꍇ́A
			//	idxMojiretsuyousoCont == idxMojiretsuyousoEnd ƂȂ܂B
			//strMojiretsu = ꂽʂ̕
			//logicalunitYSize = ꂽʂ́̕AỸTCY
			//	i_Pʁj


			if ( idxMojiretsuyousoCont == idxMojiretsuyousoEnd )
			{
				//	1\łȂꍇ́A
				//	̍sւ̕\݂܂B
				logicalunitYOffset = 0 ;
				iXLineNumber ++ ;
				continue ;
			}
			//	ʂƂɁACStrElementPlace IuWFNg𐶐A
			//	ReiɊi[܂B
			CStrElementPlace aCStrElementPlace( 
				CVerticalTextElement( stringOf(strMojiretsu) , aCStrElement.getType() ) ,
				logicalunitYOffset , iXLineNumber , iXLineWidth ) ;
			//tstringstringɂĂn
			pCStrElementPlaceCont->insert( aCStrElementPlace ) ;
			
			//݂́ADcDraẅ㕔YWAɐi߂
			logicalunitYOffset += logicalunitYSize ;

			idxMojiretsuyousoCont = idxMojiretsuyousoEnd ;
			// --------------------------------
			SelectObject( pIfDcdTarget->getHdc() , hFontOld ) ;
			hFontOld = NULL ;
		}
		//	
		else if ( aCStrElement.getType() == 
				CVerticalTextElement::H_HANKAKU )
		{
			// --------------------------------
			//	ނ̘Awx
			//	͍s܂B
			// --------------------------------
			tstring strMojiretsu ;
			int idxMojiretsuyousoEnd = idxMojiretsuyousoCont ;
			int logicalunitYSize = 0 ;
			int iXLineWidth = 0 ;
			{
				CVerticalTextElement	aCStrElementEnd = 
					pCStrElementCont->get( idxMojiretsuyousoEnd ) ;
				
				tstring aString = strMojiretsu + 
					tstringOf(aCStrElementEnd.getString()) ;
				aCDcdText.setText( aString ) ;
				CdDcdSizeXy aCdDcdSizeXy ;
				aCDcdText.getItemSize( pIfDcdTarget , &aCdDcdSizeXy ) ;

				if ( logicalunitYOffset + aCdDcdSizeXy.getY() <= 
						zonexyTarget.getY().getSize() || 
					( logicalunitYOffset == 0 && strMojiretsu.size() == 0 ) )
				{
					//	́̕A̍siiXLineNumber ̍sj
					//	\ł܂B
					//
					//	@s̐擪ɂ͕KPwx
					//	݂Kv܂B
					strMojiretsu = aString ;
					logicalunitYSize = aCdDcdSizeXy.getY() ;
					iXLineWidth = aCdDcdSizeXy.getX() ;
					idxMojiretsuyousoEnd ++ ;
				}
			}
			//idxMojiretsuyousoEnd = wx̎̃CfNX
			//	wx݂̍siiXLineNumberjɈ`łȂ
			//	ꍇ́A
			//	idxMojiretsuyousoCont == idxMojiretsuyousoEnd ƂȂ܂B
			//strMojiretsu = ꂽʂ̕
			//logicalunitYSize = ꂽʂ́̕AỸTCY
			//	i_Pʁj

			if ( idxMojiretsuyousoCont == idxMojiretsuyousoEnd )
			{
				//	1\łȂꍇ́A
				//	̍sւ̕\݂܂B
				logicalunitYOffset = 0 ;
				iXLineNumber ++ ;
				continue ;
			}
			CStrElementPlace aCStrElementPlace( 
				CVerticalTextElement( stringOf(strMojiretsu) , aCStrElement.getType() ) ,
				logicalunitYOffset , iXLineNumber , iXLineWidth ) ;
			pCStrElementPlaceCont->insert( aCStrElementPlace ) ;

			//݂́ADcDraẅ㕔YWAɐi߂
			logicalunitYOffset += logicalunitYSize ;

			idxMojiretsuyousoCont = idxMojiretsuyousoEnd ;
		}
	}
	
	//debug
	{
		CdDcdZoneXy	zonexyTarget = pIfDcdTarget->getZone() ;
		LogMsgL(3, _T("CDcdTextboxV3::MojiretsuyousoToMojiretsuyousoPlace")
			_T("(X.Pos=%d X.Size=%d Y.Pos=%d Y.Size=%d)") ,
			zonexyTarget.getX().getPos() , 
			zonexyTarget.getX().getSize() , 
			zonexyTarget.getY().getPos() , 
			zonexyTarget.getY().getSize() ) ;
		int idx ;
		for ( idx = 0 ; idx < pCStrElementPlaceCont->size() ; idx ++ ){
			CStrElementPlace aCStrElementPlace = 
				pCStrElementPlaceCont->get( idx ) ;
			LogMsgL(3, _T("\t[%d] \"%s\" %d iY=%d iX=%d iXLineWidth=%d") ,
				idx , 
				aCStrElementPlace.getCStrElement().getString().c_str() ,
				aCStrElementPlace.getCStrElement().getType() ,
				aCStrElementPlace.getYOffset() ,
				aCStrElementPlace.getXLineNumber() , 
				aCStrElementPlace.getXLineWidth() ) ;

		}
	}
	
	
	
	// --------------------------------
	return ( iRv ) ;
}

bool CDcdTextboxV3::DcDrawElementPlace( 
		IfDcdTarget* pIfDcdTarget ,
		const CdFontProp& aFontProp ,
		const CdColorProp&  colorTextColor , 
		const Mu<CStrElementPlace>* pCStrElementPlaceCont ) 
{
	bool bRv = false ;

	// --------------------------------
	CdDcdZoneXy	zonexyTarget = pIfDcdTarget->getZone() ;

	// --------------------------------
	//	tHg쐬
	// --------------------------------
	Ou<CGdiHFontHolder>  pfontVertical = CreateVFont( 
		pIfDcdTarget , 
		aFontProp ) ; 
	CdDcdSizeXy	sizeExtent = calcZenkakuCharExtent( pIfDcdTarget , aFontProp) ;
	//hFontVertical = c̃tHg
	//sizeExtent = eLXgSp{bNXP̃TCYB
	//	ATCY͐`ɂȂ悤ɍœK܂B
	//	܂AX,ŶA傫̕ӂɍ킹܂B
	
	CDcdText aCDcdText( createCDcdTextH( 
				aFontProp , colorTextColor ) ) ;
	//aCDcdText = eLXgṕADcDrawIuWFNg
	// --------------------------------
	int iLines = 1 ;
	if ( pCStrElementPlaceCont->size() > 0 ){
		iLines = pCStrElementPlaceCont->get( INT_MAX ).getXLineNumber() 
			+ 1 ;
	}
	//iLines = X̍s

	int iXOffset = 0 ;
	{
		iXOffset = 
			( zonexyTarget.getX().getSize() - iLines * sizeExtent.getX() ) 
			/ 2 ;
	}
	//iXOffset = m_strText ̕`́A[̍WB
	//	́AzonexyTarget.X.Pos ̃ItZbgł

	// --------------------------------
	//	`
	// --------------------------------
	for ( int idxCStrElementPlaceCont = 0 ;
			idxCStrElementPlaceCont < pCStrElementPlaceCont->size() ;
			idxCStrElementPlaceCont ++ ){
		CStrElementPlace	aCStrElementPlace = 
			pCStrElementPlaceCont->get( idxCStrElementPlaceCont ) ;
		CVerticalTextElement	aCStrElement = 
			aCStrElementPlace.getCStrElement() ;
		
		int iXPos = zonexyTarget.getX().getPos() + iXOffset + 
				( iLines - 1 - aCStrElementPlace.getXLineNumber() ) 
				* sizeExtent.getX() ;
		int iYPos = zonexyTarget.getY().getPos() + 
				aCStrElementPlace.getYOffset() ;
		tstring strChar = tstringOf(aCStrElement.getString()) ;
		
		if ( aCStrElement.getType() == CVerticalTextElement::V_ZENKAKU || 
				aCStrElement.getType() == CVerticalTextElement::V_HANKAKU )
		{
			// --------------------------------
			//	ctHg
			// --------------------------------
			HFONT hfontOld = (HFONT)SelectObject( pIfDcdTarget->getHdc() , 
				pfontVertical->getHFont() ) ;
			int iBkModeOld = SetBkMode( pIfDcdTarget->getHdc() , 
				TRANSPARENT ) ;
			CConverter_WinGdi	aConv ;
			COLORREF colTextColorOld = SetTextColor( 
				pIfDcdTarget->getHdc() , 
				aConv.COLORREFOf( colorTextColor ) ) ;
			// --------------------------------
			TextOut( pIfDcdTarget->getHdc() , 
				//	́{ṔAۂ̉ʂŒl
				iXPos + sizeExtent.getX() + 1 
					- ( sizeExtent.getX() - aCStrElementPlace.getXLineWidth() ) / 2 ,
				iYPos , 
				strChar.c_str() , 
				(int)strChar.size() ) ;
			// --------------------------------
			SetTextColor( pIfDcdTarget->getHdc() , colTextColorOld ) ;
			SetBkMode( pIfDcdTarget->getHdc() , iBkModeOld ) ;
			if ( hfontOld != NULL ){
				SelectObject( pIfDcdTarget->getHdc() , hfontOld ) ;
				hfontOld = NULL ;
			}
			bRv = true ;
		}	else if ( aCStrElement.getType() == 
				CVerticalTextElement::H_HANKAKU ){
			// --------------------------------
			//	tHg
			// --------------------------------
			CdDcdZoneXy	zoneChar( 
				CdDcdZone( iXPos, sizeExtent.getX() ) , 
				CdDcdZone( iYPos , sizeExtent.getY() ) ) ;
			aCDcdText.setText( strChar ) ;
			CaDcdTargetItemPosition	aTarget( pIfDcdTarget ,  zoneChar ) ;
			if ( aCDcdText.DcDraw( &aTarget ) ) {
				bRv = true ;
			}
		}
	}


	return ( bRv ) ;
}


// ********************************
//	RXgN^
// ********************************

CDcdTextboxV3::CDcdTextboxV3( 
		const tstring&			strText  ,
		const CdFontProp&	aCdFontProp  ,
		int						iLinesExtentX  ,
		int						iLinesExtentY  ,
		const CdColorProp&	colorrefText , 
		int						logicalunitFrameWidth   ,
		int						logicalunitFrameHeight   ,
		const CdPenProp&		aCdPenProp ,
		const CdBrushProp& 		aCdBrushProp ) 
	: m_CDcdFillrect( aCdBrushProp ) 
	, m_CDcdRectangle(  aCdPenProp ) 
	, m_strText( strText ) 
	, m_CdFontProp( aCdFontProp ) 
	, m_iLinesExtentX( iLinesExtentX )
	, m_iLinesExtentY( iLinesExtentY ) 
	, m_colorrefText( colorrefText ) 
	, m_logicalunitFrameWidth( logicalunitFrameWidth )
	, m_logicalunitFrameHeight( logicalunitFrameHeight )
{
}



CDcdTextboxV3::CDcdTextboxV3() 
	: m_iLinesExtentX ( 1 ) 
	, m_iLinesExtentY( 1 ) 
	, m_colorrefText( CdColorProp( 0 , 0 , 0 ) ) 
	, m_logicalunitFrameWidth( 0 )
	, m_logicalunitFrameHeight( 0 )
{
}
	
CDcdTextboxV3::~CDcdTextboxV3() 
{
}
// ********************************
//	IfDcDraw
// ********************************
bool CDcdTextboxV3::DcDraw( IfDcdTarget* pIfDcdTarget ) 
{
	bool	bRv = false ;

	// --------------------------------
	//	wiuV̕`
	// --------------------------------
	{
		if ( m_CDcdFillrect.DcDraw( pIfDcdTarget ) ) {
			bRv = true ;
		}
	}
	// --------------------------------
	//	g̕`
	// --------------------------------
	{
		if ( m_CDcdRectangle.DcDraw( pIfDcdTarget ) ) {
			bRv = true ;
		}
	}

	// ********************************
	//	eLXg̕`
	// ********************************
	CdDcdZoneXy	aCdDcdZoneXy ;
	{
		aCdDcdZoneXy = pIfDcdTarget->getZone() ;
		aCdDcdZoneXy.setX( CdDcdZone( 
			aCdDcdZoneXy.getX().getPos() + m_logicalunitFrameWidth , 
			aCdDcdZoneXy.getX().getSize() - m_logicalunitFrameWidth * 2 )
			)  ;
		aCdDcdZoneXy.setY( CdDcdZone( 
			aCdDcdZoneXy.getY().getPos() + m_logicalunitFrameHeight , 
			aCdDcdZoneXy.getY().getSize() - m_logicalunitFrameHeight * 2 )
			)  ;
	}
	//aCdDcdZoneXy = eLXg`悷̈łB
	//	IfDcdTargeẗ̗悩A㉺E̘g̈̈łB

	{
		CaDcdTargetItemPosition aCaDcdTargetItemPosition( 
			pIfDcdTarget , 
			aCdDcdZoneXy ) ;
		CMup_deque<CVerticalTextElement> aCStrElementCont ;

		CVerticalTextElementBuilder::scan( stringOf(m_strText) , &aCStrElementCont ,m_CdFontProp.isVerticalFacename()) ;

		CMup_deque<CStrElementPlace> aCStrElementPlaceCont ;
		VerticalTextElementToElementPlace( 
			&aCaDcdTargetItemPosition , 
			m_CdFontProp , 
			&aCStrElementCont , 
			&aCStrElementPlaceCont ) ;

		bRv = DcDrawElementPlace( 
			&aCaDcdTargetItemPosition , 
			m_CdFontProp , 
			m_colorrefText , 
			&aCStrElementPlaceCont ) ;
	}
	return ( bRv ) ;
}

	
bool CDcdTextboxV3::getItemSize( IfDcdTarget* pIfDcdTarget , 
							CdDcdSizeXy* pCdDcdSizeXy ) 
{
	bool bRv = false ;

	CdDcdSizeXy	sizeExtent = calcZenkakuCharExtent( pIfDcdTarget , m_CdFontProp ) ;

	pCdDcdSizeXy->setX( sizeExtent.getX() * m_iLinesExtentX + m_logicalunitFrameWidth * 2 ) ;
	pCdDcdSizeXy->setY( sizeExtent.getY() * m_iLinesExtentY + m_logicalunitFrameHeight * 2 ) ;
	return ( true ) ;
}

} //namespace DcDraw
} //namespace DcDrawLib

