/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/** @file */
// $Id: CConvTable.h 355 2016-08-18 16:41:28Z okm $
#ifndef OuLib_NsMu_CConvTable_h
#define OuLib_NsMu_CConvTable_h

#include <map>

namespace OuLib{
namespace NsMu{


/**
@brief
  Q̒l̕ϊ\NXłB

  ̃NX́AQ̒l̃yÃe[uێA̒lL[ɉE̒lE܂͂̋ts܂B
  
  ̃NXł́AyA2̒lꂼAleft,right ƌĂт܂B

<H4>
ygz
</H4>

1. ̃NX̃CX^X𐶐ĂB
  ev[gɂ́AleftAright ̌^w肵ĂB

2. add() ŁAl̃yAo^ĂB

3. rightFrom() ŁAleft ɑΉ right ̒l擾ł܂B܂AleftFrom() ŁAright ɑΉ left 擾ł܂B

  rightFrom() ́Ao^ left w肳ꂽꍇA m_bRightDefaultEnable UȂ΁ALException  throw ܂B
  m_bRightDefaultEnable ^ȂALException  throwArightFrom() ̖߂lƂ m_RightDefault Ԃ܂B
  ̐U镑́A leftFrom() lłB

  left ɓ̒l2ȏo^ꍇArightFrom() ̖߂lǂ̒lɂȂ͖̂`łB̐U镑́A leftFrom() lłB

@param TYPE_LEFT
	left ̌^w肵ĂB
@param TYPE_RIGHT
	right ̌^w肵ĂB

*/
template <class TYPE_LEFT , class TYPE_RIGHT >
class CConvTable
{
public:
	// ********************************
	//	Ci[^Cv
	// ********************************
	/**
		ΉlȂꍇɃX[OłB
	*/
	class LException
	{
	};
private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/** left  right ̃yAi[ReiłB */
	std::map<TYPE_LEFT,TYPE_RIGHT>	m_Map ;
	///@}
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	- false: left Ԃ֐ɂāAlȂꍇ LException  
		throw ܂B
	- true: left Ԃ֐ɂāAlȂꍇ LException  
		throw  m_LeftDefault Ԃ܂B
	*/
	bool m_bLeftDefaultEnable ;
	/** @see m_bLeftDefaultEnable */
	TYPE_LEFT	m_LeftDefault ;
	/**
	- false: right Ԃ֐ɂāAlȂꍇ LException  
		throw ܂B
	- true: right Ԃ֐ɂāAlȂꍇ LException  
		throw  m_RightDefault Ԃ܂B
	*/
	bool m_bRightDefaultEnable ;
	/** @see m_bRightDefaultEnable */
	TYPE_RIGHT	m_RightDefault ;
	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************
	CConvTable()
		: m_bLeftDefaultEnable( false ) 
		, m_bRightDefaultEnable( false ) 
	{
	}

public:
	// ********************************
	///@name	CConvTable - 
	// ********************************
	///@{
	void setLeftDefaultEnable( bool value ){	m_bLeftDefaultEnable = value ;}
	bool getLeftDefaultEnable()const{	return m_bLeftDefaultEnable ;}
	/** m_LeftDefault ݒ肵܂Bm_bLeftDefaultEnable true ɂȂ܂B*/
	CConvTable& setLeftDefault( const TYPE_LEFT& value )
	{
		m_LeftDefault = value ;
		m_bLeftDefaultEnable = true ;
		return *this ;
	}
	TYPE_LEFT getLeftDefault()const{	return m_LeftDefault ;}

	void setRightDefaultEnable( bool value ){	m_bRightDefaultEnable = value ;}
	bool getRightDefaultEnable()const{	return m_bRightDefaultEnable  ;}
	/** 
		m_RightDefault ݒ肵܂Bm_bRightDefaultEnable true ɂȂ܂B
	*/
	CConvTable& setRightDefault( const TYPE_RIGHT& value )
	{
		m_RightDefault = value ;
		m_bRightDefaultEnable = true ;
		return *this ;
	}
	TYPE_RIGHT getRightDefault()const{	return m_LeftDefault ;}
	///@}
public:
	// ********************************
	///@name	CConvTable - 
	// ********************************
	///@{
	/**
	@return
		o^ꂽl̃yA̐Ԃ܂B
	*/
	int size(){	return m_Map.size() ;}
	/**
		l̃yAǉ܂B
	@param left
		left ̒l
	@param rigth 
		rigth ̒l
	*/
	CConvTable& add( const TYPE_LEFT& left , const TYPE_RIGHT& right )
	{
		m_Map[left] = right ;	return *this ;
	}
	/**
		w肳ꂽ left ̒lɑΉ rigth Ԃ܂B
	@param left
		left w肵ĂB
	@return 
		Ή right ̒lԂ܂B

		left ϊłȂꍇ̋́A m_bRightDefaultEnable 
		B

	@see m_bRightDefaultEnable
	*/
	TYPE_RIGHT rightFrom( const TYPE_LEFT& left )const
	{
		TYPE_RIGHT	rv = m_RightDefault ;
		std::map< TYPE_LEFT , TYPE_RIGHT >::const_iterator ite = m_Map.find( left ) ;
		if ( ite != m_Map.end() )
		{
			rv = ite->second ;
		}
		else if ( !m_bRightDefaultEnable )
		{
			throw( LException() ) ;
		}
		return rv ;
	}
	/**
		w肳ꂽ right ̒lɑΉ left Ԃ܂B
	@param left
		right w肵ĂB
	@return 
		Ή left ̒lԂ܂B

		right ϊłȂꍇ̋́A m_bLeftDefaultEnable 
		B

	@see m_bLeftDefaultEnable
	*/
	TYPE_LEFT leftFrom( const TYPE_RIGHT& right )const 
	{
		TYPE_LEFT rv = m_LeftDefault ;
		std::map< TYPE_LEFT , TYPE_RIGHT >::const_iterator ite ;
		for ( ite = m_Map.begin() ; ite != m_Map.end() ; ite ++ )
		{
			if ( ite->second == right )
			{
				rv = ite->first ;
				break ;
			}
		}
		if ( ite == m_Map.end() )
		{
			if ( !m_bLeftDefaultEnable )
			{
				throw( LException() ) ;
			}
		}
		return rv ;
	}
	
	const std::map<TYPE_LEFT,TYPE_RIGHT>& getMap()const{  return m_Map ;}
	///@}
};

} //namespace NsMu
} //namespace OuLib


#endif //OuLib_NsMu_CConvTable_h
