/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CKeyinputSenderToModalDlg.cpp
// ****************************************************************
*/
#include "CKeyinputSenderToModalDlg.h"

namespace OuMfc{
namespace OuDlg{

// ****************************************************************
//	CKeyinputSenderToModalDlg
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CKeyinputSenderToModalDlg::CKeyinputSenderToModalDlg() :
		m_hwndControl( NULL ) ,
		m_bIsSend( false ) 
{
}

// ********************************
//	CKeyinputSenderToModalDlg
// ********************************
	// ********************************
	//@name w]EChEx̑
	// ********************************
bool CKeyinputSenderToModalDlg::
	OnKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags )
{
	bool bRv = false ;
	if ( m_bIsSend ){
		bRv = true ;
		MsgToPost	aMsg ;
		aMsg.Msg = WM_KEYDOWN ;
		aMsg.wParam = nChar ;
		aMsg.lParam = MAKELONG( nRepCnt , nFlags )  ;
		if ( m_hwndControl == NULL ){
			m_contmsgToSend.push_back( aMsg ) ;
		}	else	{
			PostMessage( m_hwndControl , aMsg.Msg , aMsg.wParam , 
				aMsg.lParam ) ;
		}
	}
	return bRv ;
}

bool CKeyinputSenderToModalDlg::
	OnKeyUp( UINT nChar, UINT nRepCnt, UINT nFlags )
{
	bool bRv = false ;
	if ( m_bIsSend ){
		bRv = true ;
		MsgToPost	aMsg ;
		aMsg.Msg = WM_KEYUP ;
		aMsg.wParam = nChar ;
		aMsg.lParam = MAKELONG( nRepCnt , nFlags )  ;
		if ( m_hwndControl == NULL ){
			m_contmsgToSend.push_back( aMsg ) ;
		}	else	{
			PostMessage( m_hwndControl , aMsg.Msg , aMsg.wParam , 
				aMsg.lParam ) ;
		}
	}
	return bRv ;
}


int CKeyinputSenderToModalDlg::startSend() 
{
	int iRv = 0 ;
	if ( iRv >=0 ){
		if ( m_bIsSend ){
			iRv = -1 ;	//	łɓ]łB
		}
	}
	if ( iRv >=0 ){
		m_bIsSend = true ;
	}
	return ( iRv ) ;
}

void CKeyinputSenderToModalDlg::endSend() 
{
	m_bIsSend = false ;
	m_hwndControl = NULL ;
	m_contmsgToSend.clear() ;
}
	// ********************************
	//@name w]_CAOx̑
	// ********************************
int CKeyinputSenderToModalDlg::registerCtrl( HWND hwndControl ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		if ( !( m_bIsSend && m_hwndControl == NULL ) ){
			//	MłȂAłɁw]Rg[x
			//	o^ς݂ł
			iRv = -1 ;
		}
	}
	if ( iRv >= 0 ){
		m_hwndControl = hwndControl ;
		while ( m_contmsgToSend.size() > 0 ){
			MsgToPost	aMsg = m_contmsgToSend.front() ;
			m_contmsgToSend.pop_front() ;
			PostMessage( m_hwndControl , aMsg.Msg , aMsg.wParam , 
				aMsg.lParam ) ;
		}
	}
	return ( iRv ) ;
}
void CKeyinputSenderToModalDlg::unregisterCtrl() 
{
	m_hwndControl = NULL ;
}
	// ********************************
	//@name 
	// ********************************
bool CKeyinputSenderToModalDlg::isSend() 
{
	return ( m_bIsSend ) ;
}
HWND CKeyinputSenderToModalDlg::getControl() 
{
	return ( m_hwndControl ) ;
}

	// ********************************
	///@name 
	// ********************************
bool CKeyinputSenderToModalDlg::AnyLetterOrDigitKeyIsDown()
{
	//	ANZ[^L[ɂ
	//	j[R}hNWQȂ悤ɁA
	//	ALTL[CTRLL[ĂƂ́A
	//	_CAONĂ܂B
	//	Aۂɂ̓ANZ[^L[̋@\
	//	EChE OnKeyDown() D悳邽߁A
	//	̔͌ɂ͕Kv܂B

	//ALT
	{
		SHORT	iResult = GetKeyState( VK_MENU ) ;
		if ( iResult < 0 ){
			return false ;
		}
	}
	//CTRL
	{
		SHORT	iResult = GetKeyState( VK_CONTROL ) ;
		if ( iResult < 0 ){
			return false ;
		}
	}

	// --------------------------------
	int iCount = 0 ;
	//	At@xbgL[̐
	int iKeycode ;
	for ( iKeycode = '0' ; iKeycode <= '9' ; iKeycode ++ ){
		SHORT	iResult = GetKeyState( iKeycode ) ;
		if ( iResult < 0 ){
			iCount ++ ;
		}
	}
	//	At@xbgL[(啶ȄꍇA
	//	̏ɊY܂)
	for ( iKeycode = 'A' ; iKeycode <= 'Z' ; iKeycode ++ ){
		SHORT	iResult = GetKeyState( iKeycode ) ;
		if ( iResult < 0 ){
			iCount ++ ;
		}
	}
	//	eL[ 0x60`0x69܂łł
	for ( iKeycode = 0x60 ; iKeycode <= 0x69 ; iKeycode ++ ){
		SHORT	iResult = GetKeyState( iKeycode ) ;
		if ( iResult < 0 ){
			iCount ++ ;
		}
	}

	return ( iCount == 1 );
}

} //namespace OuDlg
} //namespace OuMfc
